# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Inventory Updates

    The Selling Partner API for Direct Fulfillment Inventory Updates provides programmatic access to a direct fulfillment vendor's inventory updates.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from spapi.api_client import ApiClient


class UpdateInventoryApi(object):
    """NOTE: This class is auto generated by the openapi generator.

    Do not edit the class manually.
    """

    api_models_module = "spapi.models.vendor_direct_fulfillment_inventory_v1"

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.classFileName = 'update_inventory_api'

    def submit_inventory_update(self, warehouse_id, body, **kwargs):  # noqa: E501
        """submit_inventory_update  # noqa: E501

        Submits inventory updates for the specified warehouse for either a partial or full feed of inventory items.  **Usage Plan:**  | Rate (requests per second) | Burst | | ---- | ---- | | 10 | 10 |  The `x-amzn-RateLimit-Limit` response header returns the usage plan rate limits that were applied to the requested operation, when available. The table above indicates the default rate and burst values for this operation. Selling partners whose business demands require higher throughput may see higher rate and burst values than those shown here. For more information, see [Usage Plans and Rate Limits in the Selling Partner API](https://developer-docs.amazon.com/sp-api/docs/usage-plans-and-rate-limits-in-the-sp-api).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.submit_inventory_update(warehouse_id, body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str warehouse_id: Identifier for the warehouse for which to update inventory. (required)
        :param SubmitInventoryUpdateRequest body: The request body containing the inventory update data to submit. (required)
        :return: SubmitInventoryUpdateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.submit_inventory_update_with_http_info(warehouse_id, body, **kwargs)  # noqa: E501
        else:
            (data) = self.submit_inventory_update_with_http_info(warehouse_id, body, **kwargs)  # noqa: E501
            return data

    def submit_inventory_update_with_http_info(self, warehouse_id, body, **kwargs):  # noqa: E501
        """submit_inventory_update  # noqa: E501

        Submits inventory updates for the specified warehouse for either a partial or full feed of inventory items.  **Usage Plan:**  | Rate (requests per second) | Burst | | ---- | ---- | | 10 | 10 |  The `x-amzn-RateLimit-Limit` response header returns the usage plan rate limits that were applied to the requested operation, when available. The table above indicates the default rate and burst values for this operation. Selling partners whose business demands require higher throughput may see higher rate and burst values than those shown here. For more information, see [Usage Plans and Rate Limits in the Selling Partner API](https://developer-docs.amazon.com/sp-api/docs/usage-plans-and-rate-limits-in-the-sp-api).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.submit_inventory_update_with_http_info(warehouse_id, body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str warehouse_id: Identifier for the warehouse for which to update inventory. (required)
        :param SubmitInventoryUpdateRequest body: The request body containing the inventory update data to submit. (required)
        :return: SubmitInventoryUpdateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['warehouse_id', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method submit_inventory_update" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'warehouse_id' is set
        if self.api_client.client_side_validation and ('warehouse_id' not in params or
                                                       params['warehouse_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `warehouse_id` when calling `submit_inventory_update`")  # noqa: E501
        # verify the required parameter 'body' is set
        if self.api_client.client_side_validation and ('body' not in params or
                                                       params['body'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `body` when calling `submit_inventory_update`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'warehouse_id' in params:
            path_params['warehouseId'] = params['warehouse_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/vendor/directFulfillment/inventory/v1/warehouses/{warehouseId}/items', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SubmitInventoryUpdateResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats, api_models_module=self.api_models_module)
