# coding: utf-8

"""
    Selling Partner API for A+ Content Management

    Use the A+ Content API to build applications that help selling partners add rich marketing content to their Amazon product detail pages. Selling partners can use A+ content to share their brand and product story, which helps buyers make informed purchasing decisions. Selling partners use content modules to add images and text.

    The version of the OpenAPI document: 2020-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class StandardSingleImageHighlightsModule(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'image': 'ImageComponent',
        'headline': 'TextComponent',
        'text_block1': 'StandardTextBlock',
        'text_block2': 'StandardTextBlock',
        'text_block3': 'StandardTextBlock',
        'bulleted_list_block': 'StandardHeaderTextListBlock',
    }

    attribute_map = {
        'image': 'image',
        'headline': 'headline',
        'text_block1': 'textBlock1',
        'text_block2': 'textBlock2',
        'text_block3': 'textBlock3',
        'bulleted_list_block': 'bulletedListBlock',
    }

    def __init__(self, image=None, headline=None, text_block1=None, text_block2=None, text_block3=None, bulleted_list_block=None, _configuration=None):  # noqa: E501
        """StandardSingleImageHighlightsModule - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._image = None
        self._headline = None
        self._text_block1 = None
        self._text_block2 = None
        self._text_block3 = None
        self._bulleted_list_block = None
        self.discriminator = None

        if image is not None:
            self.image = image
        if headline is not None:
            self.headline = headline
        if text_block1 is not None:
            self.text_block1 = text_block1
        if text_block2 is not None:
            self.text_block2 = text_block2
        if text_block3 is not None:
            self.text_block3 = text_block3
        if bulleted_list_block is not None:
            self.bulleted_list_block = bulleted_list_block

    @property
    def image(self):
        """Gets the image of this StandardSingleImageHighlightsModule.  # noqa: E501


        :return: The image of this StandardSingleImageHighlightsModule.  # noqa: E501
        :rtype: ImageComponent
        """
        return self._image

    @image.setter
    def image(self, image):
        """Sets the image of this StandardSingleImageHighlightsModule.


        :param image: The image of this StandardSingleImageHighlightsModule.  # noqa: E501
        :type: ImageComponent
        """

        self._image = image

    @property
    def headline(self):
        """Gets the headline of this StandardSingleImageHighlightsModule.  # noqa: E501


        :return: The headline of this StandardSingleImageHighlightsModule.  # noqa: E501
        :rtype: TextComponent
        """
        return self._headline

    @headline.setter
    def headline(self, headline):
        """Sets the headline of this StandardSingleImageHighlightsModule.


        :param headline: The headline of this StandardSingleImageHighlightsModule.  # noqa: E501
        :type: TextComponent
        """

        self._headline = headline

    @property
    def text_block1(self):
        """Gets the text_block1 of this StandardSingleImageHighlightsModule.  # noqa: E501


        :return: The text_block1 of this StandardSingleImageHighlightsModule.  # noqa: E501
        :rtype: StandardTextBlock
        """
        return self._text_block1

    @text_block1.setter
    def text_block1(self, text_block1):
        """Sets the text_block1 of this StandardSingleImageHighlightsModule.


        :param text_block1: The text_block1 of this StandardSingleImageHighlightsModule.  # noqa: E501
        :type: StandardTextBlock
        """

        self._text_block1 = text_block1

    @property
    def text_block2(self):
        """Gets the text_block2 of this StandardSingleImageHighlightsModule.  # noqa: E501


        :return: The text_block2 of this StandardSingleImageHighlightsModule.  # noqa: E501
        :rtype: StandardTextBlock
        """
        return self._text_block2

    @text_block2.setter
    def text_block2(self, text_block2):
        """Sets the text_block2 of this StandardSingleImageHighlightsModule.


        :param text_block2: The text_block2 of this StandardSingleImageHighlightsModule.  # noqa: E501
        :type: StandardTextBlock
        """

        self._text_block2 = text_block2

    @property
    def text_block3(self):
        """Gets the text_block3 of this StandardSingleImageHighlightsModule.  # noqa: E501


        :return: The text_block3 of this StandardSingleImageHighlightsModule.  # noqa: E501
        :rtype: StandardTextBlock
        """
        return self._text_block3

    @text_block3.setter
    def text_block3(self, text_block3):
        """Sets the text_block3 of this StandardSingleImageHighlightsModule.


        :param text_block3: The text_block3 of this StandardSingleImageHighlightsModule.  # noqa: E501
        :type: StandardTextBlock
        """

        self._text_block3 = text_block3

    @property
    def bulleted_list_block(self):
        """Gets the bulleted_list_block of this StandardSingleImageHighlightsModule.  # noqa: E501


        :return: The bulleted_list_block of this StandardSingleImageHighlightsModule.  # noqa: E501
        :rtype: StandardHeaderTextListBlock
        """
        return self._bulleted_list_block

    @bulleted_list_block.setter
    def bulleted_list_block(self, bulleted_list_block):
        """Sets the bulleted_list_block of this StandardSingleImageHighlightsModule.


        :param bulleted_list_block: The bulleted_list_block of this StandardSingleImageHighlightsModule.  # noqa: E501
        :type: StandardHeaderTextListBlock
        """

        self._bulleted_list_block = bulleted_list_block

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(StandardSingleImageHighlightsModule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StandardSingleImageHighlightsModule):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StandardSingleImageHighlightsModule):
            return True

        return self.to_dict() != other.to_dict()
