# coding: utf-8

"""
    Selling Partner API for A+ Content Management

    Use the A+ Content API to build applications that help selling partners add rich marketing content to their Amazon product detail pages. Selling partners can use A+ content to share their brand and product story, which helps buyers make informed purchasing decisions. Selling partners use content modules to add images and text.

    The version of the OpenAPI document: 2020-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class TextComponent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'value': 'str',
        'decorator_set': 'List[Decorator]',
    }

    attribute_map = {
        'value': 'value',
        'decorator_set': 'decoratorSet',
    }

    def __init__(self, value=None, decorator_set=None, _configuration=None):  # noqa: E501
        """TextComponent - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._value = None
        self._decorator_set = None
        self.discriminator = None

        self.value = value
        if decorator_set is not None:
            self.decorator_set = decorator_set

    @property
    def value(self):
        """Gets the value of this TextComponent.  # noqa: E501

        The actual plain text.  # noqa: E501

        :return: The value of this TextComponent.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this TextComponent.

        The actual plain text.  # noqa: E501

        :param value: The value of this TextComponent.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                value is not None and len(value) > 10000):
            raise ValueError("Invalid value for `value`, length must be less than or equal to `10000`")  # noqa: E501
        if (self._configuration.client_side_validation and
                value is not None and len(value) < 1):
            raise ValueError("Invalid value for `value`, length must be greater than or equal to `1`")  # noqa: E501

        self._value = value

    @property
    def decorator_set(self):
        """Gets the decorator_set of this TextComponent.  # noqa: E501

        A set of content decorators.  # noqa: E501

        :return: The decorator_set of this TextComponent.  # noqa: E501
        :rtype: List[Decorator]
        """
        return self._decorator_set

    @decorator_set.setter
    def decorator_set(self, decorator_set):
        """Sets the decorator_set of this TextComponent.

        A set of content decorators.  # noqa: E501

        :param decorator_set: The decorator_set of this TextComponent.  # noqa: E501
        :type: List[Decorator]
        """

        self._decorator_set = decorator_set

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TextComponent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TextComponent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TextComponent):
            return True

        return self.to_dict() != other.to_dict()
