# coding: utf-8

"""
    The Selling Partner API for third party application integrations.

    With the AppIntegrations API v2024-04-01, you can send notifications to Amazon Selling Partners and display the notifications in Seller Central.

    The version of the OpenAPI document: 2024-04-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class RecordActionFeedbackRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'feedback_action_code': 'str',
    }

    attribute_map = {
        'feedback_action_code': 'feedbackActionCode',
    }

    def __init__(self, feedback_action_code=None, _configuration=None):  # noqa: E501
        """RecordActionFeedbackRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._feedback_action_code = None
        self.discriminator = None

        self.feedback_action_code = feedback_action_code

    @property
    def feedback_action_code(self):
        """Gets the feedback_action_code of this RecordActionFeedbackRequest.  # noqa: E501

        The unique identifier for each notification status.  # noqa: E501

        :return: The feedback_action_code of this RecordActionFeedbackRequest.  # noqa: E501
        :rtype: str
        """
        return self._feedback_action_code

    @feedback_action_code.setter
    def feedback_action_code(self, feedback_action_code):
        """Sets the feedback_action_code of this RecordActionFeedbackRequest.

        The unique identifier for each notification status.  # noqa: E501

        :param feedback_action_code: The feedback_action_code of this RecordActionFeedbackRequest.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and feedback_action_code is None:
            raise ValueError("Invalid value for `feedback_action_code`, must not be `None`")  # noqa: E501
        allowed_values = ["SELLER_ACTION_COMPLETED"]  # noqa: E501
        if (self._configuration.client_side_validation and
                feedback_action_code not in allowed_values):
            raise ValueError(
                "Invalid value for `feedback_action_code` ({0}), must be one of {1}"  # noqa: E501
                .format(feedback_action_code, allowed_values)
            )

        self._feedback_action_code = feedback_action_code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RecordActionFeedbackRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RecordActionFeedbackRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RecordActionFeedbackRequest):
            return True

        return self.to_dict() != other.to_dict()
