# coding: utf-8

"""
    The Selling Partner API for Amazon Warehousing and Distribution

    The Selling Partner API for Amazon Warehousing and Distribution (AWD) provides programmatic access to information about AWD shipments and inventory.

    The version of the OpenAPI document: 2024-05-09
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class PrepInstruction(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'prep_owner': 'PrepOwner',
        'prep_type': 'str',
    }

    attribute_map = {
        'prep_owner': 'prepOwner',
        'prep_type': 'prepType',
    }

    def __init__(self, prep_owner=None, prep_type=None, _configuration=None):  # noqa: E501
        """PrepInstruction - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._prep_owner = None
        self._prep_type = None
        self.discriminator = None

        if prep_owner is not None:
            self.prep_owner = prep_owner
        if prep_type is not None:
            self.prep_type = prep_type

    @property
    def prep_owner(self):
        """Gets the prep_owner of this PrepInstruction.  # noqa: E501


        :return: The prep_owner of this PrepInstruction.  # noqa: E501
        :rtype: PrepOwner
        """
        return self._prep_owner

    @prep_owner.setter
    def prep_owner(self, prep_owner):
        """Sets the prep_owner of this PrepInstruction.


        :param prep_owner: The prep_owner of this PrepInstruction.  # noqa: E501
        :type: PrepOwner
        """

        self._prep_owner = prep_owner

    @property
    def prep_type(self):
        """Gets the prep_type of this PrepInstruction.  # noqa: E501

        The type of preparation to be done. For more information about preparing items, refer to [Prep guidance](https://sellercentral.amazon.com/help/hub/reference/external/GF4G7547KSLDX2KC) on Seller Central.  # noqa: E501

        :return: The prep_type of this PrepInstruction.  # noqa: E501
        :rtype: str
        """
        return self._prep_type

    @prep_type.setter
    def prep_type(self, prep_type):
        """Sets the prep_type of this PrepInstruction.

        The type of preparation to be done. For more information about preparing items, refer to [Prep guidance](https://sellercentral.amazon.com/help/hub/reference/external/GF4G7547KSLDX2KC) on Seller Central.  # noqa: E501

        :param prep_type: The prep_type of this PrepInstruction.  # noqa: E501
        :type: str
        """

        self._prep_type = prep_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PrepInstruction, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PrepInstruction):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PrepInstruction):
            return True

        return self.to_dict() != other.to_dict()
