# coding: utf-8

"""
    Selling Partner API for Catalog Items

    Use the Selling Partner API for Catalog Items to retrieve information about items in the Amazon catalog.  For more information, refer to the [Catalog Items API Use Case Guide](https://developer-docs.amazon.com/sp-api/docs/:catalog-items-api-v2022-04-01-use-case-guide).

    The version of the OpenAPI document: 2022-04-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ItemSalesRanksByMarketplace(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'marketplace_id': 'str',
        'classification_ranks': 'List[ItemClassificationSalesRank]',
        'display_group_ranks': 'List[ItemDisplayGroupSalesRank]',
    }

    attribute_map = {
        'marketplace_id': 'marketplaceId',
        'classification_ranks': 'classificationRanks',
        'display_group_ranks': 'displayGroupRanks',
    }

    def __init__(self, marketplace_id=None, classification_ranks=None, display_group_ranks=None, _configuration=None):  # noqa: E501
        """ItemSalesRanksByMarketplace - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._marketplace_id = None
        self._classification_ranks = None
        self._display_group_ranks = None
        self.discriminator = None

        self.marketplace_id = marketplace_id
        if classification_ranks is not None:
            self.classification_ranks = classification_ranks
        if display_group_ranks is not None:
            self.display_group_ranks = display_group_ranks

    @property
    def marketplace_id(self):
        """Gets the marketplace_id of this ItemSalesRanksByMarketplace.  # noqa: E501

        Amazon marketplace identifier. To find the ID for your marketplace, refer to [Marketplace IDs](https://developer-docs.amazon.com/sp-api/docs/marketplace-ids).  # noqa: E501

        :return: The marketplace_id of this ItemSalesRanksByMarketplace.  # noqa: E501
        :rtype: str
        """
        return self._marketplace_id

    @marketplace_id.setter
    def marketplace_id(self, marketplace_id):
        """Sets the marketplace_id of this ItemSalesRanksByMarketplace.

        Amazon marketplace identifier. To find the ID for your marketplace, refer to [Marketplace IDs](https://developer-docs.amazon.com/sp-api/docs/marketplace-ids).  # noqa: E501

        :param marketplace_id: The marketplace_id of this ItemSalesRanksByMarketplace.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and marketplace_id is None:
            raise ValueError("Invalid value for `marketplace_id`, must not be `None`")  # noqa: E501

        self._marketplace_id = marketplace_id

    @property
    def classification_ranks(self):
        """Gets the classification_ranks of this ItemSalesRanksByMarketplace.  # noqa: E501

        Sales ranks of an Amazon catalog item for a `marketplaceId`, grouped by classification.  # noqa: E501

        :return: The classification_ranks of this ItemSalesRanksByMarketplace.  # noqa: E501
        :rtype: List[ItemClassificationSalesRank]
        """
        return self._classification_ranks

    @classification_ranks.setter
    def classification_ranks(self, classification_ranks):
        """Sets the classification_ranks of this ItemSalesRanksByMarketplace.

        Sales ranks of an Amazon catalog item for a `marketplaceId`, grouped by classification.  # noqa: E501

        :param classification_ranks: The classification_ranks of this ItemSalesRanksByMarketplace.  # noqa: E501
        :type: List[ItemClassificationSalesRank]
        """

        self._classification_ranks = classification_ranks

    @property
    def display_group_ranks(self):
        """Gets the display_group_ranks of this ItemSalesRanksByMarketplace.  # noqa: E501

        Sales ranks of an Amazon catalog item for a `marketplaceId`, grouped by website display group.  # noqa: E501

        :return: The display_group_ranks of this ItemSalesRanksByMarketplace.  # noqa: E501
        :rtype: List[ItemDisplayGroupSalesRank]
        """
        return self._display_group_ranks

    @display_group_ranks.setter
    def display_group_ranks(self, display_group_ranks):
        """Sets the display_group_ranks of this ItemSalesRanksByMarketplace.

        Sales ranks of an Amazon catalog item for a `marketplaceId`, grouped by website display group.  # noqa: E501

        :param display_group_ranks: The display_group_ranks of this ItemSalesRanksByMarketplace.  # noqa: E501
        :type: List[ItemDisplayGroupSalesRank]
        """

        self._display_group_ranks = display_group_ranks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ItemSalesRanksByMarketplace, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ItemSalesRanksByMarketplace):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ItemSalesRanksByMarketplace):
            return True

        return self.to_dict() != other.to_dict()
