# coding: utf-8

"""
    Selling Partner API for Easy Ship

    Use the Selling Partner API for Easy Ship to build applications for sellers to manage and ship Amazon Easy Ship orders. With this API, you can get available time slots, schedule and reschedule Easy Ship orders, and print shipping labels, invoices, and warranties. To review the differences in Easy Ship operations by marketplace, refer to [Marketplace support](https://developer-docs.amazon.com/sp-api/docs/easyship-api-v2022-03-23-use-case-guide#marketplace-support).

    The version of the OpenAPI document: 2022-03-23
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class Package(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'scheduled_package_id': 'ScheduledPackageId',
        'package_dimensions': 'Dimensions',
        'package_weight': 'Weight',
        'package_items': 'List[Item]',
        'package_time_slot': 'TimeSlot',
        'package_identifier': 'str',
        'invoice': 'InvoiceData',
        'package_status': 'PackageStatus',
        'tracking_details': 'TrackingDetails',
    }

    attribute_map = {
        'scheduled_package_id': 'scheduledPackageId',
        'package_dimensions': 'packageDimensions',
        'package_weight': 'packageWeight',
        'package_items': 'packageItems',
        'package_time_slot': 'packageTimeSlot',
        'package_identifier': 'packageIdentifier',
        'invoice': 'invoice',
        'package_status': 'packageStatus',
        'tracking_details': 'trackingDetails',
    }

    def __init__(self, scheduled_package_id=None, package_dimensions=None, package_weight=None, package_items=None, package_time_slot=None, package_identifier=None, invoice=None, package_status=None, tracking_details=None, _configuration=None):  # noqa: E501
        """Package - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._scheduled_package_id = None
        self._package_dimensions = None
        self._package_weight = None
        self._package_items = None
        self._package_time_slot = None
        self._package_identifier = None
        self._invoice = None
        self._package_status = None
        self._tracking_details = None
        self.discriminator = None

        self.scheduled_package_id = scheduled_package_id
        self.package_dimensions = package_dimensions
        self.package_weight = package_weight
        if package_items is not None:
            self.package_items = package_items
        self.package_time_slot = package_time_slot
        if package_identifier is not None:
            self.package_identifier = package_identifier
        if invoice is not None:
            self.invoice = invoice
        if package_status is not None:
            self.package_status = package_status
        if tracking_details is not None:
            self.tracking_details = tracking_details

    @property
    def scheduled_package_id(self):
        """Gets the scheduled_package_id of this Package.  # noqa: E501


        :return: The scheduled_package_id of this Package.  # noqa: E501
        :rtype: ScheduledPackageId
        """
        return self._scheduled_package_id

    @scheduled_package_id.setter
    def scheduled_package_id(self, scheduled_package_id):
        """Sets the scheduled_package_id of this Package.


        :param scheduled_package_id: The scheduled_package_id of this Package.  # noqa: E501
        :type: ScheduledPackageId
        """
        if self._configuration.client_side_validation and scheduled_package_id is None:
            raise ValueError("Invalid value for `scheduled_package_id`, must not be `None`")  # noqa: E501

        self._scheduled_package_id = scheduled_package_id

    @property
    def package_dimensions(self):
        """Gets the package_dimensions of this Package.  # noqa: E501


        :return: The package_dimensions of this Package.  # noqa: E501
        :rtype: Dimensions
        """
        return self._package_dimensions

    @package_dimensions.setter
    def package_dimensions(self, package_dimensions):
        """Sets the package_dimensions of this Package.


        :param package_dimensions: The package_dimensions of this Package.  # noqa: E501
        :type: Dimensions
        """
        if self._configuration.client_side_validation and package_dimensions is None:
            raise ValueError("Invalid value for `package_dimensions`, must not be `None`")  # noqa: E501

        self._package_dimensions = package_dimensions

    @property
    def package_weight(self):
        """Gets the package_weight of this Package.  # noqa: E501


        :return: The package_weight of this Package.  # noqa: E501
        :rtype: Weight
        """
        return self._package_weight

    @package_weight.setter
    def package_weight(self, package_weight):
        """Sets the package_weight of this Package.


        :param package_weight: The package_weight of this Package.  # noqa: E501
        :type: Weight
        """
        if self._configuration.client_side_validation and package_weight is None:
            raise ValueError("Invalid value for `package_weight`, must not be `None`")  # noqa: E501

        self._package_weight = package_weight

    @property
    def package_items(self):
        """Gets the package_items of this Package.  # noqa: E501

        A list of items contained in the package.  # noqa: E501

        :return: The package_items of this Package.  # noqa: E501
        :rtype: List[Item]
        """
        return self._package_items

    @package_items.setter
    def package_items(self, package_items):
        """Sets the package_items of this Package.

        A list of items contained in the package.  # noqa: E501

        :param package_items: The package_items of this Package.  # noqa: E501
        :type: List[Item]
        """
        if (self._configuration.client_side_validation and
                package_items is not None and len(package_items) > 500):
            raise ValueError("Invalid value for `package_items`, number of items must be less than or equal to `500`")  # noqa: E501

        self._package_items = package_items

    @property
    def package_time_slot(self):
        """Gets the package_time_slot of this Package.  # noqa: E501


        :return: The package_time_slot of this Package.  # noqa: E501
        :rtype: TimeSlot
        """
        return self._package_time_slot

    @package_time_slot.setter
    def package_time_slot(self, package_time_slot):
        """Sets the package_time_slot of this Package.


        :param package_time_slot: The package_time_slot of this Package.  # noqa: E501
        :type: TimeSlot
        """
        if self._configuration.client_side_validation and package_time_slot is None:
            raise ValueError("Invalid value for `package_time_slot`, must not be `None`")  # noqa: E501

        self._package_time_slot = package_time_slot

    @property
    def package_identifier(self):
        """Gets the package_identifier of this Package.  # noqa: E501

        Optional seller-created identifier that is printed on the shipping label to help the seller identify the package.  # noqa: E501

        :return: The package_identifier of this Package.  # noqa: E501
        :rtype: str
        """
        return self._package_identifier

    @package_identifier.setter
    def package_identifier(self, package_identifier):
        """Sets the package_identifier of this Package.

        Optional seller-created identifier that is printed on the shipping label to help the seller identify the package.  # noqa: E501

        :param package_identifier: The package_identifier of this Package.  # noqa: E501
        :type: str
        """

        self._package_identifier = package_identifier

    @property
    def invoice(self):
        """Gets the invoice of this Package.  # noqa: E501


        :return: The invoice of this Package.  # noqa: E501
        :rtype: InvoiceData
        """
        return self._invoice

    @invoice.setter
    def invoice(self, invoice):
        """Sets the invoice of this Package.


        :param invoice: The invoice of this Package.  # noqa: E501
        :type: InvoiceData
        """

        self._invoice = invoice

    @property
    def package_status(self):
        """Gets the package_status of this Package.  # noqa: E501


        :return: The package_status of this Package.  # noqa: E501
        :rtype: PackageStatus
        """
        return self._package_status

    @package_status.setter
    def package_status(self, package_status):
        """Sets the package_status of this Package.


        :param package_status: The package_status of this Package.  # noqa: E501
        :type: PackageStatus
        """

        self._package_status = package_status

    @property
    def tracking_details(self):
        """Gets the tracking_details of this Package.  # noqa: E501


        :return: The tracking_details of this Package.  # noqa: E501
        :rtype: TrackingDetails
        """
        return self._tracking_details

    @tracking_details.setter
    def tracking_details(self, tracking_details):
        """Sets the tracking_details of this Package.


        :param tracking_details: The tracking_details of this Package.  # noqa: E501
        :type: TrackingDetails
        """

        self._tracking_details = tracking_details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Package, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Package):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Package):
            return True

        return self.to_dict() != other.to_dict()
