# coding: utf-8

"""
    Selling Partner API for Easy Ship

    Use the Selling Partner API for Easy Ship to build applications for sellers to manage and ship Amazon Easy Ship orders. With this API, you can get available time slots, schedule and reschedule Easy Ship orders, and print shipping labels, invoices, and warranties. To review the differences in Easy Ship operations by marketplace, refer to [Marketplace support](https://developer-docs.amazon.com/sp-api/docs/easyship-api-v2022-03-23-use-case-guide#marketplace-support).

    The version of the OpenAPI document: 2022-03-23
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class UpdateScheduledPackagesRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'marketplace_id': 'str',
        'update_package_details_list': 'List[UpdatePackageDetails]',
    }

    attribute_map = {
        'marketplace_id': 'marketplaceId',
        'update_package_details_list': 'updatePackageDetailsList',
    }

    def __init__(self, marketplace_id=None, update_package_details_list=None, _configuration=None):  # noqa: E501
        """UpdateScheduledPackagesRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._marketplace_id = None
        self._update_package_details_list = None
        self.discriminator = None

        self.marketplace_id = marketplace_id
        self.update_package_details_list = update_package_details_list

    @property
    def marketplace_id(self):
        """Gets the marketplace_id of this UpdateScheduledPackagesRequest.  # noqa: E501

        A string of up to 255 characters.  # noqa: E501

        :return: The marketplace_id of this UpdateScheduledPackagesRequest.  # noqa: E501
        :rtype: str
        """
        return self._marketplace_id

    @marketplace_id.setter
    def marketplace_id(self, marketplace_id):
        """Sets the marketplace_id of this UpdateScheduledPackagesRequest.

        A string of up to 255 characters.  # noqa: E501

        :param marketplace_id: The marketplace_id of this UpdateScheduledPackagesRequest.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and marketplace_id is None:
            raise ValueError("Invalid value for `marketplace_id`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                marketplace_id is not None and len(marketplace_id) > 255):
            raise ValueError("Invalid value for `marketplace_id`, length must be less than or equal to `255`")  # noqa: E501
        if (self._configuration.client_side_validation and
                marketplace_id is not None and len(marketplace_id) < 1):
            raise ValueError("Invalid value for `marketplace_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._marketplace_id = marketplace_id

    @property
    def update_package_details_list(self):
        """Gets the update_package_details_list of this UpdateScheduledPackagesRequest.  # noqa: E501

        A list of package update details.  # noqa: E501

        :return: The update_package_details_list of this UpdateScheduledPackagesRequest.  # noqa: E501
        :rtype: List[UpdatePackageDetails]
        """
        return self._update_package_details_list

    @update_package_details_list.setter
    def update_package_details_list(self, update_package_details_list):
        """Sets the update_package_details_list of this UpdateScheduledPackagesRequest.

        A list of package update details.  # noqa: E501

        :param update_package_details_list: The update_package_details_list of this UpdateScheduledPackagesRequest.  # noqa: E501
        :type: List[UpdatePackageDetails]
        """
        if self._configuration.client_side_validation and update_package_details_list is None:
            raise ValueError("Invalid value for `update_package_details_list`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                update_package_details_list is not None and len(update_package_details_list) > 500):
            raise ValueError("Invalid value for `update_package_details_list`, number of items must be less than or equal to `500`")  # noqa: E501
        if (self._configuration.client_side_validation and
                update_package_details_list is not None and len(update_package_details_list) < 1):
            raise ValueError("Invalid value for `update_package_details_list`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._update_package_details_list = update_package_details_list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateScheduledPackagesRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateScheduledPackagesRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateScheduledPackagesRequest):
            return True

        return self.to_dict() != other.to_dict()
