# coding: utf-8

"""
    Selling Partner API for FBA Inventory

    The Selling Partner API for FBA Inventory lets you programmatically retrieve information about inventory in Amazon's fulfillment network.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class InventoryItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'seller_sku': 'str',
        'marketplace_id': 'str',
        'quantity': 'int',
    }

    attribute_map = {
        'seller_sku': 'sellerSku',
        'marketplace_id': 'marketplaceId',
        'quantity': 'quantity',
    }

    def __init__(self, seller_sku=None, marketplace_id=None, quantity=None, _configuration=None):  # noqa: E501
        """InventoryItem - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._seller_sku = None
        self._marketplace_id = None
        self._quantity = None
        self.discriminator = None

        self.seller_sku = seller_sku
        self.marketplace_id = marketplace_id
        self.quantity = quantity

    @property
    def seller_sku(self):
        """Gets the seller_sku of this InventoryItem.  # noqa: E501

        The seller SKU of the item.  # noqa: E501

        :return: The seller_sku of this InventoryItem.  # noqa: E501
        :rtype: str
        """
        return self._seller_sku

    @seller_sku.setter
    def seller_sku(self, seller_sku):
        """Sets the seller_sku of this InventoryItem.

        The seller SKU of the item.  # noqa: E501

        :param seller_sku: The seller_sku of this InventoryItem.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and seller_sku is None:
            raise ValueError("Invalid value for `seller_sku`, must not be `None`")  # noqa: E501

        self._seller_sku = seller_sku

    @property
    def marketplace_id(self):
        """Gets the marketplace_id of this InventoryItem.  # noqa: E501

        The marketplaceId.  # noqa: E501

        :return: The marketplace_id of this InventoryItem.  # noqa: E501
        :rtype: str
        """
        return self._marketplace_id

    @marketplace_id.setter
    def marketplace_id(self, marketplace_id):
        """Sets the marketplace_id of this InventoryItem.

        The marketplaceId.  # noqa: E501

        :param marketplace_id: The marketplace_id of this InventoryItem.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and marketplace_id is None:
            raise ValueError("Invalid value for `marketplace_id`, must not be `None`")  # noqa: E501

        self._marketplace_id = marketplace_id

    @property
    def quantity(self):
        """Gets the quantity of this InventoryItem.  # noqa: E501

        The quantity of item to add.  # noqa: E501

        :return: The quantity of this InventoryItem.  # noqa: E501
        :rtype: int
        """
        return self._quantity

    @quantity.setter
    def quantity(self, quantity):
        """Sets the quantity of this InventoryItem.

        The quantity of item to add.  # noqa: E501

        :param quantity: The quantity of this InventoryItem.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and quantity is None:
            raise ValueError("Invalid value for `quantity`, must not be `None`")  # noqa: E501

        self._quantity = quantity

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InventoryItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InventoryItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InventoryItem):
            return True

        return self.to_dict() != other.to_dict()
