# coding: utf-8

"""
    Selling Partner API for Finances

    The Selling Partner API for Finances helps you obtain financial information relevant to a seller's business. You can obtain financial events for a given order, financial event group, or date range without having to wait until a statement period closes. You can also obtain financial event groups for a given date range.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class CapacityReservationBillingEvent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'transaction_type': 'str',
        'posted_date': 'datetime',
        'description': 'str',
        'transaction_amount': 'Currency',
    }

    attribute_map = {
        'transaction_type': 'TransactionType',
        'posted_date': 'PostedDate',
        'description': 'Description',
        'transaction_amount': 'TransactionAmount',
    }

    def __init__(self, transaction_type=None, posted_date=None, description=None, transaction_amount=None, _configuration=None):  # noqa: E501
        """CapacityReservationBillingEvent - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._transaction_type = None
        self._posted_date = None
        self._description = None
        self._transaction_amount = None
        self.discriminator = None

        if transaction_type is not None:
            self.transaction_type = transaction_type
        if posted_date is not None:
            self.posted_date = posted_date
        if description is not None:
            self.description = description
        if transaction_amount is not None:
            self.transaction_amount = transaction_amount

    @property
    def transaction_type(self):
        """Gets the transaction_type of this CapacityReservationBillingEvent.  # noqa: E501

        Indicates the type of transaction. For example, FBA Inventory Fee  # noqa: E501

        :return: The transaction_type of this CapacityReservationBillingEvent.  # noqa: E501
        :rtype: str
        """
        return self._transaction_type

    @transaction_type.setter
    def transaction_type(self, transaction_type):
        """Sets the transaction_type of this CapacityReservationBillingEvent.

        Indicates the type of transaction. For example, FBA Inventory Fee  # noqa: E501

        :param transaction_type: The transaction_type of this CapacityReservationBillingEvent.  # noqa: E501
        :type: str
        """

        self._transaction_type = transaction_type

    @property
    def posted_date(self):
        """Gets the posted_date of this CapacityReservationBillingEvent.  # noqa: E501

        Fields with a schema type of date are in ISO 8601 date time format (for example GroupBeginDate).  # noqa: E501

        :return: The posted_date of this CapacityReservationBillingEvent.  # noqa: E501
        :rtype: datetime
        """
        return self._posted_date

    @posted_date.setter
    def posted_date(self, posted_date):
        """Sets the posted_date of this CapacityReservationBillingEvent.

        Fields with a schema type of date are in ISO 8601 date time format (for example GroupBeginDate).  # noqa: E501

        :param posted_date: The posted_date of this CapacityReservationBillingEvent.  # noqa: E501
        :type: datetime
        """

        self._posted_date = posted_date

    @property
    def description(self):
        """Gets the description of this CapacityReservationBillingEvent.  # noqa: E501

        A short description of the capacity reservation billing event.  # noqa: E501

        :return: The description of this CapacityReservationBillingEvent.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CapacityReservationBillingEvent.

        A short description of the capacity reservation billing event.  # noqa: E501

        :param description: The description of this CapacityReservationBillingEvent.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def transaction_amount(self):
        """Gets the transaction_amount of this CapacityReservationBillingEvent.  # noqa: E501


        :return: The transaction_amount of this CapacityReservationBillingEvent.  # noqa: E501
        :rtype: Currency
        """
        return self._transaction_amount

    @transaction_amount.setter
    def transaction_amount(self, transaction_amount):
        """Sets the transaction_amount of this CapacityReservationBillingEvent.


        :param transaction_amount: The transaction_amount of this CapacityReservationBillingEvent.  # noqa: E501
        :type: Currency
        """

        self._transaction_amount = transaction_amount

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CapacityReservationBillingEvent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CapacityReservationBillingEvent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CapacityReservationBillingEvent):
            return True

        return self.to_dict() != other.to_dict()
