# coding: utf-8

"""
    Selling Partner API for Finances

    The Selling Partner API for Finances helps you obtain financial information relevant to a seller's business. You can obtain financial events for a given order, financial event group, or date range without having to wait until a statement period closes. You can also obtain financial event groups for a given date range.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ChargeRefundEvent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'posted_date': 'datetime',
        'reason_code': 'str',
        'reason_code_description': 'str',
        'charge_refund_transactions': 'List[ChargeRefundTransaction]',
    }

    attribute_map = {
        'posted_date': 'PostedDate',
        'reason_code': 'ReasonCode',
        'reason_code_description': 'ReasonCodeDescription',
        'charge_refund_transactions': 'ChargeRefundTransactions',
    }

    def __init__(self, posted_date=None, reason_code=None, reason_code_description=None, charge_refund_transactions=None, _configuration=None):  # noqa: E501
        """ChargeRefundEvent - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._posted_date = None
        self._reason_code = None
        self._reason_code_description = None
        self._charge_refund_transactions = None
        self.discriminator = None

        if posted_date is not None:
            self.posted_date = posted_date
        if reason_code is not None:
            self.reason_code = reason_code
        if reason_code_description is not None:
            self.reason_code_description = reason_code_description
        if charge_refund_transactions is not None:
            self.charge_refund_transactions = charge_refund_transactions

    @property
    def posted_date(self):
        """Gets the posted_date of this ChargeRefundEvent.  # noqa: E501

        Fields with a schema type of date are in ISO 8601 date time format (for example GroupBeginDate).  # noqa: E501

        :return: The posted_date of this ChargeRefundEvent.  # noqa: E501
        :rtype: datetime
        """
        return self._posted_date

    @posted_date.setter
    def posted_date(self, posted_date):
        """Sets the posted_date of this ChargeRefundEvent.

        Fields with a schema type of date are in ISO 8601 date time format (for example GroupBeginDate).  # noqa: E501

        :param posted_date: The posted_date of this ChargeRefundEvent.  # noqa: E501
        :type: datetime
        """

        self._posted_date = posted_date

    @property
    def reason_code(self):
        """Gets the reason_code of this ChargeRefundEvent.  # noqa: E501

        The reason given for a charge refund.  Example: `SubscriptionFeeCorrection`  # noqa: E501

        :return: The reason_code of this ChargeRefundEvent.  # noqa: E501
        :rtype: str
        """
        return self._reason_code

    @reason_code.setter
    def reason_code(self, reason_code):
        """Sets the reason_code of this ChargeRefundEvent.

        The reason given for a charge refund.  Example: `SubscriptionFeeCorrection`  # noqa: E501

        :param reason_code: The reason_code of this ChargeRefundEvent.  # noqa: E501
        :type: str
        """

        self._reason_code = reason_code

    @property
    def reason_code_description(self):
        """Gets the reason_code_description of this ChargeRefundEvent.  # noqa: E501

        A description of the Reason Code.   Example: `SubscriptionFeeCorrection`  # noqa: E501

        :return: The reason_code_description of this ChargeRefundEvent.  # noqa: E501
        :rtype: str
        """
        return self._reason_code_description

    @reason_code_description.setter
    def reason_code_description(self, reason_code_description):
        """Sets the reason_code_description of this ChargeRefundEvent.

        A description of the Reason Code.   Example: `SubscriptionFeeCorrection`  # noqa: E501

        :param reason_code_description: The reason_code_description of this ChargeRefundEvent.  # noqa: E501
        :type: str
        """

        self._reason_code_description = reason_code_description

    @property
    def charge_refund_transactions(self):
        """Gets the charge_refund_transactions of this ChargeRefundEvent.  # noqa: E501

        A list of `ChargeRefund` transactions  # noqa: E501

        :return: The charge_refund_transactions of this ChargeRefundEvent.  # noqa: E501
        :rtype: List[ChargeRefundTransaction]
        """
        return self._charge_refund_transactions

    @charge_refund_transactions.setter
    def charge_refund_transactions(self, charge_refund_transactions):
        """Sets the charge_refund_transactions of this ChargeRefundEvent.

        A list of `ChargeRefund` transactions  # noqa: E501

        :param charge_refund_transactions: The charge_refund_transactions of this ChargeRefundEvent.  # noqa: E501
        :type: List[ChargeRefundTransaction]
        """

        self._charge_refund_transactions = charge_refund_transactions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChargeRefundEvent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChargeRefundEvent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ChargeRefundEvent):
            return True

        return self.to_dict() != other.to_dict()
