# coding: utf-8

"""
    Selling Partner API for Finances

    The Selling Partner API for Finances helps you obtain financial information relevant to a seller's business. You can obtain financial events for a given order, financial event group, or date range without having to wait until a statement period closes. You can also obtain financial event groups for a given date range.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ChargeRefundTransaction(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'charge_amount': 'Currency',
        'charge_type': 'str',
    }

    attribute_map = {
        'charge_amount': 'ChargeAmount',
        'charge_type': 'ChargeType',
    }

    def __init__(self, charge_amount=None, charge_type=None, _configuration=None):  # noqa: E501
        """ChargeRefundTransaction - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._charge_amount = None
        self._charge_type = None
        self.discriminator = None

        if charge_amount is not None:
            self.charge_amount = charge_amount
        if charge_type is not None:
            self.charge_type = charge_type

    @property
    def charge_amount(self):
        """Gets the charge_amount of this ChargeRefundTransaction.  # noqa: E501


        :return: The charge_amount of this ChargeRefundTransaction.  # noqa: E501
        :rtype: Currency
        """
        return self._charge_amount

    @charge_amount.setter
    def charge_amount(self, charge_amount):
        """Sets the charge_amount of this ChargeRefundTransaction.


        :param charge_amount: The charge_amount of this ChargeRefundTransaction.  # noqa: E501
        :type: Currency
        """

        self._charge_amount = charge_amount

    @property
    def charge_type(self):
        """Gets the charge_type of this ChargeRefundTransaction.  # noqa: E501

        The type of charge.  # noqa: E501

        :return: The charge_type of this ChargeRefundTransaction.  # noqa: E501
        :rtype: str
        """
        return self._charge_type

    @charge_type.setter
    def charge_type(self, charge_type):
        """Sets the charge_type of this ChargeRefundTransaction.

        The type of charge.  # noqa: E501

        :param charge_type: The charge_type of this ChargeRefundTransaction.  # noqa: E501
        :type: str
        """

        self._charge_type = charge_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChargeRefundTransaction, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChargeRefundTransaction):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ChargeRefundTransaction):
            return True

        return self.to_dict() != other.to_dict()
