# coding: utf-8

"""
    The Selling Partner API for Finances

    The Selling Partner API for Finances helps you obtain financial information relevant to a seller's business. You can obtain financial events for a given order or date range without having to wait until a statement period closes.

    The version of the OpenAPI document: 2024-06-19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class SellingPartnerMetadata(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'selling_partner_id': 'str',
        'account_type': 'str',
        'marketplace_id': 'str',
    }

    attribute_map = {
        'selling_partner_id': 'sellingPartnerId',
        'account_type': 'accountType',
        'marketplace_id': 'marketplaceId',
    }

    def __init__(self, selling_partner_id=None, account_type=None, marketplace_id=None, _configuration=None):  # noqa: E501
        """SellingPartnerMetadata - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._selling_partner_id = None
        self._account_type = None
        self._marketplace_id = None
        self.discriminator = None

        if selling_partner_id is not None:
            self.selling_partner_id = selling_partner_id
        if account_type is not None:
            self.account_type = account_type
        if marketplace_id is not None:
            self.marketplace_id = marketplace_id

    @property
    def selling_partner_id(self):
        """Gets the selling_partner_id of this SellingPartnerMetadata.  # noqa: E501

        Unique seller identifier.  # noqa: E501

        :return: The selling_partner_id of this SellingPartnerMetadata.  # noqa: E501
        :rtype: str
        """
        return self._selling_partner_id

    @selling_partner_id.setter
    def selling_partner_id(self, selling_partner_id):
        """Sets the selling_partner_id of this SellingPartnerMetadata.

        Unique seller identifier.  # noqa: E501

        :param selling_partner_id: The selling_partner_id of this SellingPartnerMetadata.  # noqa: E501
        :type: str
        """

        self._selling_partner_id = selling_partner_id

    @property
    def account_type(self):
        """Gets the account_type of this SellingPartnerMetadata.  # noqa: E501

        Account type of transaction.  # noqa: E501

        :return: The account_type of this SellingPartnerMetadata.  # noqa: E501
        :rtype: str
        """
        return self._account_type

    @account_type.setter
    def account_type(self, account_type):
        """Sets the account_type of this SellingPartnerMetadata.

        Account type of transaction.  # noqa: E501

        :param account_type: The account_type of this SellingPartnerMetadata.  # noqa: E501
        :type: str
        """

        self._account_type = account_type

    @property
    def marketplace_id(self):
        """Gets the marketplace_id of this SellingPartnerMetadata.  # noqa: E501

        Marketplace identifier of transaction.  # noqa: E501

        :return: The marketplace_id of this SellingPartnerMetadata.  # noqa: E501
        :rtype: str
        """
        return self._marketplace_id

    @marketplace_id.setter
    def marketplace_id(self, marketplace_id):
        """Sets the marketplace_id of this SellingPartnerMetadata.

        Marketplace identifier of transaction.  # noqa: E501

        :param marketplace_id: The marketplace_id of this SellingPartnerMetadata.  # noqa: E501
        :type: str
        """

        self._marketplace_id = marketplace_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SellingPartnerMetadata, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SellingPartnerMetadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SellingPartnerMetadata):
            return True

        return self.to_dict() != other.to_dict()
