# coding: utf-8

"""
    The Selling Partner API for FBA inbound operations.

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class Carrier(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'alpha_code': 'str',
        'name': 'str',
    }

    attribute_map = {
        'alpha_code': 'alphaCode',
        'name': 'name',
    }

    def __init__(self, alpha_code=None, name=None, _configuration=None):  # noqa: E501
        """Carrier - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._alpha_code = None
        self._name = None
        self.discriminator = None

        if alpha_code is not None:
            self.alpha_code = alpha_code
        if name is not None:
            self.name = name

    @property
    def alpha_code(self):
        """Gets the alpha_code of this Carrier.  # noqa: E501

        The carrier code. For example, USPS or DHLEX.  # noqa: E501

        :return: The alpha_code of this Carrier.  # noqa: E501
        :rtype: str
        """
        return self._alpha_code

    @alpha_code.setter
    def alpha_code(self, alpha_code):
        """Sets the alpha_code of this Carrier.

        The carrier code. For example, USPS or DHLEX.  # noqa: E501

        :param alpha_code: The alpha_code of this Carrier.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                alpha_code is not None and len(alpha_code) > 1024):
            raise ValueError("Invalid value for `alpha_code`, length must be less than or equal to `1024`")  # noqa: E501
        if (self._configuration.client_side_validation and
                alpha_code is not None and len(alpha_code) < 1):
            raise ValueError("Invalid value for `alpha_code`, length must be greater than or equal to `1`")  # noqa: E501

        self._alpha_code = alpha_code

    @property
    def name(self):
        """Gets the name of this Carrier.  # noqa: E501

        The name of the carrier.  # noqa: E501

        :return: The name of this Carrier.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Carrier.

        The name of the carrier.  # noqa: E501

        :param name: The name of this Carrier.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                name is not None and len(name) > 1024):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `1024`")  # noqa: E501
        if (self._configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Carrier, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Carrier):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Carrier):
            return True

        return self.to_dict() != other.to_dict()
