# coding: utf-8

"""
    The Selling Partner API for FBA inbound operations.

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GenerateShipmentContentUpdatePreviewsRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'boxes': 'List[BoxUpdateInput]',
        'items': 'List[ItemInput]',
    }

    attribute_map = {
        'boxes': 'boxes',
        'items': 'items',
    }

    def __init__(self, boxes=None, items=None, _configuration=None):  # noqa: E501
        """GenerateShipmentContentUpdatePreviewsRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._boxes = None
        self._items = None
        self.discriminator = None

        self.boxes = boxes
        self.items = items

    @property
    def boxes(self):
        """Gets the boxes of this GenerateShipmentContentUpdatePreviewsRequest.  # noqa: E501

        A list of boxes that will be present in the shipment after the update.  # noqa: E501

        :return: The boxes of this GenerateShipmentContentUpdatePreviewsRequest.  # noqa: E501
        :rtype: List[BoxUpdateInput]
        """
        return self._boxes

    @boxes.setter
    def boxes(self, boxes):
        """Sets the boxes of this GenerateShipmentContentUpdatePreviewsRequest.

        A list of boxes that will be present in the shipment after the update.  # noqa: E501

        :param boxes: The boxes of this GenerateShipmentContentUpdatePreviewsRequest.  # noqa: E501
        :type: List[BoxUpdateInput]
        """
        if self._configuration.client_side_validation and boxes is None:
            raise ValueError("Invalid value for `boxes`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                boxes is not None and len(boxes) > 5000):
            raise ValueError("Invalid value for `boxes`, number of items must be less than or equal to `5000`")  # noqa: E501
        if (self._configuration.client_side_validation and
                boxes is not None and len(boxes) < 1):
            raise ValueError("Invalid value for `boxes`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._boxes = boxes

    @property
    def items(self):
        """Gets the items of this GenerateShipmentContentUpdatePreviewsRequest.  # noqa: E501

        A list of all items that will be present in the shipment after the update.  # noqa: E501

        :return: The items of this GenerateShipmentContentUpdatePreviewsRequest.  # noqa: E501
        :rtype: List[ItemInput]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this GenerateShipmentContentUpdatePreviewsRequest.

        A list of all items that will be present in the shipment after the update.  # noqa: E501

        :param items: The items of this GenerateShipmentContentUpdatePreviewsRequest.  # noqa: E501
        :type: List[ItemInput]
        """
        if self._configuration.client_side_validation and items is None:
            raise ValueError("Invalid value for `items`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                items is not None and len(items) > 2000):
            raise ValueError("Invalid value for `items`, number of items must be less than or equal to `2000`")  # noqa: E501
        if (self._configuration.client_side_validation and
                items is not None and len(items) < 1):
            raise ValueError("Invalid value for `items`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._items = items

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GenerateShipmentContentUpdatePreviewsRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GenerateShipmentContentUpdatePreviewsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GenerateShipmentContentUpdatePreviewsRequest):
            return True

        return self.to_dict() != other.to_dict()
