# coding: utf-8

"""
    The Selling Partner API for FBA inbound operations.

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class InboundOperationStatus(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'operation': 'str',
        'operation_id': 'str',
        'operation_problems': 'List[OperationProblem]',
        'operation_status': 'OperationStatus',
    }

    attribute_map = {
        'operation': 'operation',
        'operation_id': 'operationId',
        'operation_problems': 'operationProblems',
        'operation_status': 'operationStatus',
    }

    def __init__(self, operation=None, operation_id=None, operation_problems=None, operation_status=None, _configuration=None):  # noqa: E501
        """InboundOperationStatus - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._operation = None
        self._operation_id = None
        self._operation_problems = None
        self._operation_status = None
        self.discriminator = None

        self.operation = operation
        self.operation_id = operation_id
        self.operation_problems = operation_problems
        self.operation_status = operation_status

    @property
    def operation(self):
        """Gets the operation of this InboundOperationStatus.  # noqa: E501

        The name of the operation in the asynchronous API call.  # noqa: E501

        :return: The operation of this InboundOperationStatus.  # noqa: E501
        :rtype: str
        """
        return self._operation

    @operation.setter
    def operation(self, operation):
        """Sets the operation of this InboundOperationStatus.

        The name of the operation in the asynchronous API call.  # noqa: E501

        :param operation: The operation of this InboundOperationStatus.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and operation is None:
            raise ValueError("Invalid value for `operation`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                operation is not None and len(operation) > 1024):
            raise ValueError("Invalid value for `operation`, length must be less than or equal to `1024`")  # noqa: E501
        if (self._configuration.client_side_validation and
                operation is not None and len(operation) < 1):
            raise ValueError("Invalid value for `operation`, length must be greater than or equal to `1`")  # noqa: E501

        self._operation = operation

    @property
    def operation_id(self):
        """Gets the operation_id of this InboundOperationStatus.  # noqa: E501

        The operation ID returned by the asynchronous API call.  # noqa: E501

        :return: The operation_id of this InboundOperationStatus.  # noqa: E501
        :rtype: str
        """
        return self._operation_id

    @operation_id.setter
    def operation_id(self, operation_id):
        """Sets the operation_id of this InboundOperationStatus.

        The operation ID returned by the asynchronous API call.  # noqa: E501

        :param operation_id: The operation_id of this InboundOperationStatus.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and operation_id is None:
            raise ValueError("Invalid value for `operation_id`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                operation_id is not None and len(operation_id) > 38):
            raise ValueError("Invalid value for `operation_id`, length must be less than or equal to `38`")  # noqa: E501
        if (self._configuration.client_side_validation and
                operation_id is not None and len(operation_id) < 36):
            raise ValueError("Invalid value for `operation_id`, length must be greater than or equal to `36`")  # noqa: E501
        if (self._configuration.client_side_validation and
                operation_id is not None and not re.search(r'^[a-zA-Z0-9-]*$', operation_id)):  # noqa: E501
            raise ValueError(r"Invalid value for `operation_id`, must be a follow pattern or equal to `/^[a-zA-Z0-9-]*$/`")  # noqa: E501

        self._operation_id = operation_id

    @property
    def operation_problems(self):
        """Gets the operation_problems of this InboundOperationStatus.  # noqa: E501

        The problems in the processing of the asynchronous operation.  # noqa: E501

        :return: The operation_problems of this InboundOperationStatus.  # noqa: E501
        :rtype: List[OperationProblem]
        """
        return self._operation_problems

    @operation_problems.setter
    def operation_problems(self, operation_problems):
        """Sets the operation_problems of this InboundOperationStatus.

        The problems in the processing of the asynchronous operation.  # noqa: E501

        :param operation_problems: The operation_problems of this InboundOperationStatus.  # noqa: E501
        :type: List[OperationProblem]
        """
        if self._configuration.client_side_validation and operation_problems is None:
            raise ValueError("Invalid value for `operation_problems`, must not be `None`")  # noqa: E501

        self._operation_problems = operation_problems

    @property
    def operation_status(self):
        """Gets the operation_status of this InboundOperationStatus.  # noqa: E501


        :return: The operation_status of this InboundOperationStatus.  # noqa: E501
        :rtype: OperationStatus
        """
        return self._operation_status

    @operation_status.setter
    def operation_status(self, operation_status):
        """Sets the operation_status of this InboundOperationStatus.


        :param operation_status: The operation_status of this InboundOperationStatus.  # noqa: E501
        :type: OperationStatus
        """
        if self._configuration.client_side_validation and operation_status is None:
            raise ValueError("Invalid value for `operation_status`, must not be `None`")  # noqa: E501

        self._operation_status = operation_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InboundOperationStatus, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InboundOperationStatus):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InboundOperationStatus):
            return True

        return self.to_dict() != other.to_dict()
