# coding: utf-8

"""
    The Selling Partner API for FBA inbound operations.

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class SetPackingInformationRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'package_groupings': 'List[PackageGroupingInput]',
    }

    attribute_map = {
        'package_groupings': 'packageGroupings',
    }

    def __init__(self, package_groupings=None, _configuration=None):  # noqa: E501
        """SetPackingInformationRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._package_groupings = None
        self.discriminator = None

        self.package_groupings = package_groupings

    @property
    def package_groupings(self):
        """Gets the package_groupings of this SetPackingInformationRequest.  # noqa: E501

        List of packing information for the inbound plan.  # noqa: E501

        :return: The package_groupings of this SetPackingInformationRequest.  # noqa: E501
        :rtype: List[PackageGroupingInput]
        """
        return self._package_groupings

    @package_groupings.setter
    def package_groupings(self, package_groupings):
        """Sets the package_groupings of this SetPackingInformationRequest.

        List of packing information for the inbound plan.  # noqa: E501

        :param package_groupings: The package_groupings of this SetPackingInformationRequest.  # noqa: E501
        :type: List[PackageGroupingInput]
        """
        if self._configuration.client_side_validation and package_groupings is None:
            raise ValueError("Invalid value for `package_groupings`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                package_groupings is not None and len(package_groupings) < 1):
            raise ValueError("Invalid value for `package_groupings`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._package_groupings = package_groupings

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SetPackingInformationRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SetPackingInformationRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SetPackingInformationRequest):
            return True

        return self.to_dict() != other.to_dict()
