# coding: utf-8

"""
    The Selling Partner API for FBA inbound operations.

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ShippingRequirements(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'modes': 'List[str]',
        'solution': 'str',
    }

    attribute_map = {
        'modes': 'modes',
        'solution': 'solution',
    }

    def __init__(self, modes=None, solution=None, _configuration=None):  # noqa: E501
        """ShippingRequirements - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._modes = None
        self._solution = None
        self.discriminator = None

        self.modes = modes
        self.solution = solution

    @property
    def modes(self):
        """Gets the modes of this ShippingRequirements.  # noqa: E501

        Available shipment modes for this shipping program.  # noqa: E501

        :return: The modes of this ShippingRequirements.  # noqa: E501
        :rtype: List[str]
        """
        return self._modes

    @modes.setter
    def modes(self, modes):
        """Sets the modes of this ShippingRequirements.

        Available shipment modes for this shipping program.  # noqa: E501

        :param modes: The modes of this ShippingRequirements.  # noqa: E501
        :type: List[str]
        """
        if self._configuration.client_side_validation and modes is None:
            raise ValueError("Invalid value for `modes`, must not be `None`")  # noqa: E501

        self._modes = modes

    @property
    def solution(self):
        """Gets the solution of this ShippingRequirements.  # noqa: E501

        Shipping program for the option. Can be: `AMAZON_PARTNERED_CARRIER`, `USE_YOUR_OWN_CARRIER`.  # noqa: E501

        :return: The solution of this ShippingRequirements.  # noqa: E501
        :rtype: str
        """
        return self._solution

    @solution.setter
    def solution(self, solution):
        """Sets the solution of this ShippingRequirements.

        Shipping program for the option. Can be: `AMAZON_PARTNERED_CARRIER`, `USE_YOUR_OWN_CARRIER`.  # noqa: E501

        :param solution: The solution of this ShippingRequirements.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and solution is None:
            raise ValueError("Invalid value for `solution`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                solution is not None and len(solution) > 1024):
            raise ValueError("Invalid value for `solution`, length must be less than or equal to `1024`")  # noqa: E501
        if (self._configuration.client_side_validation and
                solution is not None and len(solution) < 1):
            raise ValueError("Invalid value for `solution`, length must be greater than or equal to `1`")  # noqa: E501

        self._solution = solution

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ShippingRequirements, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ShippingRequirements):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ShippingRequirements):
            return True

        return self.to_dict() != other.to_dict()
