# coding: utf-8

"""
    The Selling Partner API for FBA inbound operations.

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class SpdTrackingDetailInput(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'spd_tracking_items': 'List[SpdTrackingItemInput]',
    }

    attribute_map = {
        'spd_tracking_items': 'spdTrackingItems',
    }

    def __init__(self, spd_tracking_items=None, _configuration=None):  # noqa: E501
        """SpdTrackingDetailInput - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._spd_tracking_items = None
        self.discriminator = None

        self.spd_tracking_items = spd_tracking_items

    @property
    def spd_tracking_items(self):
        """Gets the spd_tracking_items of this SpdTrackingDetailInput.  # noqa: E501

        List of Small Parcel Delivery (SPD) tracking items input.  # noqa: E501

        :return: The spd_tracking_items of this SpdTrackingDetailInput.  # noqa: E501
        :rtype: List[SpdTrackingItemInput]
        """
        return self._spd_tracking_items

    @spd_tracking_items.setter
    def spd_tracking_items(self, spd_tracking_items):
        """Sets the spd_tracking_items of this SpdTrackingDetailInput.

        List of Small Parcel Delivery (SPD) tracking items input.  # noqa: E501

        :param spd_tracking_items: The spd_tracking_items of this SpdTrackingDetailInput.  # noqa: E501
        :type: List[SpdTrackingItemInput]
        """
        if self._configuration.client_side_validation and spd_tracking_items is None:
            raise ValueError("Invalid value for `spd_tracking_items`, must not be `None`")  # noqa: E501

        self._spd_tracking_items = spd_tracking_items

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SpdTrackingDetailInput, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SpdTrackingDetailInput):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SpdTrackingDetailInput):
            return True

        return self.to_dict() != other.to_dict()
