# coding: utf-8

"""
    The Selling Partner API for FBA inbound operations.

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class SpdTrackingItemInput(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'box_id': 'str',
        'tracking_id': 'str',
    }

    attribute_map = {
        'box_id': 'boxId',
        'tracking_id': 'trackingId',
    }

    def __init__(self, box_id=None, tracking_id=None, _configuration=None):  # noqa: E501
        """SpdTrackingItemInput - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._box_id = None
        self._tracking_id = None
        self.discriminator = None

        self.box_id = box_id
        self.tracking_id = tracking_id

    @property
    def box_id(self):
        """Gets the box_id of this SpdTrackingItemInput.  # noqa: E501

        The ID provided by Amazon that identifies a given box. This ID is comprised of the external shipment ID (which is generated after transportation has been confirmed) and the index of the box.  # noqa: E501

        :return: The box_id of this SpdTrackingItemInput.  # noqa: E501
        :rtype: str
        """
        return self._box_id

    @box_id.setter
    def box_id(self, box_id):
        """Sets the box_id of this SpdTrackingItemInput.

        The ID provided by Amazon that identifies a given box. This ID is comprised of the external shipment ID (which is generated after transportation has been confirmed) and the index of the box.  # noqa: E501

        :param box_id: The box_id of this SpdTrackingItemInput.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and box_id is None:
            raise ValueError("Invalid value for `box_id`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                box_id is not None and len(box_id) > 1024):
            raise ValueError("Invalid value for `box_id`, length must be less than or equal to `1024`")  # noqa: E501
        if (self._configuration.client_side_validation and
                box_id is not None and len(box_id) < 1):
            raise ValueError("Invalid value for `box_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._box_id = box_id

    @property
    def tracking_id(self):
        """Gets the tracking_id of this SpdTrackingItemInput.  # noqa: E501

        The tracking Id associated with each box in a non-Amazon partnered Small Parcel Delivery (SPD) shipment. The seller must provide this information.  # noqa: E501

        :return: The tracking_id of this SpdTrackingItemInput.  # noqa: E501
        :rtype: str
        """
        return self._tracking_id

    @tracking_id.setter
    def tracking_id(self, tracking_id):
        """Sets the tracking_id of this SpdTrackingItemInput.

        The tracking Id associated with each box in a non-Amazon partnered Small Parcel Delivery (SPD) shipment. The seller must provide this information.  # noqa: E501

        :param tracking_id: The tracking_id of this SpdTrackingItemInput.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and tracking_id is None:
            raise ValueError("Invalid value for `tracking_id`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                tracking_id is not None and len(tracking_id) > 1024):
            raise ValueError("Invalid value for `tracking_id`, length must be less than or equal to `1024`")  # noqa: E501
        if (self._configuration.client_side_validation and
                tracking_id is not None and len(tracking_id) < 1):
            raise ValueError("Invalid value for `tracking_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._tracking_id = tracking_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SpdTrackingItemInput, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SpdTrackingItemInput):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SpdTrackingItemInput):
            return True

        return self.to_dict() != other.to_dict()
