# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class CreateFulfillmentReturnResult(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'return_items': 'List[ReturnItem]',
        'invalid_return_items': 'List[InvalidReturnItem]',
        'return_authorizations': 'List[ReturnAuthorization]',
    }

    attribute_map = {
        'return_items': 'returnItems',
        'invalid_return_items': 'invalidReturnItems',
        'return_authorizations': 'returnAuthorizations',
    }

    def __init__(self, return_items=None, invalid_return_items=None, return_authorizations=None, _configuration=None):  # noqa: E501
        """CreateFulfillmentReturnResult - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._return_items = None
        self._invalid_return_items = None
        self._return_authorizations = None
        self.discriminator = None

        if return_items is not None:
            self.return_items = return_items
        if invalid_return_items is not None:
            self.invalid_return_items = invalid_return_items
        if return_authorizations is not None:
            self.return_authorizations = return_authorizations

    @property
    def return_items(self):
        """Gets the return_items of this CreateFulfillmentReturnResult.  # noqa: E501

        An array of items that Amazon accepted for return. Returns empty if no items were accepted for return.  # noqa: E501

        :return: The return_items of this CreateFulfillmentReturnResult.  # noqa: E501
        :rtype: List[ReturnItem]
        """
        return self._return_items

    @return_items.setter
    def return_items(self, return_items):
        """Sets the return_items of this CreateFulfillmentReturnResult.

        An array of items that Amazon accepted for return. Returns empty if no items were accepted for return.  # noqa: E501

        :param return_items: The return_items of this CreateFulfillmentReturnResult.  # noqa: E501
        :type: List[ReturnItem]
        """

        self._return_items = return_items

    @property
    def invalid_return_items(self):
        """Gets the invalid_return_items of this CreateFulfillmentReturnResult.  # noqa: E501

        An array of invalid return item information.  # noqa: E501

        :return: The invalid_return_items of this CreateFulfillmentReturnResult.  # noqa: E501
        :rtype: List[InvalidReturnItem]
        """
        return self._invalid_return_items

    @invalid_return_items.setter
    def invalid_return_items(self, invalid_return_items):
        """Sets the invalid_return_items of this CreateFulfillmentReturnResult.

        An array of invalid return item information.  # noqa: E501

        :param invalid_return_items: The invalid_return_items of this CreateFulfillmentReturnResult.  # noqa: E501
        :type: List[InvalidReturnItem]
        """

        self._invalid_return_items = invalid_return_items

    @property
    def return_authorizations(self):
        """Gets the return_authorizations of this CreateFulfillmentReturnResult.  # noqa: E501

        An array of return authorization information.  # noqa: E501

        :return: The return_authorizations of this CreateFulfillmentReturnResult.  # noqa: E501
        :rtype: List[ReturnAuthorization]
        """
        return self._return_authorizations

    @return_authorizations.setter
    def return_authorizations(self, return_authorizations):
        """Sets the return_authorizations of this CreateFulfillmentReturnResult.

        An array of return authorization information.  # noqa: E501

        :param return_authorizations: The return_authorizations of this CreateFulfillmentReturnResult.  # noqa: E501
        :type: List[ReturnAuthorization]
        """

        self._return_authorizations = return_authorizations

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateFulfillmentReturnResult, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateFulfillmentReturnResult):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateFulfillmentReturnResult):
            return True

        return self.to_dict() != other.to_dict()
