# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class CreateReturnItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'seller_return_item_id': 'str',
        'seller_fulfillment_order_item_id': 'str',
        'amazon_shipment_id': 'str',
        'return_reason_code': 'str',
        'return_comment': 'str',
    }

    attribute_map = {
        'seller_return_item_id': 'sellerReturnItemId',
        'seller_fulfillment_order_item_id': 'sellerFulfillmentOrderItemId',
        'amazon_shipment_id': 'amazonShipmentId',
        'return_reason_code': 'returnReasonCode',
        'return_comment': 'returnComment',
    }

    def __init__(self, seller_return_item_id=None, seller_fulfillment_order_item_id=None, amazon_shipment_id=None, return_reason_code=None, return_comment=None, _configuration=None):  # noqa: E501
        """CreateReturnItem - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._seller_return_item_id = None
        self._seller_fulfillment_order_item_id = None
        self._amazon_shipment_id = None
        self._return_reason_code = None
        self._return_comment = None
        self.discriminator = None

        self.seller_return_item_id = seller_return_item_id
        self.seller_fulfillment_order_item_id = seller_fulfillment_order_item_id
        self.amazon_shipment_id = amazon_shipment_id
        self.return_reason_code = return_reason_code
        if return_comment is not None:
            self.return_comment = return_comment

    @property
    def seller_return_item_id(self):
        """Gets the seller_return_item_id of this CreateReturnItem.  # noqa: E501

        An identifier assigned by the seller to the return item.  # noqa: E501

        :return: The seller_return_item_id of this CreateReturnItem.  # noqa: E501
        :rtype: str
        """
        return self._seller_return_item_id

    @seller_return_item_id.setter
    def seller_return_item_id(self, seller_return_item_id):
        """Sets the seller_return_item_id of this CreateReturnItem.

        An identifier assigned by the seller to the return item.  # noqa: E501

        :param seller_return_item_id: The seller_return_item_id of this CreateReturnItem.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and seller_return_item_id is None:
            raise ValueError("Invalid value for `seller_return_item_id`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                seller_return_item_id is not None and len(seller_return_item_id) > 80):
            raise ValueError("Invalid value for `seller_return_item_id`, length must be less than or equal to `80`")  # noqa: E501

        self._seller_return_item_id = seller_return_item_id

    @property
    def seller_fulfillment_order_item_id(self):
        """Gets the seller_fulfillment_order_item_id of this CreateReturnItem.  # noqa: E501

        The identifier assigned to the item by the seller when the fulfillment order was created.  # noqa: E501

        :return: The seller_fulfillment_order_item_id of this CreateReturnItem.  # noqa: E501
        :rtype: str
        """
        return self._seller_fulfillment_order_item_id

    @seller_fulfillment_order_item_id.setter
    def seller_fulfillment_order_item_id(self, seller_fulfillment_order_item_id):
        """Sets the seller_fulfillment_order_item_id of this CreateReturnItem.

        The identifier assigned to the item by the seller when the fulfillment order was created.  # noqa: E501

        :param seller_fulfillment_order_item_id: The seller_fulfillment_order_item_id of this CreateReturnItem.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and seller_fulfillment_order_item_id is None:
            raise ValueError("Invalid value for `seller_fulfillment_order_item_id`, must not be `None`")  # noqa: E501

        self._seller_fulfillment_order_item_id = seller_fulfillment_order_item_id

    @property
    def amazon_shipment_id(self):
        """Gets the amazon_shipment_id of this CreateReturnItem.  # noqa: E501

        The identifier for the shipment that is associated with the return item.  # noqa: E501

        :return: The amazon_shipment_id of this CreateReturnItem.  # noqa: E501
        :rtype: str
        """
        return self._amazon_shipment_id

    @amazon_shipment_id.setter
    def amazon_shipment_id(self, amazon_shipment_id):
        """Sets the amazon_shipment_id of this CreateReturnItem.

        The identifier for the shipment that is associated with the return item.  # noqa: E501

        :param amazon_shipment_id: The amazon_shipment_id of this CreateReturnItem.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and amazon_shipment_id is None:
            raise ValueError("Invalid value for `amazon_shipment_id`, must not be `None`")  # noqa: E501

        self._amazon_shipment_id = amazon_shipment_id

    @property
    def return_reason_code(self):
        """Gets the return_reason_code of this CreateReturnItem.  # noqa: E501

        The return reason code assigned to the return item by the seller.  # noqa: E501

        :return: The return_reason_code of this CreateReturnItem.  # noqa: E501
        :rtype: str
        """
        return self._return_reason_code

    @return_reason_code.setter
    def return_reason_code(self, return_reason_code):
        """Sets the return_reason_code of this CreateReturnItem.

        The return reason code assigned to the return item by the seller.  # noqa: E501

        :param return_reason_code: The return_reason_code of this CreateReturnItem.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and return_reason_code is None:
            raise ValueError("Invalid value for `return_reason_code`, must not be `None`")  # noqa: E501

        self._return_reason_code = return_reason_code

    @property
    def return_comment(self):
        """Gets the return_comment of this CreateReturnItem.  # noqa: E501

        An optional comment about the return item.  # noqa: E501

        :return: The return_comment of this CreateReturnItem.  # noqa: E501
        :rtype: str
        """
        return self._return_comment

    @return_comment.setter
    def return_comment(self, return_comment):
        """Sets the return_comment of this CreateReturnItem.

        An optional comment about the return item.  # noqa: E501

        :param return_comment: The return_comment of this CreateReturnItem.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                return_comment is not None and len(return_comment) > 1000):
            raise ValueError("Invalid value for `return_comment`, length must be less than or equal to `1000`")  # noqa: E501

        self._return_comment = return_comment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateReturnItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateReturnItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateReturnItem):
            return True

        return self.to_dict() != other.to_dict()
