# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class Destination(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'delivery_address': 'VariablePrecisionAddress',
        'ip_address': 'str',
    }

    attribute_map = {
        'delivery_address': 'deliveryAddress',
        'ip_address': 'ipAddress',
    }

    def __init__(self, delivery_address=None, ip_address=None, _configuration=None):  # noqa: E501
        """Destination - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._delivery_address = None
        self._ip_address = None
        self.discriminator = None

        if delivery_address is not None:
            self.delivery_address = delivery_address
        if ip_address is not None:
            self.ip_address = ip_address

    @property
    def delivery_address(self):
        """Gets the delivery_address of this Destination.  # noqa: E501


        :return: The delivery_address of this Destination.  # noqa: E501
        :rtype: VariablePrecisionAddress
        """
        return self._delivery_address

    @delivery_address.setter
    def delivery_address(self, delivery_address):
        """Sets the delivery_address of this Destination.


        :param delivery_address: The delivery_address of this Destination.  # noqa: E501
        :type: VariablePrecisionAddress
        """

        self._delivery_address = delivery_address

    @property
    def ip_address(self):
        """Gets the ip_address of this Destination.  # noqa: E501

        An IP Address.  # noqa: E501

        :return: The ip_address of this Destination.  # noqa: E501
        :rtype: str
        """
        return self._ip_address

    @ip_address.setter
    def ip_address(self, ip_address):
        """Sets the ip_address of this Destination.

        An IP Address.  # noqa: E501

        :param ip_address: The ip_address of this Destination.  # noqa: E501
        :type: str
        """

        self._ip_address = ip_address

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Destination, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Destination):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Destination):
            return True

        return self.to_dict() != other.to_dict()
