# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class FeatureSettings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'feature_name': 'str',
        'feature_fulfillment_policy': 'str',
    }

    attribute_map = {
        'feature_name': 'featureName',
        'feature_fulfillment_policy': 'featureFulfillmentPolicy',
    }

    def __init__(self, feature_name=None, feature_fulfillment_policy=None, _configuration=None):  # noqa: E501
        """FeatureSettings - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._feature_name = None
        self._feature_fulfillment_policy = None
        self.discriminator = None

        if feature_name is not None:
            self.feature_name = feature_name
        if feature_fulfillment_policy is not None:
            self.feature_fulfillment_policy = feature_fulfillment_policy

    @property
    def feature_name(self):
        """Gets the feature_name of this FeatureSettings.  # noqa: E501

        The name of the feature.  # noqa: E501

        :return: The feature_name of this FeatureSettings.  # noqa: E501
        :rtype: str
        """
        return self._feature_name

    @feature_name.setter
    def feature_name(self, feature_name):
        """Sets the feature_name of this FeatureSettings.

        The name of the feature.  # noqa: E501

        :param feature_name: The feature_name of this FeatureSettings.  # noqa: E501
        :type: str
        """

        self._feature_name = feature_name

    @property
    def feature_fulfillment_policy(self):
        """Gets the feature_fulfillment_policy of this FeatureSettings.  # noqa: E501

        Specifies the policy to use when fulfilling an order.  # noqa: E501

        :return: The feature_fulfillment_policy of this FeatureSettings.  # noqa: E501
        :rtype: str
        """
        return self._feature_fulfillment_policy

    @feature_fulfillment_policy.setter
    def feature_fulfillment_policy(self, feature_fulfillment_policy):
        """Sets the feature_fulfillment_policy of this FeatureSettings.

        Specifies the policy to use when fulfilling an order.  # noqa: E501

        :param feature_fulfillment_policy: The feature_fulfillment_policy of this FeatureSettings.  # noqa: E501
        :type: str
        """
        allowed_values = ["Required", "NotRequired"]  # noqa: E501
        if (self._configuration.client_side_validation and
                feature_fulfillment_policy not in allowed_values):
            raise ValueError(
                "Invalid value for `feature_fulfillment_policy` ({0}), must be one of {1}"  # noqa: E501
                .format(feature_fulfillment_policy, allowed_values)
            )

        self._feature_fulfillment_policy = feature_fulfillment_policy

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FeatureSettings, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FeatureSettings):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FeatureSettings):
            return True

        return self.to_dict() != other.to_dict()
