# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class FulfillmentPreviewItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'seller_sku': 'str',
        'quantity': 'int',
        'seller_fulfillment_order_item_id': 'str',
        'estimated_shipping_weight': 'Weight',
        'shipping_weight_calculation_method': 'str',
    }

    attribute_map = {
        'seller_sku': 'sellerSku',
        'quantity': 'quantity',
        'seller_fulfillment_order_item_id': 'sellerFulfillmentOrderItemId',
        'estimated_shipping_weight': 'estimatedShippingWeight',
        'shipping_weight_calculation_method': 'shippingWeightCalculationMethod',
    }

    def __init__(self, seller_sku=None, quantity=None, seller_fulfillment_order_item_id=None, estimated_shipping_weight=None, shipping_weight_calculation_method=None, _configuration=None):  # noqa: E501
        """FulfillmentPreviewItem - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._seller_sku = None
        self._quantity = None
        self._seller_fulfillment_order_item_id = None
        self._estimated_shipping_weight = None
        self._shipping_weight_calculation_method = None
        self.discriminator = None

        self.seller_sku = seller_sku
        self.quantity = quantity
        self.seller_fulfillment_order_item_id = seller_fulfillment_order_item_id
        if estimated_shipping_weight is not None:
            self.estimated_shipping_weight = estimated_shipping_weight
        if shipping_weight_calculation_method is not None:
            self.shipping_weight_calculation_method = shipping_weight_calculation_method

    @property
    def seller_sku(self):
        """Gets the seller_sku of this FulfillmentPreviewItem.  # noqa: E501

        The seller SKU of the item.  # noqa: E501

        :return: The seller_sku of this FulfillmentPreviewItem.  # noqa: E501
        :rtype: str
        """
        return self._seller_sku

    @seller_sku.setter
    def seller_sku(self, seller_sku):
        """Sets the seller_sku of this FulfillmentPreviewItem.

        The seller SKU of the item.  # noqa: E501

        :param seller_sku: The seller_sku of this FulfillmentPreviewItem.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and seller_sku is None:
            raise ValueError("Invalid value for `seller_sku`, must not be `None`")  # noqa: E501

        self._seller_sku = seller_sku

    @property
    def quantity(self):
        """Gets the quantity of this FulfillmentPreviewItem.  # noqa: E501

        The item quantity.  # noqa: E501

        :return: The quantity of this FulfillmentPreviewItem.  # noqa: E501
        :rtype: int
        """
        return self._quantity

    @quantity.setter
    def quantity(self, quantity):
        """Sets the quantity of this FulfillmentPreviewItem.

        The item quantity.  # noqa: E501

        :param quantity: The quantity of this FulfillmentPreviewItem.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and quantity is None:
            raise ValueError("Invalid value for `quantity`, must not be `None`")  # noqa: E501

        self._quantity = quantity

    @property
    def seller_fulfillment_order_item_id(self):
        """Gets the seller_fulfillment_order_item_id of this FulfillmentPreviewItem.  # noqa: E501

        A fulfillment order item identifier that the seller created with a call to the `createFulfillmentOrder` operation.  # noqa: E501

        :return: The seller_fulfillment_order_item_id of this FulfillmentPreviewItem.  # noqa: E501
        :rtype: str
        """
        return self._seller_fulfillment_order_item_id

    @seller_fulfillment_order_item_id.setter
    def seller_fulfillment_order_item_id(self, seller_fulfillment_order_item_id):
        """Sets the seller_fulfillment_order_item_id of this FulfillmentPreviewItem.

        A fulfillment order item identifier that the seller created with a call to the `createFulfillmentOrder` operation.  # noqa: E501

        :param seller_fulfillment_order_item_id: The seller_fulfillment_order_item_id of this FulfillmentPreviewItem.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and seller_fulfillment_order_item_id is None:
            raise ValueError("Invalid value for `seller_fulfillment_order_item_id`, must not be `None`")  # noqa: E501

        self._seller_fulfillment_order_item_id = seller_fulfillment_order_item_id

    @property
    def estimated_shipping_weight(self):
        """Gets the estimated_shipping_weight of this FulfillmentPreviewItem.  # noqa: E501


        :return: The estimated_shipping_weight of this FulfillmentPreviewItem.  # noqa: E501
        :rtype: Weight
        """
        return self._estimated_shipping_weight

    @estimated_shipping_weight.setter
    def estimated_shipping_weight(self, estimated_shipping_weight):
        """Sets the estimated_shipping_weight of this FulfillmentPreviewItem.


        :param estimated_shipping_weight: The estimated_shipping_weight of this FulfillmentPreviewItem.  # noqa: E501
        :type: Weight
        """

        self._estimated_shipping_weight = estimated_shipping_weight

    @property
    def shipping_weight_calculation_method(self):
        """Gets the shipping_weight_calculation_method of this FulfillmentPreviewItem.  # noqa: E501

        The method used to calculate the estimated shipping weight.  # noqa: E501

        :return: The shipping_weight_calculation_method of this FulfillmentPreviewItem.  # noqa: E501
        :rtype: str
        """
        return self._shipping_weight_calculation_method

    @shipping_weight_calculation_method.setter
    def shipping_weight_calculation_method(self, shipping_weight_calculation_method):
        """Sets the shipping_weight_calculation_method of this FulfillmentPreviewItem.

        The method used to calculate the estimated shipping weight.  # noqa: E501

        :param shipping_weight_calculation_method: The shipping_weight_calculation_method of this FulfillmentPreviewItem.  # noqa: E501
        :type: str
        """
        allowed_values = ["Package", "Dimensional"]  # noqa: E501
        if (self._configuration.client_side_validation and
                shipping_weight_calculation_method not in allowed_values):
            raise ValueError(
                "Invalid value for `shipping_weight_calculation_method` ({0}), must be one of {1}"  # noqa: E501
                .format(shipping_weight_calculation_method, allowed_values)
            )

        self._shipping_weight_calculation_method = shipping_weight_calculation_method

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FulfillmentPreviewItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FulfillmentPreviewItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FulfillmentPreviewItem):
            return True

        return self.to_dict() != other.to_dict()
