# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GetDeliveryOffersRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'product': 'GetDeliveryOffersProduct',
        'terms': 'GetDeliveryOffersTerms',
    }

    attribute_map = {
        'product': 'product',
        'terms': 'terms',
    }

    def __init__(self, product=None, terms=None, _configuration=None):  # noqa: E501
        """GetDeliveryOffersRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._product = None
        self._terms = None
        self.discriminator = None

        self.product = product
        self.terms = terms

    @property
    def product(self):
        """Gets the product of this GetDeliveryOffersRequest.  # noqa: E501


        :return: The product of this GetDeliveryOffersRequest.  # noqa: E501
        :rtype: GetDeliveryOffersProduct
        """
        return self._product

    @product.setter
    def product(self, product):
        """Sets the product of this GetDeliveryOffersRequest.


        :param product: The product of this GetDeliveryOffersRequest.  # noqa: E501
        :type: GetDeliveryOffersProduct
        """
        if self._configuration.client_side_validation and product is None:
            raise ValueError("Invalid value for `product`, must not be `None`")  # noqa: E501

        self._product = product

    @property
    def terms(self):
        """Gets the terms of this GetDeliveryOffersRequest.  # noqa: E501


        :return: The terms of this GetDeliveryOffersRequest.  # noqa: E501
        :rtype: GetDeliveryOffersTerms
        """
        return self._terms

    @terms.setter
    def terms(self, terms):
        """Sets the terms of this GetDeliveryOffersRequest.


        :param terms: The terms of this GetDeliveryOffersRequest.  # noqa: E501
        :type: GetDeliveryOffersTerms
        """
        if self._configuration.client_side_validation and terms is None:
            raise ValueError("Invalid value for `terms`, must not be `None`")  # noqa: E501

        self._terms = terms

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetDeliveryOffersRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetDeliveryOffersRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetDeliveryOffersRequest):
            return True

        return self.to_dict() != other.to_dict()
