# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class PaymentInformation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payment_transaction_id': 'str',
        'payment_mode': 'str',
        'payment_date': 'datetime',
    }

    attribute_map = {
        'payment_transaction_id': 'paymentTransactionId',
        'payment_mode': 'paymentMode',
        'payment_date': 'paymentDate',
    }

    def __init__(self, payment_transaction_id=None, payment_mode=None, payment_date=None, _configuration=None):  # noqa: E501
        """PaymentInformation - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._payment_transaction_id = None
        self._payment_mode = None
        self._payment_date = None
        self.discriminator = None

        self.payment_transaction_id = payment_transaction_id
        self.payment_mode = payment_mode
        self.payment_date = payment_date

    @property
    def payment_transaction_id(self):
        """Gets the payment_transaction_id of this PaymentInformation.  # noqa: E501

        The transaction identifier of this payment.  # noqa: E501

        :return: The payment_transaction_id of this PaymentInformation.  # noqa: E501
        :rtype: str
        """
        return self._payment_transaction_id

    @payment_transaction_id.setter
    def payment_transaction_id(self, payment_transaction_id):
        """Sets the payment_transaction_id of this PaymentInformation.

        The transaction identifier of this payment.  # noqa: E501

        :param payment_transaction_id: The payment_transaction_id of this PaymentInformation.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and payment_transaction_id is None:
            raise ValueError("Invalid value for `payment_transaction_id`, must not be `None`")  # noqa: E501

        self._payment_transaction_id = payment_transaction_id

    @property
    def payment_mode(self):
        """Gets the payment_mode of this PaymentInformation.  # noqa: E501

        The transaction mode of this payment.  # noqa: E501

        :return: The payment_mode of this PaymentInformation.  # noqa: E501
        :rtype: str
        """
        return self._payment_mode

    @payment_mode.setter
    def payment_mode(self, payment_mode):
        """Sets the payment_mode of this PaymentInformation.

        The transaction mode of this payment.  # noqa: E501

        :param payment_mode: The payment_mode of this PaymentInformation.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and payment_mode is None:
            raise ValueError("Invalid value for `payment_mode`, must not be `None`")  # noqa: E501

        self._payment_mode = payment_mode

    @property
    def payment_date(self):
        """Gets the payment_date of this PaymentInformation.  # noqa: E501

        Date timestamp  # noqa: E501

        :return: The payment_date of this PaymentInformation.  # noqa: E501
        :rtype: datetime
        """
        return self._payment_date

    @payment_date.setter
    def payment_date(self, payment_date):
        """Sets the payment_date of this PaymentInformation.

        Date timestamp  # noqa: E501

        :param payment_date: The payment_date of this PaymentInformation.  # noqa: E501
        :type: datetime
        """
        if self._configuration.client_side_validation and payment_date is None:
            raise ValueError("Invalid value for `payment_date`, must not be `None`")  # noqa: E501

        self._payment_date = payment_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentInformation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentInformation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PaymentInformation):
            return True

        return self.to_dict() != other.to_dict()
