# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ScheduledDeliveryInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'delivery_time_zone': 'str',
        'delivery_windows': 'List[DeliveryWindow]',
    }

    attribute_map = {
        'delivery_time_zone': 'deliveryTimeZone',
        'delivery_windows': 'deliveryWindows',
    }

    def __init__(self, delivery_time_zone=None, delivery_windows=None, _configuration=None):  # noqa: E501
        """ScheduledDeliveryInfo - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._delivery_time_zone = None
        self._delivery_windows = None
        self.discriminator = None

        self.delivery_time_zone = delivery_time_zone
        self.delivery_windows = delivery_windows

    @property
    def delivery_time_zone(self):
        """Gets the delivery_time_zone of this ScheduledDeliveryInfo.  # noqa: E501

        The time zone of the destination address for the fulfillment order preview. Must be an IANA time zone name. Example: Asia/Tokyo.  # noqa: E501

        :return: The delivery_time_zone of this ScheduledDeliveryInfo.  # noqa: E501
        :rtype: str
        """
        return self._delivery_time_zone

    @delivery_time_zone.setter
    def delivery_time_zone(self, delivery_time_zone):
        """Sets the delivery_time_zone of this ScheduledDeliveryInfo.

        The time zone of the destination address for the fulfillment order preview. Must be an IANA time zone name. Example: Asia/Tokyo.  # noqa: E501

        :param delivery_time_zone: The delivery_time_zone of this ScheduledDeliveryInfo.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and delivery_time_zone is None:
            raise ValueError("Invalid value for `delivery_time_zone`, must not be `None`")  # noqa: E501

        self._delivery_time_zone = delivery_time_zone

    @property
    def delivery_windows(self):
        """Gets the delivery_windows of this ScheduledDeliveryInfo.  # noqa: E501

        An array of delivery windows.  # noqa: E501

        :return: The delivery_windows of this ScheduledDeliveryInfo.  # noqa: E501
        :rtype: List[DeliveryWindow]
        """
        return self._delivery_windows

    @delivery_windows.setter
    def delivery_windows(self, delivery_windows):
        """Sets the delivery_windows of this ScheduledDeliveryInfo.

        An array of delivery windows.  # noqa: E501

        :param delivery_windows: The delivery_windows of this ScheduledDeliveryInfo.  # noqa: E501
        :type: List[DeliveryWindow]
        """
        if self._configuration.client_side_validation and delivery_windows is None:
            raise ValueError("Invalid value for `delivery_windows`, must not be `None`")  # noqa: E501

        self._delivery_windows = delivery_windows

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScheduledDeliveryInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScheduledDeliveryInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ScheduledDeliveryInfo):
            return True

        return self.to_dict() != other.to_dict()
