# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class TrackingEvent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'event_date': 'datetime',
        'event_address': 'TrackingAddress',
        'event_code': 'EventCode',
        'event_description': 'str',
    }

    attribute_map = {
        'event_date': 'eventDate',
        'event_address': 'eventAddress',
        'event_code': 'eventCode',
        'event_description': 'eventDescription',
    }

    def __init__(self, event_date=None, event_address=None, event_code=None, event_description=None, _configuration=None):  # noqa: E501
        """TrackingEvent - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._event_date = None
        self._event_address = None
        self._event_code = None
        self._event_description = None
        self.discriminator = None

        self.event_date = event_date
        self.event_address = event_address
        self.event_code = event_code
        self.event_description = event_description

    @property
    def event_date(self):
        """Gets the event_date of this TrackingEvent.  # noqa: E501

        Date timestamp  # noqa: E501

        :return: The event_date of this TrackingEvent.  # noqa: E501
        :rtype: datetime
        """
        return self._event_date

    @event_date.setter
    def event_date(self, event_date):
        """Sets the event_date of this TrackingEvent.

        Date timestamp  # noqa: E501

        :param event_date: The event_date of this TrackingEvent.  # noqa: E501
        :type: datetime
        """
        if self._configuration.client_side_validation and event_date is None:
            raise ValueError("Invalid value for `event_date`, must not be `None`")  # noqa: E501

        self._event_date = event_date

    @property
    def event_address(self):
        """Gets the event_address of this TrackingEvent.  # noqa: E501


        :return: The event_address of this TrackingEvent.  # noqa: E501
        :rtype: TrackingAddress
        """
        return self._event_address

    @event_address.setter
    def event_address(self, event_address):
        """Sets the event_address of this TrackingEvent.


        :param event_address: The event_address of this TrackingEvent.  # noqa: E501
        :type: TrackingAddress
        """
        if self._configuration.client_side_validation and event_address is None:
            raise ValueError("Invalid value for `event_address`, must not be `None`")  # noqa: E501

        self._event_address = event_address

    @property
    def event_code(self):
        """Gets the event_code of this TrackingEvent.  # noqa: E501


        :return: The event_code of this TrackingEvent.  # noqa: E501
        :rtype: EventCode
        """
        return self._event_code

    @event_code.setter
    def event_code(self, event_code):
        """Sets the event_code of this TrackingEvent.


        :param event_code: The event_code of this TrackingEvent.  # noqa: E501
        :type: EventCode
        """
        if self._configuration.client_side_validation and event_code is None:
            raise ValueError("Invalid value for `event_code`, must not be `None`")  # noqa: E501

        self._event_code = event_code

    @property
    def event_description(self):
        """Gets the event_description of this TrackingEvent.  # noqa: E501

        A description for the corresponding event code.  # noqa: E501

        :return: The event_description of this TrackingEvent.  # noqa: E501
        :rtype: str
        """
        return self._event_description

    @event_description.setter
    def event_description(self, event_description):
        """Sets the event_description of this TrackingEvent.

        A description for the corresponding event code.  # noqa: E501

        :param event_description: The event_description of this TrackingEvent.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and event_description is None:
            raise ValueError("Invalid value for `event_description`, must not be `None`")  # noqa: E501

        self._event_description = event_description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TrackingEvent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TrackingEvent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TrackingEvent):
            return True

        return self.to_dict() != other.to_dict()
