# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class UnfulfillablePreviewItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'seller_sku': 'str',
        'quantity': 'int',
        'seller_fulfillment_order_item_id': 'str',
        'item_unfulfillable_reasons': 'List[str]',
    }

    attribute_map = {
        'seller_sku': 'sellerSku',
        'quantity': 'quantity',
        'seller_fulfillment_order_item_id': 'sellerFulfillmentOrderItemId',
        'item_unfulfillable_reasons': 'itemUnfulfillableReasons',
    }

    def __init__(self, seller_sku=None, quantity=None, seller_fulfillment_order_item_id=None, item_unfulfillable_reasons=None, _configuration=None):  # noqa: E501
        """UnfulfillablePreviewItem - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._seller_sku = None
        self._quantity = None
        self._seller_fulfillment_order_item_id = None
        self._item_unfulfillable_reasons = None
        self.discriminator = None

        self.seller_sku = seller_sku
        self.quantity = quantity
        self.seller_fulfillment_order_item_id = seller_fulfillment_order_item_id
        if item_unfulfillable_reasons is not None:
            self.item_unfulfillable_reasons = item_unfulfillable_reasons

    @property
    def seller_sku(self):
        """Gets the seller_sku of this UnfulfillablePreviewItem.  # noqa: E501

        The seller SKU of the item.  # noqa: E501

        :return: The seller_sku of this UnfulfillablePreviewItem.  # noqa: E501
        :rtype: str
        """
        return self._seller_sku

    @seller_sku.setter
    def seller_sku(self, seller_sku):
        """Sets the seller_sku of this UnfulfillablePreviewItem.

        The seller SKU of the item.  # noqa: E501

        :param seller_sku: The seller_sku of this UnfulfillablePreviewItem.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and seller_sku is None:
            raise ValueError("Invalid value for `seller_sku`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                seller_sku is not None and len(seller_sku) > 50):
            raise ValueError("Invalid value for `seller_sku`, length must be less than or equal to `50`")  # noqa: E501

        self._seller_sku = seller_sku

    @property
    def quantity(self):
        """Gets the quantity of this UnfulfillablePreviewItem.  # noqa: E501

        The item quantity.  # noqa: E501

        :return: The quantity of this UnfulfillablePreviewItem.  # noqa: E501
        :rtype: int
        """
        return self._quantity

    @quantity.setter
    def quantity(self, quantity):
        """Sets the quantity of this UnfulfillablePreviewItem.

        The item quantity.  # noqa: E501

        :param quantity: The quantity of this UnfulfillablePreviewItem.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and quantity is None:
            raise ValueError("Invalid value for `quantity`, must not be `None`")  # noqa: E501

        self._quantity = quantity

    @property
    def seller_fulfillment_order_item_id(self):
        """Gets the seller_fulfillment_order_item_id of this UnfulfillablePreviewItem.  # noqa: E501

        A fulfillment order item identifier created with a call to the `getFulfillmentPreview` operation.  # noqa: E501

        :return: The seller_fulfillment_order_item_id of this UnfulfillablePreviewItem.  # noqa: E501
        :rtype: str
        """
        return self._seller_fulfillment_order_item_id

    @seller_fulfillment_order_item_id.setter
    def seller_fulfillment_order_item_id(self, seller_fulfillment_order_item_id):
        """Sets the seller_fulfillment_order_item_id of this UnfulfillablePreviewItem.

        A fulfillment order item identifier created with a call to the `getFulfillmentPreview` operation.  # noqa: E501

        :param seller_fulfillment_order_item_id: The seller_fulfillment_order_item_id of this UnfulfillablePreviewItem.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and seller_fulfillment_order_item_id is None:
            raise ValueError("Invalid value for `seller_fulfillment_order_item_id`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                seller_fulfillment_order_item_id is not None and len(seller_fulfillment_order_item_id) > 50):
            raise ValueError("Invalid value for `seller_fulfillment_order_item_id`, length must be less than or equal to `50`")  # noqa: E501

        self._seller_fulfillment_order_item_id = seller_fulfillment_order_item_id

    @property
    def item_unfulfillable_reasons(self):
        """Gets the item_unfulfillable_reasons of this UnfulfillablePreviewItem.  # noqa: E501

        String list  # noqa: E501

        :return: The item_unfulfillable_reasons of this UnfulfillablePreviewItem.  # noqa: E501
        :rtype: List[str]
        """
        return self._item_unfulfillable_reasons

    @item_unfulfillable_reasons.setter
    def item_unfulfillable_reasons(self, item_unfulfillable_reasons):
        """Sets the item_unfulfillable_reasons of this UnfulfillablePreviewItem.

        String list  # noqa: E501

        :param item_unfulfillable_reasons: The item_unfulfillable_reasons of this UnfulfillablePreviewItem.  # noqa: E501
        :type: List[str]
        """

        self._item_unfulfillable_reasons = item_unfulfillable_reasons

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UnfulfillablePreviewItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UnfulfillablePreviewItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UnfulfillablePreviewItem):
            return True

        return self.to_dict() != other.to_dict()
