# coding: utf-8

"""
    The Selling Partner API for Invoices.

    Use the Selling Partner API for Invoices to retrieve and manage invoice-related operations, which can help selling partners manage their bookkeeping processes.

    The version of the OpenAPI document: 2024-06-19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class InvoicesAttributes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'invoice_status_options': 'List[AttributeOption]',
        'invoice_type_options': 'List[AttributeOption]',
        'transaction_identifier_name_options': 'List[AttributeOption]',
        'transaction_type_options': 'List[AttributeOption]',
    }

    attribute_map = {
        'invoice_status_options': 'invoiceStatusOptions',
        'invoice_type_options': 'invoiceTypeOptions',
        'transaction_identifier_name_options': 'transactionIdentifierNameOptions',
        'transaction_type_options': 'transactionTypeOptions',
    }

    def __init__(self, invoice_status_options=None, invoice_type_options=None, transaction_identifier_name_options=None, transaction_type_options=None, _configuration=None):  # noqa: E501
        """InvoicesAttributes - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._invoice_status_options = None
        self._invoice_type_options = None
        self._transaction_identifier_name_options = None
        self._transaction_type_options = None
        self.discriminator = None

        if invoice_status_options is not None:
            self.invoice_status_options = invoice_status_options
        if invoice_type_options is not None:
            self.invoice_type_options = invoice_type_options
        if transaction_identifier_name_options is not None:
            self.transaction_identifier_name_options = transaction_identifier_name_options
        if transaction_type_options is not None:
            self.transaction_type_options = transaction_type_options

    @property
    def invoice_status_options(self):
        """Gets the invoice_status_options of this InvoicesAttributes.  # noqa: E501

        A list of all the options that are available for the invoice status attribute.  # noqa: E501

        :return: The invoice_status_options of this InvoicesAttributes.  # noqa: E501
        :rtype: List[AttributeOption]
        """
        return self._invoice_status_options

    @invoice_status_options.setter
    def invoice_status_options(self, invoice_status_options):
        """Sets the invoice_status_options of this InvoicesAttributes.

        A list of all the options that are available for the invoice status attribute.  # noqa: E501

        :param invoice_status_options: The invoice_status_options of this InvoicesAttributes.  # noqa: E501
        :type: List[AttributeOption]
        """

        self._invoice_status_options = invoice_status_options

    @property
    def invoice_type_options(self):
        """Gets the invoice_type_options of this InvoicesAttributes.  # noqa: E501

        A list of all the options that are available for the invoice type attribute.  # noqa: E501

        :return: The invoice_type_options of this InvoicesAttributes.  # noqa: E501
        :rtype: List[AttributeOption]
        """
        return self._invoice_type_options

    @invoice_type_options.setter
    def invoice_type_options(self, invoice_type_options):
        """Sets the invoice_type_options of this InvoicesAttributes.

        A list of all the options that are available for the invoice type attribute.  # noqa: E501

        :param invoice_type_options: The invoice_type_options of this InvoicesAttributes.  # noqa: E501
        :type: List[AttributeOption]
        """

        self._invoice_type_options = invoice_type_options

    @property
    def transaction_identifier_name_options(self):
        """Gets the transaction_identifier_name_options of this InvoicesAttributes.  # noqa: E501

        A list of all the options that are available for the transaction identifier name attribute.  # noqa: E501

        :return: The transaction_identifier_name_options of this InvoicesAttributes.  # noqa: E501
        :rtype: List[AttributeOption]
        """
        return self._transaction_identifier_name_options

    @transaction_identifier_name_options.setter
    def transaction_identifier_name_options(self, transaction_identifier_name_options):
        """Sets the transaction_identifier_name_options of this InvoicesAttributes.

        A list of all the options that are available for the transaction identifier name attribute.  # noqa: E501

        :param transaction_identifier_name_options: The transaction_identifier_name_options of this InvoicesAttributes.  # noqa: E501
        :type: List[AttributeOption]
        """

        self._transaction_identifier_name_options = transaction_identifier_name_options

    @property
    def transaction_type_options(self):
        """Gets the transaction_type_options of this InvoicesAttributes.  # noqa: E501

        A list of all the options that are available for the transaction type attribute.  # noqa: E501

        :return: The transaction_type_options of this InvoicesAttributes.  # noqa: E501
        :rtype: List[AttributeOption]
        """
        return self._transaction_type_options

    @transaction_type_options.setter
    def transaction_type_options(self, transaction_type_options):
        """Sets the transaction_type_options of this InvoicesAttributes.

        A list of all the options that are available for the transaction type attribute.  # noqa: E501

        :param transaction_type_options: The transaction_type_options of this InvoicesAttributes.  # noqa: E501
        :type: List[AttributeOption]
        """

        self._transaction_type_options = transaction_type_options

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InvoicesAttributes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InvoicesAttributes):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InvoicesAttributes):
            return True

        return self.to_dict() != other.to_dict()
