# coding: utf-8

"""
    The Selling Partner API for Invoices.

    Use the Selling Partner API for Invoices to retrieve and manage invoice-related operations, which can help selling partners manage their bookkeeping processes.

    The version of the OpenAPI document: 2024-06-19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class InvoicesDocument(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'invoices_document_id': 'str',
        'invoices_document_url': 'str',
    }

    attribute_map = {
        'invoices_document_id': 'invoicesDocumentId',
        'invoices_document_url': 'invoicesDocumentUrl',
    }

    def __init__(self, invoices_document_id=None, invoices_document_url=None, _configuration=None):  # noqa: E501
        """InvoicesDocument - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._invoices_document_id = None
        self._invoices_document_url = None
        self.discriminator = None

        if invoices_document_id is not None:
            self.invoices_document_id = invoices_document_id
        if invoices_document_url is not None:
            self.invoices_document_url = invoices_document_url

    @property
    def invoices_document_id(self):
        """Gets the invoices_document_id of this InvoicesDocument.  # noqa: E501

        The identifier of the export document.  # noqa: E501

        :return: The invoices_document_id of this InvoicesDocument.  # noqa: E501
        :rtype: str
        """
        return self._invoices_document_id

    @invoices_document_id.setter
    def invoices_document_id(self, invoices_document_id):
        """Sets the invoices_document_id of this InvoicesDocument.

        The identifier of the export document.  # noqa: E501

        :param invoices_document_id: The invoices_document_id of this InvoicesDocument.  # noqa: E501
        :type: str
        """

        self._invoices_document_id = invoices_document_id

    @property
    def invoices_document_url(self):
        """Gets the invoices_document_url of this InvoicesDocument.  # noqa: E501

        A pre-signed URL that you can use to download the invoices document in zip format. This URL expires after 30 seconds.  # noqa: E501

        :return: The invoices_document_url of this InvoicesDocument.  # noqa: E501
        :rtype: str
        """
        return self._invoices_document_url

    @invoices_document_url.setter
    def invoices_document_url(self, invoices_document_url):
        """Sets the invoices_document_url of this InvoicesDocument.

        A pre-signed URL that you can use to download the invoices document in zip format. This URL expires after 30 seconds.  # noqa: E501

        :param invoices_document_url: The invoices_document_url of this InvoicesDocument.  # noqa: E501
        :type: str
        """

        self._invoices_document_url = invoices_document_url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InvoicesDocument, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InvoicesDocument):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InvoicesDocument):
            return True

        return self.to_dict() != other.to_dict()
