# coding: utf-8

"""
    Selling Partner API for Listings Items

    The Selling Partner API for Listings Items (Listings Items API) provides programmatic access to selling partner listings on Amazon. Use this API in collaboration with the Selling Partner API for Product Type Definitions, which you use to retrieve the information about Amazon product types needed to use the Listings Items API.  For more information, see the [Listings Items API Use Case Guide](https://developer-docs.amazon.com/sp-api/docs/listings-items-api-v2021-08-01-use-case-guide).

    The version of the OpenAPI document: 2021-08-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class IssueEnforcements(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'actions': 'List[IssueEnforcementAction]',
        'exemption': 'IssueExemption',
    }

    attribute_map = {
        'actions': 'actions',
        'exemption': 'exemption',
    }

    def __init__(self, actions=None, exemption=None, _configuration=None):  # noqa: E501
        """IssueEnforcements - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._actions = None
        self._exemption = None
        self.discriminator = None

        self.actions = actions
        self.exemption = exemption

    @property
    def actions(self):
        """Gets the actions of this IssueEnforcements.  # noqa: E501

        List of enforcement actions taken by Amazon that affect the publishing or status of a listing.  # noqa: E501

        :return: The actions of this IssueEnforcements.  # noqa: E501
        :rtype: List[IssueEnforcementAction]
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this IssueEnforcements.

        List of enforcement actions taken by Amazon that affect the publishing or status of a listing.  # noqa: E501

        :param actions: The actions of this IssueEnforcements.  # noqa: E501
        :type: List[IssueEnforcementAction]
        """
        if self._configuration.client_side_validation and actions is None:
            raise ValueError("Invalid value for `actions`, must not be `None`")  # noqa: E501

        self._actions = actions

    @property
    def exemption(self):
        """Gets the exemption of this IssueEnforcements.  # noqa: E501


        :return: The exemption of this IssueEnforcements.  # noqa: E501
        :rtype: IssueExemption
        """
        return self._exemption

    @exemption.setter
    def exemption(self, exemption):
        """Sets the exemption of this IssueEnforcements.


        :param exemption: The exemption of this IssueEnforcements.  # noqa: E501
        :type: IssueExemption
        """
        if self._configuration.client_side_validation and exemption is None:
            raise ValueError("Invalid value for `exemption`, must not be `None`")  # noqa: E501

        self._exemption = exemption

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IssueEnforcements, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IssueEnforcements):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IssueEnforcements):
            return True

        return self.to_dict() != other.to_dict()
