# coding: utf-8

"""
    Selling Partner API for Listings Items

    The Selling Partner API for Listings Items (Listings Items API) provides programmatic access to selling partner listings on Amazon. Use this API in collaboration with the Selling Partner API for Product Type Definitions, which you use to retrieve the information about Amazon product types needed to use the Listings Items API.  For more information, see the [Listings Items API Use Case Guide](https://developer-docs.amazon.com/sp-api/docs/listings-items-api-v2021-08-01-use-case-guide).

    The version of the OpenAPI document: 2021-08-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ItemIdentifiersByMarketplace(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'marketplace_id': 'str',
        'asin': 'str',
    }

    attribute_map = {
        'marketplace_id': 'marketplaceId',
        'asin': 'asin',
    }

    def __init__(self, marketplace_id=None, asin=None, _configuration=None):  # noqa: E501
        """ItemIdentifiersByMarketplace - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._marketplace_id = None
        self._asin = None
        self.discriminator = None

        if marketplace_id is not None:
            self.marketplace_id = marketplace_id
        if asin is not None:
            self.asin = asin

    @property
    def marketplace_id(self):
        """Gets the marketplace_id of this ItemIdentifiersByMarketplace.  # noqa: E501

        A marketplace identifier. Identifies the Amazon marketplace for the listings item.  # noqa: E501

        :return: The marketplace_id of this ItemIdentifiersByMarketplace.  # noqa: E501
        :rtype: str
        """
        return self._marketplace_id

    @marketplace_id.setter
    def marketplace_id(self, marketplace_id):
        """Sets the marketplace_id of this ItemIdentifiersByMarketplace.

        A marketplace identifier. Identifies the Amazon marketplace for the listings item.  # noqa: E501

        :param marketplace_id: The marketplace_id of this ItemIdentifiersByMarketplace.  # noqa: E501
        :type: str
        """

        self._marketplace_id = marketplace_id

    @property
    def asin(self):
        """Gets the asin of this ItemIdentifiersByMarketplace.  # noqa: E501

        Amazon Standard Identification Number (ASIN) of the listings item.  # noqa: E501

        :return: The asin of this ItemIdentifiersByMarketplace.  # noqa: E501
        :rtype: str
        """
        return self._asin

    @asin.setter
    def asin(self, asin):
        """Sets the asin of this ItemIdentifiersByMarketplace.

        Amazon Standard Identification Number (ASIN) of the listings item.  # noqa: E501

        :param asin: The asin of this ItemIdentifiersByMarketplace.  # noqa: E501
        :type: str
        """

        self._asin = asin

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ItemIdentifiersByMarketplace, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ItemIdentifiersByMarketplace):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ItemIdentifiersByMarketplace):
            return True

        return self.to_dict() != other.to_dict()
