# coding: utf-8

"""
    Selling Partner API for Listings Items

    The Selling Partner API for Listings Items (Listings Items API) provides programmatic access to selling partner listings on Amazon. Use this API in collaboration with the Selling Partner API for Product Type Definitions, which you use to retrieve the information about Amazon product types needed to use the Listings Items API.  For more information, see the [Listings Items API Use Case Guide](https://developer-docs.amazon.com/sp-api/docs/listings-items-api-v2021-08-01-use-case-guide).

    The version of the OpenAPI document: 2021-08-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ItemVariationTheme(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'attributes': 'List[str]',
        'theme': 'str',
    }

    attribute_map = {
        'attributes': 'attributes',
        'theme': 'theme',
    }

    def __init__(self, attributes=None, theme=None, _configuration=None):  # noqa: E501
        """ItemVariationTheme - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._attributes = None
        self._theme = None
        self.discriminator = None

        self.attributes = attributes
        self.theme = theme

    @property
    def attributes(self):
        """Gets the attributes of this ItemVariationTheme.  # noqa: E501

        The names of the listing item attributes that are associated with the variation theme.  # noqa: E501

        :return: The attributes of this ItemVariationTheme.  # noqa: E501
        :rtype: List[str]
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """Sets the attributes of this ItemVariationTheme.

        The names of the listing item attributes that are associated with the variation theme.  # noqa: E501

        :param attributes: The attributes of this ItemVariationTheme.  # noqa: E501
        :type: List[str]
        """
        if self._configuration.client_side_validation and attributes is None:
            raise ValueError("Invalid value for `attributes`, must not be `None`")  # noqa: E501

        self._attributes = attributes

    @property
    def theme(self):
        """Gets the theme of this ItemVariationTheme.  # noqa: E501

        The variation theme that indicates the combination of listing item attributes that define the variation family.  # noqa: E501

        :return: The theme of this ItemVariationTheme.  # noqa: E501
        :rtype: str
        """
        return self._theme

    @theme.setter
    def theme(self, theme):
        """Sets the theme of this ItemVariationTheme.

        The variation theme that indicates the combination of listing item attributes that define the variation family.  # noqa: E501

        :param theme: The theme of this ItemVariationTheme.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and theme is None:
            raise ValueError("Invalid value for `theme`, must not be `None`")  # noqa: E501

        self._theme = theme

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ItemVariationTheme, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ItemVariationTheme):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ItemVariationTheme):
            return True

        return self.to_dict() != other.to_dict()
