# coding: utf-8

"""
    Selling Partner API for Merchant Fulfillment

    With the Selling Partner API for Merchant Fulfillment, you can build applications that sellers can use to purchase shipping for non-Prime and Prime orders using Amazon's Buy Shipping Services.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class AvailableShippingServiceOptions(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'available_carrier_will_pick_up_options': 'List[AvailableCarrierWillPickUpOption]',
        'available_delivery_experience_options': 'List[AvailableDeliveryExperienceOption]',
    }

    attribute_map = {
        'available_carrier_will_pick_up_options': 'AvailableCarrierWillPickUpOptions',
        'available_delivery_experience_options': 'AvailableDeliveryExperienceOptions',
    }

    def __init__(self, available_carrier_will_pick_up_options=None, available_delivery_experience_options=None, _configuration=None):  # noqa: E501
        """AvailableShippingServiceOptions - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._available_carrier_will_pick_up_options = None
        self._available_delivery_experience_options = None
        self.discriminator = None

        self.available_carrier_will_pick_up_options = available_carrier_will_pick_up_options
        self.available_delivery_experience_options = available_delivery_experience_options

    @property
    def available_carrier_will_pick_up_options(self):
        """Gets the available_carrier_will_pick_up_options of this AvailableShippingServiceOptions.  # noqa: E501

        List of available carrier pickup options.  # noqa: E501

        :return: The available_carrier_will_pick_up_options of this AvailableShippingServiceOptions.  # noqa: E501
        :rtype: List[AvailableCarrierWillPickUpOption]
        """
        return self._available_carrier_will_pick_up_options

    @available_carrier_will_pick_up_options.setter
    def available_carrier_will_pick_up_options(self, available_carrier_will_pick_up_options):
        """Sets the available_carrier_will_pick_up_options of this AvailableShippingServiceOptions.

        List of available carrier pickup options.  # noqa: E501

        :param available_carrier_will_pick_up_options: The available_carrier_will_pick_up_options of this AvailableShippingServiceOptions.  # noqa: E501
        :type: List[AvailableCarrierWillPickUpOption]
        """
        if self._configuration.client_side_validation and available_carrier_will_pick_up_options is None:
            raise ValueError("Invalid value for `available_carrier_will_pick_up_options`, must not be `None`")  # noqa: E501

        self._available_carrier_will_pick_up_options = available_carrier_will_pick_up_options

    @property
    def available_delivery_experience_options(self):
        """Gets the available_delivery_experience_options of this AvailableShippingServiceOptions.  # noqa: E501

        List of available delivery experience options.  # noqa: E501

        :return: The available_delivery_experience_options of this AvailableShippingServiceOptions.  # noqa: E501
        :rtype: List[AvailableDeliveryExperienceOption]
        """
        return self._available_delivery_experience_options

    @available_delivery_experience_options.setter
    def available_delivery_experience_options(self, available_delivery_experience_options):
        """Sets the available_delivery_experience_options of this AvailableShippingServiceOptions.

        List of available delivery experience options.  # noqa: E501

        :param available_delivery_experience_options: The available_delivery_experience_options of this AvailableShippingServiceOptions.  # noqa: E501
        :type: List[AvailableDeliveryExperienceOption]
        """
        if self._configuration.client_side_validation and available_delivery_experience_options is None:
            raise ValueError("Invalid value for `available_delivery_experience_options`, must not be `None`")  # noqa: E501

        self._available_delivery_experience_options = available_delivery_experience_options

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AvailableShippingServiceOptions, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AvailableShippingServiceOptions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AvailableShippingServiceOptions):
            return True

        return self.to_dict() != other.to_dict()
