# coding: utf-8

"""
    Selling Partner API for Merchant Fulfillment

    With the Selling Partner API for Merchant Fulfillment, you can build applications that sellers can use to purchase shipping for non-Prime and Prime orders using Amazon's Buy Shipping Services.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GetAdditionalSellerInputsRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'shipping_service_id': 'str',
        'ship_from_address': 'Address',
        'order_id': 'str',
    }

    attribute_map = {
        'shipping_service_id': 'ShippingServiceId',
        'ship_from_address': 'ShipFromAddress',
        'order_id': 'OrderId',
    }

    def __init__(self, shipping_service_id=None, ship_from_address=None, order_id=None, _configuration=None):  # noqa: E501
        """GetAdditionalSellerInputsRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._shipping_service_id = None
        self._ship_from_address = None
        self._order_id = None
        self.discriminator = None

        self.shipping_service_id = shipping_service_id
        self.ship_from_address = ship_from_address
        self.order_id = order_id

    @property
    def shipping_service_id(self):
        """Gets the shipping_service_id of this GetAdditionalSellerInputsRequest.  # noqa: E501

        An Amazon-defined shipping service identifier.  # noqa: E501

        :return: The shipping_service_id of this GetAdditionalSellerInputsRequest.  # noqa: E501
        :rtype: str
        """
        return self._shipping_service_id

    @shipping_service_id.setter
    def shipping_service_id(self, shipping_service_id):
        """Sets the shipping_service_id of this GetAdditionalSellerInputsRequest.

        An Amazon-defined shipping service identifier.  # noqa: E501

        :param shipping_service_id: The shipping_service_id of this GetAdditionalSellerInputsRequest.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and shipping_service_id is None:
            raise ValueError("Invalid value for `shipping_service_id`, must not be `None`")  # noqa: E501

        self._shipping_service_id = shipping_service_id

    @property
    def ship_from_address(self):
        """Gets the ship_from_address of this GetAdditionalSellerInputsRequest.  # noqa: E501


        :return: The ship_from_address of this GetAdditionalSellerInputsRequest.  # noqa: E501
        :rtype: Address
        """
        return self._ship_from_address

    @ship_from_address.setter
    def ship_from_address(self, ship_from_address):
        """Sets the ship_from_address of this GetAdditionalSellerInputsRequest.


        :param ship_from_address: The ship_from_address of this GetAdditionalSellerInputsRequest.  # noqa: E501
        :type: Address
        """
        if self._configuration.client_side_validation and ship_from_address is None:
            raise ValueError("Invalid value for `ship_from_address`, must not be `None`")  # noqa: E501

        self._ship_from_address = ship_from_address

    @property
    def order_id(self):
        """Gets the order_id of this GetAdditionalSellerInputsRequest.  # noqa: E501

        An Amazon-defined order identifier, in 3-7-7 format.  # noqa: E501

        :return: The order_id of this GetAdditionalSellerInputsRequest.  # noqa: E501
        :rtype: str
        """
        return self._order_id

    @order_id.setter
    def order_id(self, order_id):
        """Sets the order_id of this GetAdditionalSellerInputsRequest.

        An Amazon-defined order identifier, in 3-7-7 format.  # noqa: E501

        :param order_id: The order_id of this GetAdditionalSellerInputsRequest.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and order_id is None:
            raise ValueError("Invalid value for `order_id`, must not be `None`")  # noqa: E501

        self._order_id = order_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetAdditionalSellerInputsRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetAdditionalSellerInputsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetAdditionalSellerInputsRequest):
            return True

        return self.to_dict() != other.to_dict()
