# coding: utf-8

"""
    Selling Partner API for Merchant Fulfillment

    With the Selling Partner API for Merchant Fulfillment, you can build applications that sellers can use to purchase shipping for non-Prime and Prime orders using Amazon's Buy Shipping Services.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ItemLevelFields(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'asin': 'str',
        'additional_inputs': 'List[AdditionalInputs]',
    }

    attribute_map = {
        'asin': 'Asin',
        'additional_inputs': 'AdditionalInputs',
    }

    def __init__(self, asin=None, additional_inputs=None, _configuration=None):  # noqa: E501
        """ItemLevelFields - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._asin = None
        self._additional_inputs = None
        self.discriminator = None

        self.asin = asin
        self.additional_inputs = additional_inputs

    @property
    def asin(self):
        """Gets the asin of this ItemLevelFields.  # noqa: E501

        The Amazon Standard Identification Number (ASIN) of the item.  # noqa: E501

        :return: The asin of this ItemLevelFields.  # noqa: E501
        :rtype: str
        """
        return self._asin

    @asin.setter
    def asin(self, asin):
        """Sets the asin of this ItemLevelFields.

        The Amazon Standard Identification Number (ASIN) of the item.  # noqa: E501

        :param asin: The asin of this ItemLevelFields.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and asin is None:
            raise ValueError("Invalid value for `asin`, must not be `None`")  # noqa: E501

        self._asin = asin

    @property
    def additional_inputs(self):
        """Gets the additional_inputs of this ItemLevelFields.  # noqa: E501

        A list of additional inputs.  # noqa: E501

        :return: The additional_inputs of this ItemLevelFields.  # noqa: E501
        :rtype: List[AdditionalInputs]
        """
        return self._additional_inputs

    @additional_inputs.setter
    def additional_inputs(self, additional_inputs):
        """Sets the additional_inputs of this ItemLevelFields.

        A list of additional inputs.  # noqa: E501

        :param additional_inputs: The additional_inputs of this ItemLevelFields.  # noqa: E501
        :type: List[AdditionalInputs]
        """
        if self._configuration.client_side_validation and additional_inputs is None:
            raise ValueError("Invalid value for `additional_inputs`, must not be `None`")  # noqa: E501

        self._additional_inputs = additional_inputs

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ItemLevelFields, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ItemLevelFields):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ItemLevelFields):
            return True

        return self.to_dict() != other.to_dict()
