# coding: utf-8

"""
    Selling Partner API for Messaging

    With the Messaging API you can build applications that send messages to buyers. You can get a list of message types that are available for an order that you specify, then call an operation that sends a message to the buyer for that order. The Messaging API returns responses that are formed according to the <a href=https://tools.ietf.org/html/draft-kelly-json-hal-08>JSON Hypertext Application Language</a> (HAL) standard.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class Attachment(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'upload_destination_id': 'str',
        'file_name': 'str',
    }

    attribute_map = {
        'upload_destination_id': 'uploadDestinationId',
        'file_name': 'fileName',
    }

    def __init__(self, upload_destination_id=None, file_name=None, _configuration=None):  # noqa: E501
        """Attachment - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._upload_destination_id = None
        self._file_name = None
        self.discriminator = None

        self.upload_destination_id = upload_destination_id
        self.file_name = file_name

    @property
    def upload_destination_id(self):
        """Gets the upload_destination_id of this Attachment.  # noqa: E501

        The identifier for the upload destination. To retrieve this value, call the Uploads API [`createUploadDestinationForResource`](https://developer-docs.amazon.com/sp-api/docs/uploads-api-reference#post-uploads2020-11-01uploaddestinationsresource) operation.  # noqa: E501

        :return: The upload_destination_id of this Attachment.  # noqa: E501
        :rtype: str
        """
        return self._upload_destination_id

    @upload_destination_id.setter
    def upload_destination_id(self, upload_destination_id):
        """Sets the upload_destination_id of this Attachment.

        The identifier for the upload destination. To retrieve this value, call the Uploads API [`createUploadDestinationForResource`](https://developer-docs.amazon.com/sp-api/docs/uploads-api-reference#post-uploads2020-11-01uploaddestinationsresource) operation.  # noqa: E501

        :param upload_destination_id: The upload_destination_id of this Attachment.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and upload_destination_id is None:
            raise ValueError("Invalid value for `upload_destination_id`, must not be `None`")  # noqa: E501

        self._upload_destination_id = upload_destination_id

    @property
    def file_name(self):
        """Gets the file_name of this Attachment.  # noqa: E501

        The name of the file, including the extension. This is the file name that will appear in the message. This does not need to match the file name of the file that you uploaded.  # noqa: E501

        :return: The file_name of this Attachment.  # noqa: E501
        :rtype: str
        """
        return self._file_name

    @file_name.setter
    def file_name(self, file_name):
        """Sets the file_name of this Attachment.

        The name of the file, including the extension. This is the file name that will appear in the message. This does not need to match the file name of the file that you uploaded.  # noqa: E501

        :param file_name: The file_name of this Attachment.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and file_name is None:
            raise ValueError("Invalid value for `file_name`, must not be `None`")  # noqa: E501

        self._file_name = file_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Attachment, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Attachment):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Attachment):
            return True

        return self.to_dict() != other.to_dict()
