# coding: utf-8

"""
    Selling Partner API for Messaging

    With the Messaging API you can build applications that send messages to buyers. You can get a list of message types that are available for an order that you specify, then call an operation that sends a message to the buyer for that order. The Messaging API returns responses that are formed according to the <a href=https://tools.ietf.org/html/draft-kelly-json-hal-08>JSON Hypertext Application Language</a> (HAL) standard.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class CreateWarrantyRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'attachments': 'List[Attachment]',
        'coverage_start_date': 'datetime',
        'coverage_end_date': 'datetime',
    }

    attribute_map = {
        'attachments': 'attachments',
        'coverage_start_date': 'coverageStartDate',
        'coverage_end_date': 'coverageEndDate',
    }

    def __init__(self, attachments=None, coverage_start_date=None, coverage_end_date=None, _configuration=None):  # noqa: E501
        """CreateWarrantyRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._attachments = None
        self._coverage_start_date = None
        self._coverage_end_date = None
        self.discriminator = None

        if attachments is not None:
            self.attachments = attachments
        if coverage_start_date is not None:
            self.coverage_start_date = coverage_start_date
        if coverage_end_date is not None:
            self.coverage_end_date = coverage_end_date

    @property
    def attachments(self):
        """Gets the attachments of this CreateWarrantyRequest.  # noqa: E501

        Attachments to include in the message to the buyer. If any text is included in the attachment, the text must be written in the buyer's language of preference, which can be retrieved from the GetAttributes operation.  # noqa: E501

        :return: The attachments of this CreateWarrantyRequest.  # noqa: E501
        :rtype: List[Attachment]
        """
        return self._attachments

    @attachments.setter
    def attachments(self, attachments):
        """Sets the attachments of this CreateWarrantyRequest.

        Attachments to include in the message to the buyer. If any text is included in the attachment, the text must be written in the buyer's language of preference, which can be retrieved from the GetAttributes operation.  # noqa: E501

        :param attachments: The attachments of this CreateWarrantyRequest.  # noqa: E501
        :type: List[Attachment]
        """

        self._attachments = attachments

    @property
    def coverage_start_date(self):
        """Gets the coverage_start_date of this CreateWarrantyRequest.  # noqa: E501

        The start date of the warranty coverage to include in the message to the buyer.  # noqa: E501

        :return: The coverage_start_date of this CreateWarrantyRequest.  # noqa: E501
        :rtype: datetime
        """
        return self._coverage_start_date

    @coverage_start_date.setter
    def coverage_start_date(self, coverage_start_date):
        """Sets the coverage_start_date of this CreateWarrantyRequest.

        The start date of the warranty coverage to include in the message to the buyer.  # noqa: E501

        :param coverage_start_date: The coverage_start_date of this CreateWarrantyRequest.  # noqa: E501
        :type: datetime
        """

        self._coverage_start_date = coverage_start_date

    @property
    def coverage_end_date(self):
        """Gets the coverage_end_date of this CreateWarrantyRequest.  # noqa: E501

        The end date of the warranty coverage to include in the message to the buyer.  # noqa: E501

        :return: The coverage_end_date of this CreateWarrantyRequest.  # noqa: E501
        :rtype: datetime
        """
        return self._coverage_end_date

    @coverage_end_date.setter
    def coverage_end_date(self, coverage_end_date):
        """Sets the coverage_end_date of this CreateWarrantyRequest.

        The end date of the warranty coverage to include in the message to the buyer.  # noqa: E501

        :param coverage_end_date: The coverage_end_date of this CreateWarrantyRequest.  # noqa: E501
        :type: datetime
        """

        self._coverage_end_date = coverage_end_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateWarrantyRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateWarrantyRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateWarrantyRequest):
            return True

        return self.to_dict() != other.to_dict()
