# coding: utf-8

"""
    Selling Partner API for Notifications

    The Selling Partner API for Notifications lets you subscribe to notifications that are relevant to a selling partner's business. Using this API you can create a destination to receive notifications, subscribe to notifications, delete notification subscriptions, and more.  For more information, refer to the [Notifications Use Case Guide](https://developer-docs.amazon.com/sp-api/docs/notifications-api-v1-use-case-guide).

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class SqsResource(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'arn': 'str',
    }

    attribute_map = {
        'arn': 'arn',
    }

    def __init__(self, arn=None, _configuration=None):  # noqa: E501
        """SqsResource - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._arn = None
        self.discriminator = None

        self.arn = arn

    @property
    def arn(self):
        """Gets the arn of this SqsResource.  # noqa: E501

        The Amazon Resource Name (ARN) associated with the SQS queue.  # noqa: E501

        :return: The arn of this SqsResource.  # noqa: E501
        :rtype: str
        """
        return self._arn

    @arn.setter
    def arn(self, arn):
        """Sets the arn of this SqsResource.

        The Amazon Resource Name (ARN) associated with the SQS queue.  # noqa: E501

        :param arn: The arn of this SqsResource.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and arn is None:
            raise ValueError("Invalid value for `arn`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                arn is not None and len(arn) > 1000):
            raise ValueError("Invalid value for `arn`, length must be less than or equal to `1000`")  # noqa: E501
        if (self._configuration.client_side_validation and
                arn is not None and not re.search(r'^arn:aws:sqs:\S+:\S+:\S+', arn)):  # noqa: E501
            raise ValueError(r"Invalid value for `arn`, must be a follow pattern or equal to `/^arn:aws:sqs:\S+:\S+:\S+/`")  # noqa: E501

        self._arn = arn

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SqsResource, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SqsResource):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SqsResource):
            return True

        return self.to_dict() != other.to_dict()
