# coding: utf-8

"""
    Selling Partner API for Orders

    Use the Orders Selling Partner API to programmatically retrieve order information. With this API, you can develop fast, flexible, and custom applications to manage order synchronization, perform order research, and create demand-based decision support tools.   _Note:_ For the JP, AU, and SG marketplaces, the Orders API supports orders from 2016 onward. For all other marketplaces, the Orders API supports orders for the last two years (orders older than this don't show up in the response).

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class UpdateVerificationStatusRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'regulated_order_verification_status': 'UpdateVerificationStatusRequestBody',
    }

    attribute_map = {
        'regulated_order_verification_status': 'regulatedOrderVerificationStatus',
    }

    def __init__(self, regulated_order_verification_status=None, _configuration=None):  # noqa: E501
        """UpdateVerificationStatusRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._regulated_order_verification_status = None
        self.discriminator = None

        self.regulated_order_verification_status = regulated_order_verification_status

    @property
    def regulated_order_verification_status(self):
        """Gets the regulated_order_verification_status of this UpdateVerificationStatusRequest.  # noqa: E501


        :return: The regulated_order_verification_status of this UpdateVerificationStatusRequest.  # noqa: E501
        :rtype: UpdateVerificationStatusRequestBody
        """
        return self._regulated_order_verification_status

    @regulated_order_verification_status.setter
    def regulated_order_verification_status(self, regulated_order_verification_status):
        """Sets the regulated_order_verification_status of this UpdateVerificationStatusRequest.


        :param regulated_order_verification_status: The regulated_order_verification_status of this UpdateVerificationStatusRequest.  # noqa: E501
        :type: UpdateVerificationStatusRequestBody
        """
        if self._configuration.client_side_validation and regulated_order_verification_status is None:
            raise ValueError("Invalid value for `regulated_order_verification_status`, must not be `None`")  # noqa: E501

        self._regulated_order_verification_status = regulated_order_verification_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateVerificationStatusRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateVerificationStatusRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateVerificationStatusRequest):
            return True

        return self.to_dict() != other.to_dict()
