# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer information for Amazon Marketplace products.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GetItemOffersBatchRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'requests': 'List[ItemOffersRequest]',
    }

    attribute_map = {
        'requests': 'requests',
    }

    def __init__(self, requests=None, _configuration=None):  # noqa: E501
        """GetItemOffersBatchRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._requests = None
        self.discriminator = None

        if requests is not None:
            self.requests = requests

    @property
    def requests(self):
        """Gets the requests of this GetItemOffersBatchRequest.  # noqa: E501

        A list of `getListingOffers` batched requests to run.  # noqa: E501

        :return: The requests of this GetItemOffersBatchRequest.  # noqa: E501
        :rtype: List[ItemOffersRequest]
        """
        return self._requests

    @requests.setter
    def requests(self, requests):
        """Sets the requests of this GetItemOffersBatchRequest.

        A list of `getListingOffers` batched requests to run.  # noqa: E501

        :param requests: The requests of this GetItemOffersBatchRequest.  # noqa: E501
        :type: List[ItemOffersRequest]
        """
        if (self._configuration.client_side_validation and
                requests is not None and len(requests) > 20):
            raise ValueError("Invalid value for `requests`, number of items must be less than or equal to `20`")  # noqa: E501
        if (self._configuration.client_side_validation and
                requests is not None and len(requests) < 1):
            raise ValueError("Invalid value for `requests`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._requests = requests

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetItemOffersBatchRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetItemOffersBatchRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetItemOffersBatchRequest):
            return True

        return self.to_dict() != other.to_dict()
