# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer information for Amazon Marketplace products.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GetOffersHttpStatusLine(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'status_code': 'int',
        'reason_phrase': 'str',
    }

    attribute_map = {
        'status_code': 'statusCode',
        'reason_phrase': 'reasonPhrase',
    }

    def __init__(self, status_code=None, reason_phrase=None, _configuration=None):  # noqa: E501
        """GetOffersHttpStatusLine - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._status_code = None
        self._reason_phrase = None
        self.discriminator = None

        if status_code is not None:
            self.status_code = status_code
        if reason_phrase is not None:
            self.reason_phrase = reason_phrase

    @property
    def status_code(self):
        """Gets the status_code of this GetOffersHttpStatusLine.  # noqa: E501

        The HTTP response Status Code.  # noqa: E501

        :return: The status_code of this GetOffersHttpStatusLine.  # noqa: E501
        :rtype: int
        """
        return self._status_code

    @status_code.setter
    def status_code(self, status_code):
        """Sets the status_code of this GetOffersHttpStatusLine.

        The HTTP response Status Code.  # noqa: E501

        :param status_code: The status_code of this GetOffersHttpStatusLine.  # noqa: E501
        :type: int
        """
        if (self._configuration.client_side_validation and
                status_code is not None and status_code > 599):  # noqa: E501
            raise ValueError("Invalid value for `status_code`, must be a value less than or equal to `599`")  # noqa: E501
        if (self._configuration.client_side_validation and
                status_code is not None and status_code < 100):  # noqa: E501
            raise ValueError("Invalid value for `status_code`, must be a value greater than or equal to `100`")  # noqa: E501

        self._status_code = status_code

    @property
    def reason_phrase(self):
        """Gets the reason_phrase of this GetOffersHttpStatusLine.  # noqa: E501

        The HTTP response Reason-Phase.  # noqa: E501

        :return: The reason_phrase of this GetOffersHttpStatusLine.  # noqa: E501
        :rtype: str
        """
        return self._reason_phrase

    @reason_phrase.setter
    def reason_phrase(self, reason_phrase):
        """Sets the reason_phrase of this GetOffersHttpStatusLine.

        The HTTP response Reason-Phase.  # noqa: E501

        :param reason_phrase: The reason_phrase of this GetOffersHttpStatusLine.  # noqa: E501
        :type: str
        """

        self._reason_phrase = reason_phrase

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetOffersHttpStatusLine, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetOffersHttpStatusLine):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetOffersHttpStatusLine):
            return True

        return self.to_dict() != other.to_dict()
