# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer pricing information for Amazon Marketplace products.  For more information, refer to the [Product Pricing v2022-05-01 Use Case Guide](https://developer-docs.amazon.com/sp-api/docs/product-pricing-api-v2022-05-01-use-case-guide).

    The version of the OpenAPI document: 2022-05-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class BatchResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'headers': 'Dict[str, str]',
        'status': 'HttpStatusLine',
    }

    attribute_map = {
        'headers': 'headers',
        'status': 'status',
    }

    def __init__(self, headers=None, status=None, _configuration=None):  # noqa: E501
        """BatchResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._headers = None
        self._status = None
        self.discriminator = None

        self.headers = headers
        self.status = status

    @property
    def headers(self):
        """Gets the headers of this BatchResponse.  # noqa: E501

        A mapping of additional HTTP headers to send or receive for an individual request within a batch.  # noqa: E501

        :return: The headers of this BatchResponse.  # noqa: E501
        :rtype: Dict[str, str]
        """
        return self._headers

    @headers.setter
    def headers(self, headers):
        """Sets the headers of this BatchResponse.

        A mapping of additional HTTP headers to send or receive for an individual request within a batch.  # noqa: E501

        :param headers: The headers of this BatchResponse.  # noqa: E501
        :type: Dict[str, str]
        """
        if self._configuration.client_side_validation and headers is None:
            raise ValueError("Invalid value for `headers`, must not be `None`")  # noqa: E501

        self._headers = headers

    @property
    def status(self):
        """Gets the status of this BatchResponse.  # noqa: E501


        :return: The status of this BatchResponse.  # noqa: E501
        :rtype: HttpStatusLine
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this BatchResponse.


        :param status: The status of this BatchResponse.  # noqa: E501
        :type: HttpStatusLine
        """
        if self._configuration.client_side_validation and status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BatchResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BatchResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BatchResponse):
            return True

        return self.to_dict() != other.to_dict()
