# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer pricing information for Amazon Marketplace products.  For more information, refer to the [Product Pricing v2022-05-01 Use Case Guide](https://developer-docs.amazon.com/sp-api/docs/product-pricing-api-v2022-05-01-use-case-guide).

    The version of the OpenAPI document: 2022-05-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class FeaturedOffer(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'offer_identifier': 'OfferIdentifier',
        'condition': 'Condition',
        'price': 'Price',
    }

    attribute_map = {
        'offer_identifier': 'offerIdentifier',
        'condition': 'condition',
        'price': 'price',
    }

    def __init__(self, offer_identifier=None, condition=None, price=None, _configuration=None):  # noqa: E501
        """FeaturedOffer - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._offer_identifier = None
        self._condition = None
        self._price = None
        self.discriminator = None

        self.offer_identifier = offer_identifier
        if condition is not None:
            self.condition = condition
        if price is not None:
            self.price = price

    @property
    def offer_identifier(self):
        """Gets the offer_identifier of this FeaturedOffer.  # noqa: E501


        :return: The offer_identifier of this FeaturedOffer.  # noqa: E501
        :rtype: OfferIdentifier
        """
        return self._offer_identifier

    @offer_identifier.setter
    def offer_identifier(self, offer_identifier):
        """Sets the offer_identifier of this FeaturedOffer.


        :param offer_identifier: The offer_identifier of this FeaturedOffer.  # noqa: E501
        :type: OfferIdentifier
        """
        if self._configuration.client_side_validation and offer_identifier is None:
            raise ValueError("Invalid value for `offer_identifier`, must not be `None`")  # noqa: E501

        self._offer_identifier = offer_identifier

    @property
    def condition(self):
        """Gets the condition of this FeaturedOffer.  # noqa: E501


        :return: The condition of this FeaturedOffer.  # noqa: E501
        :rtype: Condition
        """
        return self._condition

    @condition.setter
    def condition(self, condition):
        """Sets the condition of this FeaturedOffer.


        :param condition: The condition of this FeaturedOffer.  # noqa: E501
        :type: Condition
        """

        self._condition = condition

    @property
    def price(self):
        """Gets the price of this FeaturedOffer.  # noqa: E501


        :return: The price of this FeaturedOffer.  # noqa: E501
        :rtype: Price
        """
        return self._price

    @price.setter
    def price(self, price):
        """Sets the price of this FeaturedOffer.


        :param price: The price of this FeaturedOffer.  # noqa: E501
        :type: Price
        """

        self._price = price

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FeaturedOffer, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FeaturedOffer):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FeaturedOffer):
            return True

        return self.to_dict() != other.to_dict()
