# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer pricing information for Amazon Marketplace products.  For more information, refer to the [Product Pricing v2022-05-01 Use Case Guide](https://developer-docs.amazon.com/sp-api/docs/product-pricing-api-v2022-05-01-use-case-guide).

    The version of the OpenAPI document: 2022-05-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class FeaturedOfferExpectedPriceRequestParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'marketplace_id': 'str',
        'sku': 'str',
        'segment': 'Segment',
    }

    attribute_map = {
        'marketplace_id': 'marketplaceId',
        'sku': 'sku',
        'segment': 'segment',
    }

    def __init__(self, marketplace_id=None, sku=None, segment=None, _configuration=None):  # noqa: E501
        """FeaturedOfferExpectedPriceRequestParams - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._marketplace_id = None
        self._sku = None
        self._segment = None
        self.discriminator = None

        self.marketplace_id = marketplace_id
        self.sku = sku
        if segment is not None:
            self.segment = segment

    @property
    def marketplace_id(self):
        """Gets the marketplace_id of this FeaturedOfferExpectedPriceRequestParams.  # noqa: E501

        A marketplace identifier. Specifies the marketplace for which data is returned.  # noqa: E501

        :return: The marketplace_id of this FeaturedOfferExpectedPriceRequestParams.  # noqa: E501
        :rtype: str
        """
        return self._marketplace_id

    @marketplace_id.setter
    def marketplace_id(self, marketplace_id):
        """Sets the marketplace_id of this FeaturedOfferExpectedPriceRequestParams.

        A marketplace identifier. Specifies the marketplace for which data is returned.  # noqa: E501

        :param marketplace_id: The marketplace_id of this FeaturedOfferExpectedPriceRequestParams.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and marketplace_id is None:
            raise ValueError("Invalid value for `marketplace_id`, must not be `None`")  # noqa: E501

        self._marketplace_id = marketplace_id

    @property
    def sku(self):
        """Gets the sku of this FeaturedOfferExpectedPriceRequestParams.  # noqa: E501

        The seller SKU of the item.  # noqa: E501

        :return: The sku of this FeaturedOfferExpectedPriceRequestParams.  # noqa: E501
        :rtype: str
        """
        return self._sku

    @sku.setter
    def sku(self, sku):
        """Sets the sku of this FeaturedOfferExpectedPriceRequestParams.

        The seller SKU of the item.  # noqa: E501

        :param sku: The sku of this FeaturedOfferExpectedPriceRequestParams.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and sku is None:
            raise ValueError("Invalid value for `sku`, must not be `None`")  # noqa: E501

        self._sku = sku

    @property
    def segment(self):
        """Gets the segment of this FeaturedOfferExpectedPriceRequestParams.  # noqa: E501


        :return: The segment of this FeaturedOfferExpectedPriceRequestParams.  # noqa: E501
        :rtype: Segment
        """
        return self._segment

    @segment.setter
    def segment(self, segment):
        """Sets the segment of this FeaturedOfferExpectedPriceRequestParams.


        :param segment: The segment of this FeaturedOfferExpectedPriceRequestParams.  # noqa: E501
        :type: Segment
        """

        self._segment = segment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FeaturedOfferExpectedPriceRequestParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FeaturedOfferExpectedPriceRequestParams):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FeaturedOfferExpectedPriceRequestParams):
            return True

        return self.to_dict() != other.to_dict()
