# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer pricing information for Amazon Marketplace products.  For more information, refer to the [Product Pricing v2022-05-01 Use Case Guide](https://developer-docs.amazon.com/sp-api/docs/product-pricing-api-v2022-05-01-use-case-guide).

    The version of the OpenAPI document: 2022-05-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class LowestPricedOffersInput(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'item_condition': 'Condition',
        'offer_type': 'str',
    }

    attribute_map = {
        'item_condition': 'itemCondition',
        'offer_type': 'offerType',
    }

    def __init__(self, item_condition=None, offer_type=None, _configuration=None):  # noqa: E501
        """LowestPricedOffersInput - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._item_condition = None
        self._offer_type = None
        self.discriminator = None

        self.item_condition = item_condition
        self.offer_type = offer_type

    @property
    def item_condition(self):
        """Gets the item_condition of this LowestPricedOffersInput.  # noqa: E501


        :return: The item_condition of this LowestPricedOffersInput.  # noqa: E501
        :rtype: Condition
        """
        return self._item_condition

    @item_condition.setter
    def item_condition(self, item_condition):
        """Sets the item_condition of this LowestPricedOffersInput.


        :param item_condition: The item_condition of this LowestPricedOffersInput.  # noqa: E501
        :type: Condition
        """
        if self._configuration.client_side_validation and item_condition is None:
            raise ValueError("Invalid value for `item_condition`, must not be `None`")  # noqa: E501

        self._item_condition = item_condition

    @property
    def offer_type(self):
        """Gets the offer_type of this LowestPricedOffersInput.  # noqa: E501

        The input parameter specifies the type of offers requested for `LowestPricedOffers`. This applies to `Consumer` and `Business` offers. `Consumer` is the default `offerType`.  # noqa: E501

        :return: The offer_type of this LowestPricedOffersInput.  # noqa: E501
        :rtype: str
        """
        return self._offer_type

    @offer_type.setter
    def offer_type(self, offer_type):
        """Sets the offer_type of this LowestPricedOffersInput.

        The input parameter specifies the type of offers requested for `LowestPricedOffers`. This applies to `Consumer` and `Business` offers. `Consumer` is the default `offerType`.  # noqa: E501

        :param offer_type: The offer_type of this LowestPricedOffersInput.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and offer_type is None:
            raise ValueError("Invalid value for `offer_type`, must not be `None`")  # noqa: E501
        allowed_values = ["CONSUMER"]  # noqa: E501
        if (self._configuration.client_side_validation and
                offer_type not in allowed_values):
            raise ValueError(
                "Invalid value for `offer_type` ({0}), must be one of {1}"  # noqa: E501
                .format(offer_type, allowed_values)
            )

        self._offer_type = offer_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LowestPricedOffersInput, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LowestPricedOffersInput):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LowestPricedOffersInput):
            return True

        return self.to_dict() != other.to_dict()
