# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer pricing information for Amazon Marketplace products.  For more information, refer to the [Product Pricing v2022-05-01 Use Case Guide](https://developer-docs.amazon.com/sp-api/docs/product-pricing-api-v2022-05-01-use-case-guide).

    The version of the OpenAPI document: 2022-05-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class PrimeDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'eligibility': 'str',
    }

    attribute_map = {
        'eligibility': 'eligibility',
    }

    def __init__(self, eligibility=None, _configuration=None):  # noqa: E501
        """PrimeDetails - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._eligibility = None
        self.discriminator = None

        self.eligibility = eligibility

    @property
    def eligibility(self):
        """Gets the eligibility of this PrimeDetails.  # noqa: E501

        Indicates whether the offer is an Amazon Prime offer.  # noqa: E501

        :return: The eligibility of this PrimeDetails.  # noqa: E501
        :rtype: str
        """
        return self._eligibility

    @eligibility.setter
    def eligibility(self, eligibility):
        """Sets the eligibility of this PrimeDetails.

        Indicates whether the offer is an Amazon Prime offer.  # noqa: E501

        :param eligibility: The eligibility of this PrimeDetails.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and eligibility is None:
            raise ValueError("Invalid value for `eligibility`, must not be `None`")  # noqa: E501
        allowed_values = ["NATIONAL", "REGIONAL", "NONE"]  # noqa: E501
        if (self._configuration.client_side_validation and
                eligibility not in allowed_values):
            raise ValueError(
                "Invalid value for `eligibility` ({0}), must be one of {1}"  # noqa: E501
                .format(eligibility, allowed_values)
            )

        self._eligibility = eligibility

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PrimeDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PrimeDetails):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PrimeDetails):
            return True

        return self.to_dict() != other.to_dict()
