# coding: utf-8

"""
    Selling Partner API for Replenishment

    The Selling Partner API for Replenishment (Replenishment API) provides programmatic access to replenishment program metrics and offers. These programs provide recurring delivery of any replenishable item at a frequency chosen by the customer.  The Replenishment API is available worldwide wherever Amazon Subscribe & Save is available or is supported. The API is available to vendors and FBA selling partners.

    The version of the OpenAPI document: 2022-11-07
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ListOfferMetricsRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'pagination': 'ListOfferMetricsRequestPagination',
        'sort': 'ListOfferMetricsRequestSort',
        'filters': 'ListOfferMetricsRequestFilters',
    }

    attribute_map = {
        'pagination': 'pagination',
        'sort': 'sort',
        'filters': 'filters',
    }

    def __init__(self, pagination=None, sort=None, filters=None, _configuration=None):  # noqa: E501
        """ListOfferMetricsRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._pagination = None
        self._sort = None
        self._filters = None
        self.discriminator = None

        self.pagination = pagination
        if sort is not None:
            self.sort = sort
        self.filters = filters

    @property
    def pagination(self):
        """Gets the pagination of this ListOfferMetricsRequest.  # noqa: E501


        :return: The pagination of this ListOfferMetricsRequest.  # noqa: E501
        :rtype: ListOfferMetricsRequestPagination
        """
        return self._pagination

    @pagination.setter
    def pagination(self, pagination):
        """Sets the pagination of this ListOfferMetricsRequest.


        :param pagination: The pagination of this ListOfferMetricsRequest.  # noqa: E501
        :type: ListOfferMetricsRequestPagination
        """
        if self._configuration.client_side_validation and pagination is None:
            raise ValueError("Invalid value for `pagination`, must not be `None`")  # noqa: E501

        self._pagination = pagination

    @property
    def sort(self):
        """Gets the sort of this ListOfferMetricsRequest.  # noqa: E501


        :return: The sort of this ListOfferMetricsRequest.  # noqa: E501
        :rtype: ListOfferMetricsRequestSort
        """
        return self._sort

    @sort.setter
    def sort(self, sort):
        """Sets the sort of this ListOfferMetricsRequest.


        :param sort: The sort of this ListOfferMetricsRequest.  # noqa: E501
        :type: ListOfferMetricsRequestSort
        """

        self._sort = sort

    @property
    def filters(self):
        """Gets the filters of this ListOfferMetricsRequest.  # noqa: E501


        :return: The filters of this ListOfferMetricsRequest.  # noqa: E501
        :rtype: ListOfferMetricsRequestFilters
        """
        return self._filters

    @filters.setter
    def filters(self, filters):
        """Sets the filters of this ListOfferMetricsRequest.


        :param filters: The filters of this ListOfferMetricsRequest.  # noqa: E501
        :type: ListOfferMetricsRequestFilters
        """
        if self._configuration.client_side_validation and filters is None:
            raise ValueError("Invalid value for `filters`, must not be `None`")  # noqa: E501

        self._filters = filters

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ListOfferMetricsRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ListOfferMetricsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ListOfferMetricsRequest):
            return True

        return self.to_dict() != other.to_dict()
