# coding: utf-8

"""
    Selling Partner API for Replenishment

    The Selling Partner API for Replenishment (Replenishment API) provides programmatic access to replenishment program metrics and offers. These programs provide recurring delivery of any replenishable item at a frequency chosen by the customer.  The Replenishment API is available worldwide wherever Amazon Subscribe & Save is available or is supported. The API is available to vendors and FBA selling partners.

    The version of the OpenAPI document: 2022-11-07
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class Metric(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    SHIPPED_SUBSCRIPTION_UNITS = 'SHIPPED_SUBSCRIPTION_UNITS'
    TOTAL_SUBSCRIPTIONS_REVENUE = 'TOTAL_SUBSCRIPTIONS_REVENUE'
    ACTIVE_SUBSCRIPTIONS = 'ACTIVE_SUBSCRIPTIONS'
    NOT_DELIVERED_DUE_TO_OOS = 'NOT_DELIVERED_DUE_TO_OOS'
    SUBSCRIBER_NON_SUBSCRIBER_AVERAGE_REVENUE = 'SUBSCRIBER_NON_SUBSCRIBER_AVERAGE_REVENUE'
    LOST_REVENUE_DUE_TO_OOS = 'LOST_REVENUE_DUE_TO_OOS'
    SUBSCRIBER_NON_SUBSCRIBER_AVERAGE_REORDERS = 'SUBSCRIBER_NON_SUBSCRIBER_AVERAGE_REORDERS'
    COUPONS_REVENUE_PENETRATION = 'COUPONS_REVENUE_PENETRATION'
    REVENUE_BY_DELIVERIES = 'REVENUE_BY_DELIVERIES'
    SUBSCRIBER_RETENTION = 'SUBSCRIBER_RETENTION'
    REVENUE_PENETRATION_BY_SELLER_FUNDING = 'REVENUE_PENETRATION_BY_SELLER_FUNDING'
    SHARE_OF_COUPON_SUBSCRIPTIONS = 'SHARE_OF_COUPON_SUBSCRIPTIONS'

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
    }

    attribute_map = {
    }

    def __init__(self, _configuration=None):  # noqa: E501
        """Metric - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration
        self.discriminator = None

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Metric, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Metric):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Metric):
            return True

        return self.to_dict() != other.to_dict()
