# coding: utf-8

"""
    Selling Partner API for Replenishment

    The Selling Partner API for Replenishment (Replenishment API) provides programmatic access to replenishment program metrics and offers. These programs provide recurring delivery of any replenishable item at a frequency chosen by the customer.  The Replenishment API is available worldwide wherever Amazon Subscribe & Save is available or is supported. The API is available to vendors and FBA selling partners.

    The version of the OpenAPI document: 2022-11-07
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class OfferProgramConfiguration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'preferences': 'OfferProgramConfigurationPreferences',
        'promotions': 'OfferProgramConfigurationPromotions',
        'enrollment_method': 'EnrollmentMethod',
    }

    attribute_map = {
        'preferences': 'preferences',
        'promotions': 'promotions',
        'enrollment_method': 'enrollmentMethod',
    }

    def __init__(self, preferences=None, promotions=None, enrollment_method=None, _configuration=None):  # noqa: E501
        """OfferProgramConfiguration - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._preferences = None
        self._promotions = None
        self._enrollment_method = None
        self.discriminator = None

        if preferences is not None:
            self.preferences = preferences
        if promotions is not None:
            self.promotions = promotions
        if enrollment_method is not None:
            self.enrollment_method = enrollment_method

    @property
    def preferences(self):
        """Gets the preferences of this OfferProgramConfiguration.  # noqa: E501


        :return: The preferences of this OfferProgramConfiguration.  # noqa: E501
        :rtype: OfferProgramConfigurationPreferences
        """
        return self._preferences

    @preferences.setter
    def preferences(self, preferences):
        """Sets the preferences of this OfferProgramConfiguration.


        :param preferences: The preferences of this OfferProgramConfiguration.  # noqa: E501
        :type: OfferProgramConfigurationPreferences
        """

        self._preferences = preferences

    @property
    def promotions(self):
        """Gets the promotions of this OfferProgramConfiguration.  # noqa: E501


        :return: The promotions of this OfferProgramConfiguration.  # noqa: E501
        :rtype: OfferProgramConfigurationPromotions
        """
        return self._promotions

    @promotions.setter
    def promotions(self, promotions):
        """Sets the promotions of this OfferProgramConfiguration.


        :param promotions: The promotions of this OfferProgramConfiguration.  # noqa: E501
        :type: OfferProgramConfigurationPromotions
        """

        self._promotions = promotions

    @property
    def enrollment_method(self):
        """Gets the enrollment_method of this OfferProgramConfiguration.  # noqa: E501


        :return: The enrollment_method of this OfferProgramConfiguration.  # noqa: E501
        :rtype: EnrollmentMethod
        """
        return self._enrollment_method

    @enrollment_method.setter
    def enrollment_method(self, enrollment_method):
        """Sets the enrollment_method of this OfferProgramConfiguration.


        :param enrollment_method: The enrollment_method of this OfferProgramConfiguration.  # noqa: E501
        :type: EnrollmentMethod
        """

        self._enrollment_method = enrollment_method

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OfferProgramConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OfferProgramConfiguration):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OfferProgramConfiguration):
            return True

        return self.to_dict() != other.to_dict()
