# coding: utf-8

"""
    Selling Partner API for Reports

    The Selling Partner API for Reports lets you retrieve and manage a variety of reports that can help selling partners manage their businesses.

    The version of the OpenAPI document: 2021-06-30
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GetReportsResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'reports': 'List[Report]',
        'next_token': 'str',
    }

    attribute_map = {
        'reports': 'reports',
        'next_token': 'nextToken',
    }

    def __init__(self, reports=None, next_token=None, _configuration=None):  # noqa: E501
        """GetReportsResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._reports = None
        self._next_token = None
        self.discriminator = None

        self.reports = reports
        if next_token is not None:
            self.next_token = next_token

    @property
    def reports(self):
        """Gets the reports of this GetReportsResponse.  # noqa: E501

        A list of reports.  # noqa: E501

        :return: The reports of this GetReportsResponse.  # noqa: E501
        :rtype: List[Report]
        """
        return self._reports

    @reports.setter
    def reports(self, reports):
        """Sets the reports of this GetReportsResponse.

        A list of reports.  # noqa: E501

        :param reports: The reports of this GetReportsResponse.  # noqa: E501
        :type: List[Report]
        """
        if self._configuration.client_side_validation and reports is None:
            raise ValueError("Invalid value for `reports`, must not be `None`")  # noqa: E501

        self._reports = reports

    @property
    def next_token(self):
        """Gets the next_token of this GetReportsResponse.  # noqa: E501

        Returned when the number of results exceeds `pageSize`. To get the next page of results, call `getReports` with this token as the only parameter.  # noqa: E501

        :return: The next_token of this GetReportsResponse.  # noqa: E501
        :rtype: str
        """
        return self._next_token

    @next_token.setter
    def next_token(self, next_token):
        """Sets the next_token of this GetReportsResponse.

        Returned when the number of results exceeds `pageSize`. To get the next page of results, call `getReports` with this token as the only parameter.  # noqa: E501

        :param next_token: The next_token of this GetReportsResponse.  # noqa: E501
        :type: str
        """

        self._next_token = next_token

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetReportsResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetReportsResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetReportsResponse):
            return True

        return self.to_dict() != other.to_dict()
