# coding: utf-8

"""
    Selling Partner API for Services

    With the Services API, you can build applications that help service providers get and modify their service orders and manage their resources.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class AppointmentSlotReport(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'scheduling_type': 'str',
        'start_time': 'datetime',
        'end_time': 'datetime',
        'appointment_slots': 'List[AppointmentSlot]',
    }

    attribute_map = {
        'scheduling_type': 'schedulingType',
        'start_time': 'startTime',
        'end_time': 'endTime',
        'appointment_slots': 'appointmentSlots',
    }

    def __init__(self, scheduling_type=None, start_time=None, end_time=None, appointment_slots=None, _configuration=None):  # noqa: E501
        """AppointmentSlotReport - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._scheduling_type = None
        self._start_time = None
        self._end_time = None
        self._appointment_slots = None
        self.discriminator = None

        if scheduling_type is not None:
            self.scheduling_type = scheduling_type
        if start_time is not None:
            self.start_time = start_time
        if end_time is not None:
            self.end_time = end_time
        if appointment_slots is not None:
            self.appointment_slots = appointment_slots

    @property
    def scheduling_type(self):
        """Gets the scheduling_type of this AppointmentSlotReport.  # noqa: E501

        Defines the type of slots.  # noqa: E501

        :return: The scheduling_type of this AppointmentSlotReport.  # noqa: E501
        :rtype: str
        """
        return self._scheduling_type

    @scheduling_type.setter
    def scheduling_type(self, scheduling_type):
        """Sets the scheduling_type of this AppointmentSlotReport.

        Defines the type of slots.  # noqa: E501

        :param scheduling_type: The scheduling_type of this AppointmentSlotReport.  # noqa: E501
        :type: str
        """
        allowed_values = ["REAL_TIME_SCHEDULING", "NON_REAL_TIME_SCHEDULING"]  # noqa: E501
        if (self._configuration.client_side_validation and
                scheduling_type not in allowed_values):
            raise ValueError(
                "Invalid value for `scheduling_type` ({0}), must be one of {1}"  # noqa: E501
                .format(scheduling_type, allowed_values)
            )

        self._scheduling_type = scheduling_type

    @property
    def start_time(self):
        """Gets the start_time of this AppointmentSlotReport.  # noqa: E501

        Start Time from which the appointment slots are generated in ISO 8601 format.  # noqa: E501

        :return: The start_time of this AppointmentSlotReport.  # noqa: E501
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this AppointmentSlotReport.

        Start Time from which the appointment slots are generated in ISO 8601 format.  # noqa: E501

        :param start_time: The start_time of this AppointmentSlotReport.  # noqa: E501
        :type: datetime
        """

        self._start_time = start_time

    @property
    def end_time(self):
        """Gets the end_time of this AppointmentSlotReport.  # noqa: E501

        End Time up to which the appointment slots are generated in ISO 8601 format.  # noqa: E501

        :return: The end_time of this AppointmentSlotReport.  # noqa: E501
        :rtype: datetime
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this AppointmentSlotReport.

        End Time up to which the appointment slots are generated in ISO 8601 format.  # noqa: E501

        :param end_time: The end_time of this AppointmentSlotReport.  # noqa: E501
        :type: datetime
        """

        self._end_time = end_time

    @property
    def appointment_slots(self):
        """Gets the appointment_slots of this AppointmentSlotReport.  # noqa: E501

        A list of time windows along with associated capacity in which the service can be performed.  # noqa: E501

        :return: The appointment_slots of this AppointmentSlotReport.  # noqa: E501
        :rtype: List[AppointmentSlot]
        """
        return self._appointment_slots

    @appointment_slots.setter
    def appointment_slots(self, appointment_slots):
        """Sets the appointment_slots of this AppointmentSlotReport.

        A list of time windows along with associated capacity in which the service can be performed.  # noqa: E501

        :param appointment_slots: The appointment_slots of this AppointmentSlotReport.  # noqa: E501
        :type: List[AppointmentSlot]
        """

        self._appointment_slots = appointment_slots

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AppointmentSlotReport, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AppointmentSlotReport):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AppointmentSlotReport):
            return True

        return self.to_dict() != other.to_dict()
