# coding: utf-8

"""
    Selling Partner API for Services

    With the Services API, you can build applications that help service providers get and modify their service orders and manage their resources.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class SetAppointmentResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'appointment_id': 'str',
        'warnings': 'List[Warning]',
        'errors': 'List[Error]',
    }

    attribute_map = {
        'appointment_id': 'appointmentId',
        'warnings': 'warnings',
        'errors': 'errors',
    }

    def __init__(self, appointment_id=None, warnings=None, errors=None, _configuration=None):  # noqa: E501
        """SetAppointmentResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._appointment_id = None
        self._warnings = None
        self._errors = None
        self.discriminator = None

        if appointment_id is not None:
            self.appointment_id = appointment_id
        if warnings is not None:
            self.warnings = warnings
        if errors is not None:
            self.errors = errors

    @property
    def appointment_id(self):
        """Gets the appointment_id of this SetAppointmentResponse.  # noqa: E501

        The appointment identifier.  # noqa: E501

        :return: The appointment_id of this SetAppointmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._appointment_id

    @appointment_id.setter
    def appointment_id(self, appointment_id):
        """Sets the appointment_id of this SetAppointmentResponse.

        The appointment identifier.  # noqa: E501

        :param appointment_id: The appointment_id of this SetAppointmentResponse.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                appointment_id is not None and len(appointment_id) > 100):
            raise ValueError("Invalid value for `appointment_id`, length must be less than or equal to `100`")  # noqa: E501
        if (self._configuration.client_side_validation and
                appointment_id is not None and len(appointment_id) < 5):
            raise ValueError("Invalid value for `appointment_id`, length must be greater than or equal to `5`")  # noqa: E501

        self._appointment_id = appointment_id

    @property
    def warnings(self):
        """Gets the warnings of this SetAppointmentResponse.  # noqa: E501

        A list of warnings returned in the sucessful execution response of an API request.  # noqa: E501

        :return: The warnings of this SetAppointmentResponse.  # noqa: E501
        :rtype: List[Warning]
        """
        return self._warnings

    @warnings.setter
    def warnings(self, warnings):
        """Sets the warnings of this SetAppointmentResponse.

        A list of warnings returned in the sucessful execution response of an API request.  # noqa: E501

        :param warnings: The warnings of this SetAppointmentResponse.  # noqa: E501
        :type: List[Warning]
        """

        self._warnings = warnings

    @property
    def errors(self):
        """Gets the errors of this SetAppointmentResponse.  # noqa: E501

        A list of error responses returned when a request is unsuccessful.  # noqa: E501

        :return: The errors of this SetAppointmentResponse.  # noqa: E501
        :rtype: List[Error]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """Sets the errors of this SetAppointmentResponse.

        A list of error responses returned when a request is unsuccessful.  # noqa: E501

        :param errors: The errors of this SetAppointmentResponse.  # noqa: E501
        :type: List[Error]
        """

        self._errors = errors

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SetAppointmentResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SetAppointmentResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SetAppointmentResponse):
            return True

        return self.to_dict() != other.to_dict()
