# coding: utf-8

"""
    Selling Partner API for Shipment Invoicing

    The Selling Partner API for Shipment Invoicing helps you programmatically retrieve shipment invoice information in the Brazil marketplace for a selling partner’s Fulfillment by Amazon (FBA) orders.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ShipmentInvoiceStatusInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amazon_shipment_id': 'str',
        'invoice_status': 'ShipmentInvoiceStatus',
    }

    attribute_map = {
        'amazon_shipment_id': 'AmazonShipmentId',
        'invoice_status': 'InvoiceStatus',
    }

    def __init__(self, amazon_shipment_id=None, invoice_status=None, _configuration=None):  # noqa: E501
        """ShipmentInvoiceStatusInfo - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._amazon_shipment_id = None
        self._invoice_status = None
        self.discriminator = None

        if amazon_shipment_id is not None:
            self.amazon_shipment_id = amazon_shipment_id
        if invoice_status is not None:
            self.invoice_status = invoice_status

    @property
    def amazon_shipment_id(self):
        """Gets the amazon_shipment_id of this ShipmentInvoiceStatusInfo.  # noqa: E501

        The Amazon-defined shipment identifier.  # noqa: E501

        :return: The amazon_shipment_id of this ShipmentInvoiceStatusInfo.  # noqa: E501
        :rtype: str
        """
        return self._amazon_shipment_id

    @amazon_shipment_id.setter
    def amazon_shipment_id(self, amazon_shipment_id):
        """Sets the amazon_shipment_id of this ShipmentInvoiceStatusInfo.

        The Amazon-defined shipment identifier.  # noqa: E501

        :param amazon_shipment_id: The amazon_shipment_id of this ShipmentInvoiceStatusInfo.  # noqa: E501
        :type: str
        """

        self._amazon_shipment_id = amazon_shipment_id

    @property
    def invoice_status(self):
        """Gets the invoice_status of this ShipmentInvoiceStatusInfo.  # noqa: E501


        :return: The invoice_status of this ShipmentInvoiceStatusInfo.  # noqa: E501
        :rtype: ShipmentInvoiceStatus
        """
        return self._invoice_status

    @invoice_status.setter
    def invoice_status(self, invoice_status):
        """Sets the invoice_status of this ShipmentInvoiceStatusInfo.


        :param invoice_status: The invoice_status of this ShipmentInvoiceStatusInfo.  # noqa: E501
        :type: ShipmentInvoiceStatus
        """

        self._invoice_status = invoice_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ShipmentInvoiceStatusInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ShipmentInvoiceStatusInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ShipmentInvoiceStatusInfo):
            return True

        return self.to_dict() != other.to_dict()
