# coding: utf-8

# flake8: noqa
"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


# import models into model package
from spapi.models.shipping_v2.access_point import AccessPoint
from spapi.models.shipping_v2.access_point_details import AccessPointDetails
from spapi.models.shipping_v2.access_point_type import AccessPointType
from spapi.models.shipping_v2.accessibility_attributes import AccessibilityAttributes
from spapi.models.shipping_v2.account_status import AccountStatus
from spapi.models.shipping_v2.account_type import AccountType
from spapi.models.shipping_v2.active_account import ActiveAccount
from spapi.models.shipping_v2.address import Address
from spapi.models.shipping_v2.amazon_order_details import AmazonOrderDetails
from spapi.models.shipping_v2.amazon_shipment_details import AmazonShipmentDetails
from spapi.models.shipping_v2.available_value_added_service_group import AvailableValueAddedServiceGroup
from spapi.models.shipping_v2.benefits import Benefits
from spapi.models.shipping_v2.cancel_shipment_response import CancelShipmentResponse
from spapi.models.shipping_v2.carrier import Carrier
from spapi.models.shipping_v2.carrier_account import CarrierAccount
from spapi.models.shipping_v2.carrier_account_attribute import CarrierAccountAttribute
from spapi.models.shipping_v2.carrier_account_input import CarrierAccountInput
from spapi.models.shipping_v2.channel_details import ChannelDetails
from spapi.models.shipping_v2.channel_type import ChannelType
from spapi.models.shipping_v2.charge_component import ChargeComponent
from spapi.models.shipping_v2.claim_reason import ClaimReason
from spapi.models.shipping_v2.client_reference_detail import ClientReferenceDetail
from spapi.models.shipping_v2.collect_on_delivery import CollectOnDelivery
from spapi.models.shipping_v2.collection_forms_history_record import CollectionFormsHistoryRecord
from spapi.models.shipping_v2.collections_form_document import CollectionsFormDocument
from spapi.models.shipping_v2.create_claim_request import CreateClaimRequest
from spapi.models.shipping_v2.create_claim_response import CreateClaimResponse
from spapi.models.shipping_v2.currency import Currency
from spapi.models.shipping_v2.dangerous_goods_details import DangerousGoodsDetails
from spapi.models.shipping_v2.date_range import DateRange
from spapi.models.shipping_v2.detail_codes import DetailCodes
from spapi.models.shipping_v2.dimensions import Dimensions
from spapi.models.shipping_v2.direct_fulfillment_item_identifiers import DirectFulfillmentItemIdentifiers
from spapi.models.shipping_v2.direct_purchase_request import DirectPurchaseRequest
from spapi.models.shipping_v2.direct_purchase_response import DirectPurchaseResponse
from spapi.models.shipping_v2.direct_purchase_result import DirectPurchaseResult
from spapi.models.shipping_v2.document_format import DocumentFormat
from spapi.models.shipping_v2.document_size import DocumentSize
from spapi.models.shipping_v2.document_type import DocumentType
from spapi.models.shipping_v2.error import Error
from spapi.models.shipping_v2.error_list import ErrorList
from spapi.models.shipping_v2.event import Event
from spapi.models.shipping_v2.event_code import EventCode
from spapi.models.shipping_v2.exception_operating_hours import ExceptionOperatingHours
from spapi.models.shipping_v2.excluded_benefit import ExcludedBenefit
from spapi.models.shipping_v2.generate_collection_form_request import GenerateCollectionFormRequest
from spapi.models.shipping_v2.generate_collection_form_response import GenerateCollectionFormResponse
from spapi.models.shipping_v2.generation_status import GenerationStatus
from spapi.models.shipping_v2.geocode import Geocode
from spapi.models.shipping_v2.get_access_points_response import GetAccessPointsResponse
from spapi.models.shipping_v2.get_access_points_result import GetAccessPointsResult
from spapi.models.shipping_v2.get_additional_inputs_response import GetAdditionalInputsResponse
from spapi.models.shipping_v2.get_carrier_account_form_inputs_response import GetCarrierAccountFormInputsResponse
from spapi.models.shipping_v2.get_carrier_accounts_request import GetCarrierAccountsRequest
from spapi.models.shipping_v2.get_carrier_accounts_response import GetCarrierAccountsResponse
from spapi.models.shipping_v2.get_collection_form_history_request import GetCollectionFormHistoryRequest
from spapi.models.shipping_v2.get_collection_form_history_response import GetCollectionFormHistoryResponse
from spapi.models.shipping_v2.get_collection_form_response import GetCollectionFormResponse
from spapi.models.shipping_v2.get_rates_request import GetRatesRequest
from spapi.models.shipping_v2.get_rates_response import GetRatesResponse
from spapi.models.shipping_v2.get_rates_result import GetRatesResult
from spapi.models.shipping_v2.get_shipment_documents_response import GetShipmentDocumentsResponse
from spapi.models.shipping_v2.get_shipment_documents_result import GetShipmentDocumentsResult
from spapi.models.shipping_v2.get_tracking_response import GetTrackingResponse
from spapi.models.shipping_v2.get_tracking_result import GetTrackingResult
from spapi.models.shipping_v2.get_unmanifested_shipments_request import GetUnmanifestedShipmentsRequest
from spapi.models.shipping_v2.get_unmanifested_shipments_response import GetUnmanifestedShipmentsResponse
from spapi.models.shipping_v2.goods_owner import GoodsOwner
from spapi.models.shipping_v2.ineligibility_reason import IneligibilityReason
from spapi.models.shipping_v2.ineligibility_reason_code import IneligibilityReasonCode
from spapi.models.shipping_v2.ineligible_rate import IneligibleRate
from spapi.models.shipping_v2.input_type import InputType
from spapi.models.shipping_v2.invoice_details import InvoiceDetails
from spapi.models.shipping_v2.item import Item
from spapi.models.shipping_v2.label_attribute import LabelAttribute
from spapi.models.shipping_v2.link_carrier_account_request import LinkCarrierAccountRequest
from spapi.models.shipping_v2.link_carrier_account_response import LinkCarrierAccountResponse
from spapi.models.shipping_v2.linkable_account_type import LinkableAccountType
from spapi.models.shipping_v2.linkable_carrier import LinkableCarrier
from spapi.models.shipping_v2.liquid_volume import LiquidVolume
from spapi.models.shipping_v2.location import Location
from spapi.models.shipping_v2.ndr_action import NdrAction
from spapi.models.shipping_v2.ndr_request_data import NdrRequestData
from spapi.models.shipping_v2.one_click_shipment_request import OneClickShipmentRequest
from spapi.models.shipping_v2.one_click_shipment_response import OneClickShipmentResponse
from spapi.models.shipping_v2.one_click_shipment_result import OneClickShipmentResult
from spapi.models.shipping_v2.one_click_shipment_value_added_service import OneClickShipmentValueAddedService
from spapi.models.shipping_v2.operating_hours import OperatingHours
from spapi.models.shipping_v2.package import Package
from spapi.models.shipping_v2.package_document import PackageDocument
from spapi.models.shipping_v2.package_document_detail import PackageDocumentDetail
from spapi.models.shipping_v2.payment_type import PaymentType
from spapi.models.shipping_v2.print_option import PrintOption
from spapi.models.shipping_v2.promise import Promise
from spapi.models.shipping_v2.purchase_shipment_request import PurchaseShipmentRequest
from spapi.models.shipping_v2.purchase_shipment_response import PurchaseShipmentResponse
from spapi.models.shipping_v2.purchase_shipment_result import PurchaseShipmentResult
from spapi.models.shipping_v2.rate import Rate
from spapi.models.shipping_v2.rate_item import RateItem
from spapi.models.shipping_v2.rate_item_id import RateItemID
from spapi.models.shipping_v2.rate_item_type import RateItemType
from spapi.models.shipping_v2.requested_document_specification import RequestedDocumentSpecification
from spapi.models.shipping_v2.requested_label_customization import RequestedLabelCustomization
from spapi.models.shipping_v2.requested_value_added_service import RequestedValueAddedService
from spapi.models.shipping_v2.service import Service
from spapi.models.shipping_v2.service_selection import ServiceSelection
from spapi.models.shipping_v2.settlement_type import SettlementType
from spapi.models.shipping_v2.shipment_type import ShipmentType
from spapi.models.shipping_v2.shipper_instruction import ShipperInstruction
from spapi.models.shipping_v2.status import Status
from spapi.models.shipping_v2.submit_ndr_feedback_request import SubmitNdrFeedbackRequest
from spapi.models.shipping_v2.supported_document_detail import SupportedDocumentDetail
from spapi.models.shipping_v2.supported_document_specification import SupportedDocumentSpecification
from spapi.models.shipping_v2.tax_detail import TaxDetail
from spapi.models.shipping_v2.tax_type import TaxType
from spapi.models.shipping_v2.time_of_day import TimeOfDay
from spapi.models.shipping_v2.time_window import TimeWindow
from spapi.models.shipping_v2.tracking_detail_codes import TrackingDetailCodes
from spapi.models.shipping_v2.tracking_summary import TrackingSummary
from spapi.models.shipping_v2.unlink_carrier_account_request import UnlinkCarrierAccountRequest
from spapi.models.shipping_v2.unlink_carrier_account_response import UnlinkCarrierAccountResponse
from spapi.models.shipping_v2.unmanifested_carrier_information import UnmanifestedCarrierInformation
from spapi.models.shipping_v2.unmanifested_shipment_location import UnmanifestedShipmentLocation
from spapi.models.shipping_v2.validation_metadata import ValidationMetadata
from spapi.models.shipping_v2.value_added_service import ValueAddedService
from spapi.models.shipping_v2.value_added_service_details import ValueAddedServiceDetails
from spapi.models.shipping_v2.weight import Weight
