# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class AccessibilityAttributes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'distance': 'str',
        'drive_time': 'int',
    }

    attribute_map = {
        'distance': 'distance',
        'drive_time': 'driveTime',
    }

    def __init__(self, distance=None, drive_time=None, _configuration=None):  # noqa: E501
        """AccessibilityAttributes - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._distance = None
        self._drive_time = None
        self.discriminator = None

        if distance is not None:
            self.distance = distance
        if drive_time is not None:
            self.drive_time = drive_time

    @property
    def distance(self):
        """Gets the distance of this AccessibilityAttributes.  # noqa: E501

        The approximate distance of access point from input postalCode's centroid.  # noqa: E501

        :return: The distance of this AccessibilityAttributes.  # noqa: E501
        :rtype: str
        """
        return self._distance

    @distance.setter
    def distance(self, distance):
        """Sets the distance of this AccessibilityAttributes.

        The approximate distance of access point from input postalCode's centroid.  # noqa: E501

        :param distance: The distance of this AccessibilityAttributes.  # noqa: E501
        :type: str
        """

        self._distance = distance

    @property
    def drive_time(self):
        """Gets the drive_time of this AccessibilityAttributes.  # noqa: E501

        The approximate (static) drive time from input postal code's centroid.  # noqa: E501

        :return: The drive_time of this AccessibilityAttributes.  # noqa: E501
        :rtype: int
        """
        return self._drive_time

    @drive_time.setter
    def drive_time(self, drive_time):
        """Sets the drive_time of this AccessibilityAttributes.

        The approximate (static) drive time from input postal code's centroid.  # noqa: E501

        :param drive_time: The drive_time of this AccessibilityAttributes.  # noqa: E501
        :type: int
        """

        self._drive_time = drive_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AccessibilityAttributes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccessibilityAttributes):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AccessibilityAttributes):
            return True

        return self.to_dict() != other.to_dict()
