# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class Benefits(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'included_benefits': 'List[str]',
        'excluded_benefits': 'List[ExcludedBenefit]',
    }

    attribute_map = {
        'included_benefits': 'includedBenefits',
        'excluded_benefits': 'excludedBenefits',
    }

    def __init__(self, included_benefits=None, excluded_benefits=None, _configuration=None):  # noqa: E501
        """Benefits - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._included_benefits = None
        self._excluded_benefits = None
        self.discriminator = None

        self.included_benefits = included_benefits
        self.excluded_benefits = excluded_benefits

    @property
    def included_benefits(self):
        """Gets the included_benefits of this Benefits.  # noqa: E501

        A list of included benefits.  # noqa: E501

        :return: The included_benefits of this Benefits.  # noqa: E501
        :rtype: List[str]
        """
        return self._included_benefits

    @included_benefits.setter
    def included_benefits(self, included_benefits):
        """Sets the included_benefits of this Benefits.

        A list of included benefits.  # noqa: E501

        :param included_benefits: The included_benefits of this Benefits.  # noqa: E501
        :type: List[str]
        """
        if self._configuration.client_side_validation and included_benefits is None:
            raise ValueError("Invalid value for `included_benefits`, must not be `None`")  # noqa: E501

        self._included_benefits = included_benefits

    @property
    def excluded_benefits(self):
        """Gets the excluded_benefits of this Benefits.  # noqa: E501

        A list of excluded benefit. Refer to the ExcludeBenefit object for further documentation  # noqa: E501

        :return: The excluded_benefits of this Benefits.  # noqa: E501
        :rtype: List[ExcludedBenefit]
        """
        return self._excluded_benefits

    @excluded_benefits.setter
    def excluded_benefits(self, excluded_benefits):
        """Sets the excluded_benefits of this Benefits.

        A list of excluded benefit. Refer to the ExcludeBenefit object for further documentation  # noqa: E501

        :param excluded_benefits: The excluded_benefits of this Benefits.  # noqa: E501
        :type: List[ExcludedBenefit]
        """
        if self._configuration.client_side_validation and excluded_benefits is None:
            raise ValueError("Invalid value for `excluded_benefits`, must not be `None`")  # noqa: E501

        self._excluded_benefits = excluded_benefits

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Benefits, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Benefits):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Benefits):
            return True

        return self.to_dict() != other.to_dict()
