# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ClientReferenceDetail(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'client_reference_type': 'str',
        'client_reference_id': 'str',
    }

    attribute_map = {
        'client_reference_type': 'clientReferenceType',
        'client_reference_id': 'clientReferenceId',
    }

    def __init__(self, client_reference_type=None, client_reference_id=None, _configuration=None):  # noqa: E501
        """ClientReferenceDetail - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._client_reference_type = None
        self._client_reference_id = None
        self.discriminator = None

        self.client_reference_type = client_reference_type
        self.client_reference_id = client_reference_id

    @property
    def client_reference_type(self):
        """Gets the client_reference_type of this ClientReferenceDetail.  # noqa: E501

        Client Reference type.  # noqa: E501

        :return: The client_reference_type of this ClientReferenceDetail.  # noqa: E501
        :rtype: str
        """
        return self._client_reference_type

    @client_reference_type.setter
    def client_reference_type(self, client_reference_type):
        """Sets the client_reference_type of this ClientReferenceDetail.

        Client Reference type.  # noqa: E501

        :param client_reference_type: The client_reference_type of this ClientReferenceDetail.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and client_reference_type is None:
            raise ValueError("Invalid value for `client_reference_type`, must not be `None`")  # noqa: E501
        allowed_values = ["IntegratorShipperId", "IntegratorMerchantId"]  # noqa: E501
        if (self._configuration.client_side_validation and
                client_reference_type not in allowed_values):
            raise ValueError(
                "Invalid value for `client_reference_type` ({0}), must be one of {1}"  # noqa: E501
                .format(client_reference_type, allowed_values)
            )

        self._client_reference_type = client_reference_type

    @property
    def client_reference_id(self):
        """Gets the client_reference_id of this ClientReferenceDetail.  # noqa: E501

        The Client Reference Id.  # noqa: E501

        :return: The client_reference_id of this ClientReferenceDetail.  # noqa: E501
        :rtype: str
        """
        return self._client_reference_id

    @client_reference_id.setter
    def client_reference_id(self, client_reference_id):
        """Sets the client_reference_id of this ClientReferenceDetail.

        The Client Reference Id.  # noqa: E501

        :param client_reference_id: The client_reference_id of this ClientReferenceDetail.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and client_reference_id is None:
            raise ValueError("Invalid value for `client_reference_id`, must not be `None`")  # noqa: E501

        self._client_reference_id = client_reference_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ClientReferenceDetail, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClientReferenceDetail):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ClientReferenceDetail):
            return True

        return self.to_dict() != other.to_dict()
