# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class CollectionsFormDocument(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'base64_encoded_content': 'str',
        'document_format': 'str',
    }

    attribute_map = {
        'base64_encoded_content': 'base64EncodedContent',
        'document_format': 'documentFormat',
    }

    def __init__(self, base64_encoded_content=None, document_format=None, _configuration=None):  # noqa: E501
        """CollectionsFormDocument - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._base64_encoded_content = None
        self._document_format = None
        self.discriminator = None

        if base64_encoded_content is not None:
            self.base64_encoded_content = base64_encoded_content
        if document_format is not None:
            self.document_format = document_format

    @property
    def base64_encoded_content(self):
        """Gets the base64_encoded_content of this CollectionsFormDocument.  # noqa: E501

        Base64 document Value of Collection.  # noqa: E501

        :return: The base64_encoded_content of this CollectionsFormDocument.  # noqa: E501
        :rtype: str
        """
        return self._base64_encoded_content

    @base64_encoded_content.setter
    def base64_encoded_content(self, base64_encoded_content):
        """Sets the base64_encoded_content of this CollectionsFormDocument.

        Base64 document Value of Collection.  # noqa: E501

        :param base64_encoded_content: The base64_encoded_content of this CollectionsFormDocument.  # noqa: E501
        :type: str
        """

        self._base64_encoded_content = base64_encoded_content

    @property
    def document_format(self):
        """Gets the document_format of this CollectionsFormDocument.  # noqa: E501

        Collection Document format is PDF.  # noqa: E501

        :return: The document_format of this CollectionsFormDocument.  # noqa: E501
        :rtype: str
        """
        return self._document_format

    @document_format.setter
    def document_format(self, document_format):
        """Sets the document_format of this CollectionsFormDocument.

        Collection Document format is PDF.  # noqa: E501

        :param document_format: The document_format of this CollectionsFormDocument.  # noqa: E501
        :type: str
        """

        self._document_format = document_format

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CollectionsFormDocument, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CollectionsFormDocument):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CollectionsFormDocument):
            return True

        return self.to_dict() != other.to_dict()
