# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class DirectFulfillmentItemIdentifiers(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'line_item_id': 'str',
        'piece_number': 'str',
    }

    attribute_map = {
        'line_item_id': 'lineItemID',
        'piece_number': 'pieceNumber',
    }

    def __init__(self, line_item_id=None, piece_number=None, _configuration=None):  # noqa: E501
        """DirectFulfillmentItemIdentifiers - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._line_item_id = None
        self._piece_number = None
        self.discriminator = None

        self.line_item_id = line_item_id
        if piece_number is not None:
            self.piece_number = piece_number

    @property
    def line_item_id(self):
        """Gets the line_item_id of this DirectFulfillmentItemIdentifiers.  # noqa: E501

        A unique identifier for an item provided by the client for a direct fulfillment shipment. This is only populated for direct fulfillment multi-piece shipments. It is required if a vendor wants to change the configuration of the packages in which the purchase order is shipped.  # noqa: E501

        :return: The line_item_id of this DirectFulfillmentItemIdentifiers.  # noqa: E501
        :rtype: str
        """
        return self._line_item_id

    @line_item_id.setter
    def line_item_id(self, line_item_id):
        """Sets the line_item_id of this DirectFulfillmentItemIdentifiers.

        A unique identifier for an item provided by the client for a direct fulfillment shipment. This is only populated for direct fulfillment multi-piece shipments. It is required if a vendor wants to change the configuration of the packages in which the purchase order is shipped.  # noqa: E501

        :param line_item_id: The line_item_id of this DirectFulfillmentItemIdentifiers.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and line_item_id is None:
            raise ValueError("Invalid value for `line_item_id`, must not be `None`")  # noqa: E501

        self._line_item_id = line_item_id

    @property
    def piece_number(self):
        """Gets the piece_number of this DirectFulfillmentItemIdentifiers.  # noqa: E501

        A unique identifier for an item provided by the client for a direct fulfillment shipment. This is only populated if a single line item has multiple pieces. Defaults to 1.  # noqa: E501

        :return: The piece_number of this DirectFulfillmentItemIdentifiers.  # noqa: E501
        :rtype: str
        """
        return self._piece_number

    @piece_number.setter
    def piece_number(self, piece_number):
        """Sets the piece_number of this DirectFulfillmentItemIdentifiers.

        A unique identifier for an item provided by the client for a direct fulfillment shipment. This is only populated if a single line item has multiple pieces. Defaults to 1.  # noqa: E501

        :param piece_number: The piece_number of this DirectFulfillmentItemIdentifiers.  # noqa: E501
        :type: str
        """

        self._piece_number = piece_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DirectFulfillmentItemIdentifiers, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DirectFulfillmentItemIdentifiers):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DirectFulfillmentItemIdentifiers):
            return True

        return self.to_dict() != other.to_dict()
