# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ExcludedBenefit(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'benefit': 'str',
        'reason_codes': 'List[str]',
    }

    attribute_map = {
        'benefit': 'benefit',
        'reason_codes': 'reasonCodes',
    }

    def __init__(self, benefit=None, reason_codes=None, _configuration=None):  # noqa: E501
        """ExcludedBenefit - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._benefit = None
        self._reason_codes = None
        self.discriminator = None

        self.benefit = benefit
        if reason_codes is not None:
            self.reason_codes = reason_codes

    @property
    def benefit(self):
        """Gets the benefit of this ExcludedBenefit.  # noqa: E501

        benefit  # noqa: E501

        :return: The benefit of this ExcludedBenefit.  # noqa: E501
        :rtype: str
        """
        return self._benefit

    @benefit.setter
    def benefit(self, benefit):
        """Sets the benefit of this ExcludedBenefit.

        benefit  # noqa: E501

        :param benefit: The benefit of this ExcludedBenefit.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and benefit is None:
            raise ValueError("Invalid value for `benefit`, must not be `None`")  # noqa: E501

        self._benefit = benefit

    @property
    def reason_codes(self):
        """Gets the reason_codes of this ExcludedBenefit.  # noqa: E501

        List of reasons (eg. LATE_DELIVERY_RISK, etc.) indicating why a benefit is excluded for a shipping offer.  # noqa: E501

        :return: The reason_codes of this ExcludedBenefit.  # noqa: E501
        :rtype: List[str]
        """
        return self._reason_codes

    @reason_codes.setter
    def reason_codes(self, reason_codes):
        """Sets the reason_codes of this ExcludedBenefit.

        List of reasons (eg. LATE_DELIVERY_RISK, etc.) indicating why a benefit is excluded for a shipping offer.  # noqa: E501

        :param reason_codes: The reason_codes of this ExcludedBenefit.  # noqa: E501
        :type: List[str]
        """
        if (self._configuration.client_side_validation and
                reason_codes is not None and len(reason_codes) < 1):
            raise ValueError("Invalid value for `reason_codes`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._reason_codes = reason_codes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ExcludedBenefit, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExcludedBenefit):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ExcludedBenefit):
            return True

        return self.to_dict() != other.to_dict()
