# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GetAccessPointsResult(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'access_points_map': 'Dict[str, List[AccessPoint]]',
    }

    attribute_map = {
        'access_points_map': 'accessPointsMap',
    }

    def __init__(self, access_points_map=None, _configuration=None):  # noqa: E501
        """GetAccessPointsResult - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._access_points_map = None
        self.discriminator = None

        self.access_points_map = access_points_map

    @property
    def access_points_map(self):
        """Gets the access_points_map of this GetAccessPointsResult.  # noqa: E501

        Map of type of access point to list of access points  # noqa: E501

        :return: The access_points_map of this GetAccessPointsResult.  # noqa: E501
        :rtype: Dict[str, List[AccessPoint]]
        """
        return self._access_points_map

    @access_points_map.setter
    def access_points_map(self, access_points_map):
        """Sets the access_points_map of this GetAccessPointsResult.

        Map of type of access point to list of access points  # noqa: E501

        :param access_points_map: The access_points_map of this GetAccessPointsResult.  # noqa: E501
        :type: Dict[str, List[AccessPoint]]
        """
        if self._configuration.client_side_validation and access_points_map is None:
            raise ValueError("Invalid value for `access_points_map`, must not be `None`")  # noqa: E501

        self._access_points_map = access_points_map

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetAccessPointsResult, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetAccessPointsResult):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetAccessPointsResult):
            return True

        return self.to_dict() != other.to_dict()
