# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GetCollectionFormHistoryRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'client_reference_details': 'List[ClientReferenceDetail]',
        'max_results': 'int',
        'carrier_id': 'str',
        'ship_from_address': 'Address',
        'date_range': 'DateRange',
    }

    attribute_map = {
        'client_reference_details': 'clientReferenceDetails',
        'max_results': 'maxResults',
        'carrier_id': 'carrierId',
        'ship_from_address': 'shipFromAddress',
        'date_range': 'dateRange',
    }

    def __init__(self, client_reference_details=None, max_results=None, carrier_id=None, ship_from_address=None, date_range=None, _configuration=None):  # noqa: E501
        """GetCollectionFormHistoryRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._client_reference_details = None
        self._max_results = None
        self._carrier_id = None
        self._ship_from_address = None
        self._date_range = None
        self.discriminator = None

        if client_reference_details is not None:
            self.client_reference_details = client_reference_details
        if max_results is not None:
            self.max_results = max_results
        if carrier_id is not None:
            self.carrier_id = carrier_id
        if ship_from_address is not None:
            self.ship_from_address = ship_from_address
        if date_range is not None:
            self.date_range = date_range

    @property
    def client_reference_details(self):
        """Gets the client_reference_details of this GetCollectionFormHistoryRequest.  # noqa: E501

        Object to pass additional information about the MCI Integrator shipperType: List of ClientReferenceDetail  # noqa: E501

        :return: The client_reference_details of this GetCollectionFormHistoryRequest.  # noqa: E501
        :rtype: List[ClientReferenceDetail]
        """
        return self._client_reference_details

    @client_reference_details.setter
    def client_reference_details(self, client_reference_details):
        """Sets the client_reference_details of this GetCollectionFormHistoryRequest.

        Object to pass additional information about the MCI Integrator shipperType: List of ClientReferenceDetail  # noqa: E501

        :param client_reference_details: The client_reference_details of this GetCollectionFormHistoryRequest.  # noqa: E501
        :type: List[ClientReferenceDetail]
        """

        self._client_reference_details = client_reference_details

    @property
    def max_results(self):
        """Gets the max_results of this GetCollectionFormHistoryRequest.  # noqa: E501

        max Number of Results for query .  # noqa: E501

        :return: The max_results of this GetCollectionFormHistoryRequest.  # noqa: E501
        :rtype: int
        """
        return self._max_results

    @max_results.setter
    def max_results(self, max_results):
        """Sets the max_results of this GetCollectionFormHistoryRequest.

        max Number of Results for query .  # noqa: E501

        :param max_results: The max_results of this GetCollectionFormHistoryRequest.  # noqa: E501
        :type: int
        """

        self._max_results = max_results

    @property
    def carrier_id(self):
        """Gets the carrier_id of this GetCollectionFormHistoryRequest.  # noqa: E501

        The carrier identifier for the offering, provided by the carrier.  # noqa: E501

        :return: The carrier_id of this GetCollectionFormHistoryRequest.  # noqa: E501
        :rtype: str
        """
        return self._carrier_id

    @carrier_id.setter
    def carrier_id(self, carrier_id):
        """Sets the carrier_id of this GetCollectionFormHistoryRequest.

        The carrier identifier for the offering, provided by the carrier.  # noqa: E501

        :param carrier_id: The carrier_id of this GetCollectionFormHistoryRequest.  # noqa: E501
        :type: str
        """

        self._carrier_id = carrier_id

    @property
    def ship_from_address(self):
        """Gets the ship_from_address of this GetCollectionFormHistoryRequest.  # noqa: E501


        :return: The ship_from_address of this GetCollectionFormHistoryRequest.  # noqa: E501
        :rtype: Address
        """
        return self._ship_from_address

    @ship_from_address.setter
    def ship_from_address(self, ship_from_address):
        """Sets the ship_from_address of this GetCollectionFormHistoryRequest.


        :param ship_from_address: The ship_from_address of this GetCollectionFormHistoryRequest.  # noqa: E501
        :type: Address
        """

        self._ship_from_address = ship_from_address

    @property
    def date_range(self):
        """Gets the date_range of this GetCollectionFormHistoryRequest.  # noqa: E501


        :return: The date_range of this GetCollectionFormHistoryRequest.  # noqa: E501
        :rtype: DateRange
        """
        return self._date_range

    @date_range.setter
    def date_range(self, date_range):
        """Sets the date_range of this GetCollectionFormHistoryRequest.


        :param date_range: The date_range of this GetCollectionFormHistoryRequest.  # noqa: E501
        :type: DateRange
        """

        self._date_range = date_range

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetCollectionFormHistoryRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetCollectionFormHistoryRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetCollectionFormHistoryRequest):
            return True

        return self.to_dict() != other.to_dict()
