# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GetCollectionFormHistoryResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'collection_forms_history_record_list': 'List[CollectionFormsHistoryRecord]',
        'last_refreshed_date': 'str',
    }

    attribute_map = {
        'collection_forms_history_record_list': 'collectionFormsHistoryRecordList',
        'last_refreshed_date': 'lastRefreshedDate',
    }

    def __init__(self, collection_forms_history_record_list=None, last_refreshed_date=None, _configuration=None):  # noqa: E501
        """GetCollectionFormHistoryResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._collection_forms_history_record_list = None
        self._last_refreshed_date = None
        self.discriminator = None

        if collection_forms_history_record_list is not None:
            self.collection_forms_history_record_list = collection_forms_history_record_list
        if last_refreshed_date is not None:
            self.last_refreshed_date = last_refreshed_date

    @property
    def collection_forms_history_record_list(self):
        """Gets the collection_forms_history_record_list of this GetCollectionFormHistoryResponse.  # noqa: E501

        A list of CollectionFormsHistoryRecord  # noqa: E501

        :return: The collection_forms_history_record_list of this GetCollectionFormHistoryResponse.  # noqa: E501
        :rtype: List[CollectionFormsHistoryRecord]
        """
        return self._collection_forms_history_record_list

    @collection_forms_history_record_list.setter
    def collection_forms_history_record_list(self, collection_forms_history_record_list):
        """Sets the collection_forms_history_record_list of this GetCollectionFormHistoryResponse.

        A list of CollectionFormsHistoryRecord  # noqa: E501

        :param collection_forms_history_record_list: The collection_forms_history_record_list of this GetCollectionFormHistoryResponse.  # noqa: E501
        :type: List[CollectionFormsHistoryRecord]
        """

        self._collection_forms_history_record_list = collection_forms_history_record_list

    @property
    def last_refreshed_date(self):
        """Gets the last_refreshed_date of this GetCollectionFormHistoryResponse.  # noqa: E501

        Last Refereshed Date of collection  # noqa: E501

        :return: The last_refreshed_date of this GetCollectionFormHistoryResponse.  # noqa: E501
        :rtype: str
        """
        return self._last_refreshed_date

    @last_refreshed_date.setter
    def last_refreshed_date(self, last_refreshed_date):
        """Sets the last_refreshed_date of this GetCollectionFormHistoryResponse.

        Last Refereshed Date of collection  # noqa: E501

        :param last_refreshed_date: The last_refreshed_date of this GetCollectionFormHistoryResponse.  # noqa: E501
        :type: str
        """

        self._last_refreshed_date = last_refreshed_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetCollectionFormHistoryResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetCollectionFormHistoryResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetCollectionFormHistoryResponse):
            return True

        return self.to_dict() != other.to_dict()
