# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GetUnmanifestedShipmentsRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'client_reference_details': 'List[ClientReferenceDetail]',
    }

    attribute_map = {
        'client_reference_details': 'clientReferenceDetails',
    }

    def __init__(self, client_reference_details=None, _configuration=None):  # noqa: E501
        """GetUnmanifestedShipmentsRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._client_reference_details = None
        self.discriminator = None

        if client_reference_details is not None:
            self.client_reference_details = client_reference_details

    @property
    def client_reference_details(self):
        """Gets the client_reference_details of this GetUnmanifestedShipmentsRequest.  # noqa: E501

        Object to pass additional information about the MCI Integrator shipperType: List of ClientReferenceDetail  # noqa: E501

        :return: The client_reference_details of this GetUnmanifestedShipmentsRequest.  # noqa: E501
        :rtype: List[ClientReferenceDetail]
        """
        return self._client_reference_details

    @client_reference_details.setter
    def client_reference_details(self, client_reference_details):
        """Sets the client_reference_details of this GetUnmanifestedShipmentsRequest.

        Object to pass additional information about the MCI Integrator shipperType: List of ClientReferenceDetail  # noqa: E501

        :param client_reference_details: The client_reference_details of this GetUnmanifestedShipmentsRequest.  # noqa: E501
        :type: List[ClientReferenceDetail]
        """

        self._client_reference_details = client_reference_details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetUnmanifestedShipmentsRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetUnmanifestedShipmentsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetUnmanifestedShipmentsRequest):
            return True

        return self.to_dict() != other.to_dict()
