# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class LinkCarrierAccountResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'registration_status': 'AccountStatus',
        'account_id': 'str',
    }

    attribute_map = {
        'registration_status': 'registrationStatus',
        'account_id': 'accountId',
    }

    def __init__(self, registration_status=None, account_id=None, _configuration=None):  # noqa: E501
        """LinkCarrierAccountResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._registration_status = None
        self._account_id = None
        self.discriminator = None

        if registration_status is not None:
            self.registration_status = registration_status
        if account_id is not None:
            self.account_id = account_id

    @property
    def registration_status(self):
        """Gets the registration_status of this LinkCarrierAccountResponse.  # noqa: E501


        :return: The registration_status of this LinkCarrierAccountResponse.  # noqa: E501
        :rtype: AccountStatus
        """
        return self._registration_status

    @registration_status.setter
    def registration_status(self, registration_status):
        """Sets the registration_status of this LinkCarrierAccountResponse.


        :param registration_status: The registration_status of this LinkCarrierAccountResponse.  # noqa: E501
        :type: AccountStatus
        """

        self._registration_status = registration_status

    @property
    def account_id(self):
        """Gets the account_id of this LinkCarrierAccountResponse.  # noqa: E501

        Identifier for the seller's carrier account.  # noqa: E501

        :return: The account_id of this LinkCarrierAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this LinkCarrierAccountResponse.

        Identifier for the seller's carrier account.  # noqa: E501

        :param account_id: The account_id of this LinkCarrierAccountResponse.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LinkCarrierAccountResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LinkCarrierAccountResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LinkCarrierAccountResponse):
            return True

        return self.to_dict() != other.to_dict()
