# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class LinkableAccountType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_type': 'AccountType',
        'carrier_account_inputs': 'List[CarrierAccountInput]',
    }

    attribute_map = {
        'account_type': 'accountType',
        'carrier_account_inputs': 'carrierAccountInputs',
    }

    def __init__(self, account_type=None, carrier_account_inputs=None, _configuration=None):  # noqa: E501
        """LinkableAccountType - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._account_type = None
        self._carrier_account_inputs = None
        self.discriminator = None

        if account_type is not None:
            self.account_type = account_type
        if carrier_account_inputs is not None:
            self.carrier_account_inputs = carrier_account_inputs

    @property
    def account_type(self):
        """Gets the account_type of this LinkableAccountType.  # noqa: E501


        :return: The account_type of this LinkableAccountType.  # noqa: E501
        :rtype: AccountType
        """
        return self._account_type

    @account_type.setter
    def account_type(self, account_type):
        """Sets the account_type of this LinkableAccountType.


        :param account_type: The account_type of this LinkableAccountType.  # noqa: E501
        :type: AccountType
        """

        self._account_type = account_type

    @property
    def carrier_account_inputs(self):
        """Gets the carrier_account_inputs of this LinkableAccountType.  # noqa: E501

        A list of CarrierAccountInput  # noqa: E501

        :return: The carrier_account_inputs of this LinkableAccountType.  # noqa: E501
        :rtype: List[CarrierAccountInput]
        """
        return self._carrier_account_inputs

    @carrier_account_inputs.setter
    def carrier_account_inputs(self, carrier_account_inputs):
        """Sets the carrier_account_inputs of this LinkableAccountType.

        A list of CarrierAccountInput  # noqa: E501

        :param carrier_account_inputs: The carrier_account_inputs of this LinkableAccountType.  # noqa: E501
        :type: List[CarrierAccountInput]
        """

        self._carrier_account_inputs = carrier_account_inputs

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LinkableAccountType, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LinkableAccountType):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LinkableAccountType):
            return True

        return self.to_dict() != other.to_dict()
