# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class LinkableCarrier(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'carrier_id': 'str',
        'linkable_account_types': 'List[LinkableAccountType]',
    }

    attribute_map = {
        'carrier_id': 'carrierId',
        'linkable_account_types': 'linkableAccountTypes',
    }

    def __init__(self, carrier_id=None, linkable_account_types=None, _configuration=None):  # noqa: E501
        """LinkableCarrier - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._carrier_id = None
        self._linkable_account_types = None
        self.discriminator = None

        if carrier_id is not None:
            self.carrier_id = carrier_id
        if linkable_account_types is not None:
            self.linkable_account_types = linkable_account_types

    @property
    def carrier_id(self):
        """Gets the carrier_id of this LinkableCarrier.  # noqa: E501

        The carrier identifier for the offering, provided by the carrier.  # noqa: E501

        :return: The carrier_id of this LinkableCarrier.  # noqa: E501
        :rtype: str
        """
        return self._carrier_id

    @carrier_id.setter
    def carrier_id(self, carrier_id):
        """Sets the carrier_id of this LinkableCarrier.

        The carrier identifier for the offering, provided by the carrier.  # noqa: E501

        :param carrier_id: The carrier_id of this LinkableCarrier.  # noqa: E501
        :type: str
        """

        self._carrier_id = carrier_id

    @property
    def linkable_account_types(self):
        """Gets the linkable_account_types of this LinkableCarrier.  # noqa: E501

        A list of LinkableAccountType  # noqa: E501

        :return: The linkable_account_types of this LinkableCarrier.  # noqa: E501
        :rtype: List[LinkableAccountType]
        """
        return self._linkable_account_types

    @linkable_account_types.setter
    def linkable_account_types(self, linkable_account_types):
        """Sets the linkable_account_types of this LinkableCarrier.

        A list of LinkableAccountType  # noqa: E501

        :param linkable_account_types: The linkable_account_types of this LinkableCarrier.  # noqa: E501
        :type: List[LinkableAccountType]
        """

        self._linkable_account_types = linkable_account_types

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LinkableCarrier, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LinkableCarrier):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LinkableCarrier):
            return True

        return self.to_dict() != other.to_dict()
