# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class Location(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'state_or_region': 'str',
        'city': 'str',
        'country_code': 'str',
        'postal_code': 'str',
    }

    attribute_map = {
        'state_or_region': 'stateOrRegion',
        'city': 'city',
        'country_code': 'countryCode',
        'postal_code': 'postalCode',
    }

    def __init__(self, state_or_region=None, city=None, country_code=None, postal_code=None, _configuration=None):  # noqa: E501
        """Location - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._state_or_region = None
        self._city = None
        self._country_code = None
        self._postal_code = None
        self.discriminator = None

        if state_or_region is not None:
            self.state_or_region = state_or_region
        if city is not None:
            self.city = city
        if country_code is not None:
            self.country_code = country_code
        if postal_code is not None:
            self.postal_code = postal_code

    @property
    def state_or_region(self):
        """Gets the state_or_region of this Location.  # noqa: E501

        The state, county or region where the person, business or institution is located.  # noqa: E501

        :return: The state_or_region of this Location.  # noqa: E501
        :rtype: str
        """
        return self._state_or_region

    @state_or_region.setter
    def state_or_region(self, state_or_region):
        """Sets the state_or_region of this Location.

        The state, county or region where the person, business or institution is located.  # noqa: E501

        :param state_or_region: The state_or_region of this Location.  # noqa: E501
        :type: str
        """

        self._state_or_region = state_or_region

    @property
    def city(self):
        """Gets the city of this Location.  # noqa: E501

        The city or town where the person, business or institution is located.  # noqa: E501

        :return: The city of this Location.  # noqa: E501
        :rtype: str
        """
        return self._city

    @city.setter
    def city(self, city):
        """Sets the city of this Location.

        The city or town where the person, business or institution is located.  # noqa: E501

        :param city: The city of this Location.  # noqa: E501
        :type: str
        """

        self._city = city

    @property
    def country_code(self):
        """Gets the country_code of this Location.  # noqa: E501

        The two digit country code. Follows ISO 3166-1 alpha-2 format.  # noqa: E501

        :return: The country_code of this Location.  # noqa: E501
        :rtype: str
        """
        return self._country_code

    @country_code.setter
    def country_code(self, country_code):
        """Sets the country_code of this Location.

        The two digit country code. Follows ISO 3166-1 alpha-2 format.  # noqa: E501

        :param country_code: The country_code of this Location.  # noqa: E501
        :type: str
        """

        self._country_code = country_code

    @property
    def postal_code(self):
        """Gets the postal_code of this Location.  # noqa: E501

        The postal code of that address. It contains a series of letters or digits or both, sometimes including spaces or punctuation.  # noqa: E501

        :return: The postal_code of this Location.  # noqa: E501
        :rtype: str
        """
        return self._postal_code

    @postal_code.setter
    def postal_code(self, postal_code):
        """Sets the postal_code of this Location.

        The postal code of that address. It contains a series of letters or digits or both, sometimes including spaces or punctuation.  # noqa: E501

        :param postal_code: The postal_code of this Location.  # noqa: E501
        :type: str
        """

        self._postal_code = postal_code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Location, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Location):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Location):
            return True

        return self.to_dict() != other.to_dict()
