# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class OperatingHours(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'closing_time': 'TimeOfDay',
        'opening_time': 'TimeOfDay',
        'mid_day_closures': 'List[TimeOfDay]',
    }

    attribute_map = {
        'closing_time': 'closingTime',
        'opening_time': 'openingTime',
        'mid_day_closures': 'midDayClosures',
    }

    def __init__(self, closing_time=None, opening_time=None, mid_day_closures=None, _configuration=None):  # noqa: E501
        """OperatingHours - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._closing_time = None
        self._opening_time = None
        self._mid_day_closures = None
        self.discriminator = None

        if closing_time is not None:
            self.closing_time = closing_time
        if opening_time is not None:
            self.opening_time = opening_time
        if mid_day_closures is not None:
            self.mid_day_closures = mid_day_closures

    @property
    def closing_time(self):
        """Gets the closing_time of this OperatingHours.  # noqa: E501


        :return: The closing_time of this OperatingHours.  # noqa: E501
        :rtype: TimeOfDay
        """
        return self._closing_time

    @closing_time.setter
    def closing_time(self, closing_time):
        """Sets the closing_time of this OperatingHours.


        :param closing_time: The closing_time of this OperatingHours.  # noqa: E501
        :type: TimeOfDay
        """

        self._closing_time = closing_time

    @property
    def opening_time(self):
        """Gets the opening_time of this OperatingHours.  # noqa: E501


        :return: The opening_time of this OperatingHours.  # noqa: E501
        :rtype: TimeOfDay
        """
        return self._opening_time

    @opening_time.setter
    def opening_time(self, opening_time):
        """Sets the opening_time of this OperatingHours.


        :param opening_time: The opening_time of this OperatingHours.  # noqa: E501
        :type: TimeOfDay
        """

        self._opening_time = opening_time

    @property
    def mid_day_closures(self):
        """Gets the mid_day_closures of this OperatingHours.  # noqa: E501

        midDayClosures operating hours array  # noqa: E501

        :return: The mid_day_closures of this OperatingHours.  # noqa: E501
        :rtype: List[TimeOfDay]
        """
        return self._mid_day_closures

    @mid_day_closures.setter
    def mid_day_closures(self, mid_day_closures):
        """Sets the mid_day_closures of this OperatingHours.

        midDayClosures operating hours array  # noqa: E501

        :param mid_day_closures: The mid_day_closures of this OperatingHours.  # noqa: E501
        :type: List[TimeOfDay]
        """

        self._mid_day_closures = mid_day_closures

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OperatingHours, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OperatingHours):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OperatingHours):
            return True

        return self.to_dict() != other.to_dict()
