# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class Promise(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'delivery_window': 'TimeWindow',
        'pickup_window': 'TimeWindow',
    }

    attribute_map = {
        'delivery_window': 'deliveryWindow',
        'pickup_window': 'pickupWindow',
    }

    def __init__(self, delivery_window=None, pickup_window=None, _configuration=None):  # noqa: E501
        """Promise - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._delivery_window = None
        self._pickup_window = None
        self.discriminator = None

        if delivery_window is not None:
            self.delivery_window = delivery_window
        if pickup_window is not None:
            self.pickup_window = pickup_window

    @property
    def delivery_window(self):
        """Gets the delivery_window of this Promise.  # noqa: E501


        :return: The delivery_window of this Promise.  # noqa: E501
        :rtype: TimeWindow
        """
        return self._delivery_window

    @delivery_window.setter
    def delivery_window(self, delivery_window):
        """Sets the delivery_window of this Promise.


        :param delivery_window: The delivery_window of this Promise.  # noqa: E501
        :type: TimeWindow
        """

        self._delivery_window = delivery_window

    @property
    def pickup_window(self):
        """Gets the pickup_window of this Promise.  # noqa: E501


        :return: The pickup_window of this Promise.  # noqa: E501
        :rtype: TimeWindow
        """
        return self._pickup_window

    @pickup_window.setter
    def pickup_window(self, pickup_window):
        """Sets the pickup_window of this Promise.


        :param pickup_window: The pickup_window of this Promise.  # noqa: E501
        :type: TimeWindow
        """

        self._pickup_window = pickup_window

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Promise, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Promise):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Promise):
            return True

        return self.to_dict() != other.to_dict()
