# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ShipperInstruction(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'delivery_notes': 'str',
    }

    attribute_map = {
        'delivery_notes': 'deliveryNotes',
    }

    def __init__(self, delivery_notes=None, _configuration=None):  # noqa: E501
        """ShipperInstruction - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._delivery_notes = None
        self.discriminator = None

        if delivery_notes is not None:
            self.delivery_notes = delivery_notes

    @property
    def delivery_notes(self):
        """Gets the delivery_notes of this ShipperInstruction.  # noqa: E501

        The delivery notes for the shipment  # noqa: E501

        :return: The delivery_notes of this ShipperInstruction.  # noqa: E501
        :rtype: str
        """
        return self._delivery_notes

    @delivery_notes.setter
    def delivery_notes(self, delivery_notes):
        """Sets the delivery_notes of this ShipperInstruction.

        The delivery notes for the shipment  # noqa: E501

        :param delivery_notes: The delivery_notes of this ShipperInstruction.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                delivery_notes is not None and len(delivery_notes) > 256):
            raise ValueError("Invalid value for `delivery_notes`, length must be less than or equal to `256`")  # noqa: E501

        self._delivery_notes = delivery_notes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ShipperInstruction, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ShipperInstruction):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ShipperInstruction):
            return True

        return self.to_dict() != other.to_dict()
