# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class SubmitNdrFeedbackRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'tracking_id': 'str',
        'ndr_action': 'NdrAction',
        'ndr_request_data': 'NdrRequestData',
    }

    attribute_map = {
        'tracking_id': 'trackingId',
        'ndr_action': 'ndrAction',
        'ndr_request_data': 'ndrRequestData',
    }

    def __init__(self, tracking_id=None, ndr_action=None, ndr_request_data=None, _configuration=None):  # noqa: E501
        """SubmitNdrFeedbackRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._tracking_id = None
        self._ndr_action = None
        self._ndr_request_data = None
        self.discriminator = None

        self.tracking_id = tracking_id
        self.ndr_action = ndr_action
        if ndr_request_data is not None:
            self.ndr_request_data = ndr_request_data

    @property
    def tracking_id(self):
        """Gets the tracking_id of this SubmitNdrFeedbackRequest.  # noqa: E501

        The carrier generated identifier for a package in a purchased shipment.  # noqa: E501

        :return: The tracking_id of this SubmitNdrFeedbackRequest.  # noqa: E501
        :rtype: str
        """
        return self._tracking_id

    @tracking_id.setter
    def tracking_id(self, tracking_id):
        """Sets the tracking_id of this SubmitNdrFeedbackRequest.

        The carrier generated identifier for a package in a purchased shipment.  # noqa: E501

        :param tracking_id: The tracking_id of this SubmitNdrFeedbackRequest.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and tracking_id is None:
            raise ValueError("Invalid value for `tracking_id`, must not be `None`")  # noqa: E501

        self._tracking_id = tracking_id

    @property
    def ndr_action(self):
        """Gets the ndr_action of this SubmitNdrFeedbackRequest.  # noqa: E501


        :return: The ndr_action of this SubmitNdrFeedbackRequest.  # noqa: E501
        :rtype: NdrAction
        """
        return self._ndr_action

    @ndr_action.setter
    def ndr_action(self, ndr_action):
        """Sets the ndr_action of this SubmitNdrFeedbackRequest.


        :param ndr_action: The ndr_action of this SubmitNdrFeedbackRequest.  # noqa: E501
        :type: NdrAction
        """
        if self._configuration.client_side_validation and ndr_action is None:
            raise ValueError("Invalid value for `ndr_action`, must not be `None`")  # noqa: E501

        self._ndr_action = ndr_action

    @property
    def ndr_request_data(self):
        """Gets the ndr_request_data of this SubmitNdrFeedbackRequest.  # noqa: E501


        :return: The ndr_request_data of this SubmitNdrFeedbackRequest.  # noqa: E501
        :rtype: NdrRequestData
        """
        return self._ndr_request_data

    @ndr_request_data.setter
    def ndr_request_data(self, ndr_request_data):
        """Sets the ndr_request_data of this SubmitNdrFeedbackRequest.


        :param ndr_request_data: The ndr_request_data of this SubmitNdrFeedbackRequest.  # noqa: E501
        :type: NdrRequestData
        """

        self._ndr_request_data = ndr_request_data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SubmitNdrFeedbackRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubmitNdrFeedbackRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SubmitNdrFeedbackRequest):
            return True

        return self.to_dict() != other.to_dict()
