# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class SupportedDocumentDetail(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'DocumentType',
        'is_mandatory': 'bool',
    }

    attribute_map = {
        'name': 'name',
        'is_mandatory': 'isMandatory',
    }

    def __init__(self, name=None, is_mandatory=None, _configuration=None):  # noqa: E501
        """SupportedDocumentDetail - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._is_mandatory = None
        self.discriminator = None

        self.name = name
        self.is_mandatory = is_mandatory

    @property
    def name(self):
        """Gets the name of this SupportedDocumentDetail.  # noqa: E501


        :return: The name of this SupportedDocumentDetail.  # noqa: E501
        :rtype: DocumentType
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SupportedDocumentDetail.


        :param name: The name of this SupportedDocumentDetail.  # noqa: E501
        :type: DocumentType
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def is_mandatory(self):
        """Gets the is_mandatory of this SupportedDocumentDetail.  # noqa: E501

        When true, the supported document type is required.  # noqa: E501

        :return: The is_mandatory of this SupportedDocumentDetail.  # noqa: E501
        :rtype: bool
        """
        return self._is_mandatory

    @is_mandatory.setter
    def is_mandatory(self, is_mandatory):
        """Sets the is_mandatory of this SupportedDocumentDetail.

        When true, the supported document type is required.  # noqa: E501

        :param is_mandatory: The is_mandatory of this SupportedDocumentDetail.  # noqa: E501
        :type: bool
        """
        if self._configuration.client_side_validation and is_mandatory is None:
            raise ValueError("Invalid value for `is_mandatory`, must not be `None`")  # noqa: E501

        self._is_mandatory = is_mandatory

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SupportedDocumentDetail, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SupportedDocumentDetail):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SupportedDocumentDetail):
            return True

        return self.to_dict() != other.to_dict()
