# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class TaxDetail(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'tax_type': 'TaxType',
        'tax_registration_number': 'str',
    }

    attribute_map = {
        'tax_type': 'taxType',
        'tax_registration_number': 'taxRegistrationNumber',
    }

    def __init__(self, tax_type=None, tax_registration_number=None, _configuration=None):  # noqa: E501
        """TaxDetail - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._tax_type = None
        self._tax_registration_number = None
        self.discriminator = None

        self.tax_type = tax_type
        self.tax_registration_number = tax_registration_number

    @property
    def tax_type(self):
        """Gets the tax_type of this TaxDetail.  # noqa: E501


        :return: The tax_type of this TaxDetail.  # noqa: E501
        :rtype: TaxType
        """
        return self._tax_type

    @tax_type.setter
    def tax_type(self, tax_type):
        """Sets the tax_type of this TaxDetail.


        :param tax_type: The tax_type of this TaxDetail.  # noqa: E501
        :type: TaxType
        """
        if self._configuration.client_side_validation and tax_type is None:
            raise ValueError("Invalid value for `tax_type`, must not be `None`")  # noqa: E501

        self._tax_type = tax_type

    @property
    def tax_registration_number(self):
        """Gets the tax_registration_number of this TaxDetail.  # noqa: E501

        The shipper's tax registration number associated with the shipment for customs compliance purposes in certain regions.  # noqa: E501

        :return: The tax_registration_number of this TaxDetail.  # noqa: E501
        :rtype: str
        """
        return self._tax_registration_number

    @tax_registration_number.setter
    def tax_registration_number(self, tax_registration_number):
        """Sets the tax_registration_number of this TaxDetail.

        The shipper's tax registration number associated with the shipment for customs compliance purposes in certain regions.  # noqa: E501

        :param tax_registration_number: The tax_registration_number of this TaxDetail.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and tax_registration_number is None:
            raise ValueError("Invalid value for `tax_registration_number`, must not be `None`")  # noqa: E501

        self._tax_registration_number = tax_registration_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TaxDetail, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TaxDetail):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TaxDetail):
            return True

        return self.to_dict() != other.to_dict()
