# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class TrackingDetailCodes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'forward': 'List[DetailCodes]',
        'returns': 'List[DetailCodes]',
    }

    attribute_map = {
        'forward': 'forward',
        'returns': 'returns',
    }

    def __init__(self, forward=None, returns=None, _configuration=None):  # noqa: E501
        """TrackingDetailCodes - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._forward = None
        self._returns = None
        self.discriminator = None

        self.forward = forward
        self.returns = returns

    @property
    def forward(self):
        """Gets the forward of this TrackingDetailCodes.  # noqa: E501

        Contains detail codes that provide additional details related to the forward leg of the shipment.  # noqa: E501

        :return: The forward of this TrackingDetailCodes.  # noqa: E501
        :rtype: List[DetailCodes]
        """
        return self._forward

    @forward.setter
    def forward(self, forward):
        """Sets the forward of this TrackingDetailCodes.

        Contains detail codes that provide additional details related to the forward leg of the shipment.  # noqa: E501

        :param forward: The forward of this TrackingDetailCodes.  # noqa: E501
        :type: List[DetailCodes]
        """
        if self._configuration.client_side_validation and forward is None:
            raise ValueError("Invalid value for `forward`, must not be `None`")  # noqa: E501

        self._forward = forward

    @property
    def returns(self):
        """Gets the returns of this TrackingDetailCodes.  # noqa: E501

        Contains detail codes that provide additional details related to the return leg of the shipment.  # noqa: E501

        :return: The returns of this TrackingDetailCodes.  # noqa: E501
        :rtype: List[DetailCodes]
        """
        return self._returns

    @returns.setter
    def returns(self, returns):
        """Sets the returns of this TrackingDetailCodes.

        Contains detail codes that provide additional details related to the return leg of the shipment.  # noqa: E501

        :param returns: The returns of this TrackingDetailCodes.  # noqa: E501
        :type: List[DetailCodes]
        """
        if self._configuration.client_side_validation and returns is None:
            raise ValueError("Invalid value for `returns`, must not be `None`")  # noqa: E501

        self._returns = returns

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TrackingDetailCodes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TrackingDetailCodes):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TrackingDetailCodes):
            return True

        return self.to_dict() != other.to_dict()
