# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class UnmanifestedCarrierInformation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'carrier_id': 'str',
        'carrier_name': 'str',
        'unmanifested_shipment_location_list': 'List[UnmanifestedShipmentLocation]',
    }

    attribute_map = {
        'carrier_id': 'carrierId',
        'carrier_name': 'carrierName',
        'unmanifested_shipment_location_list': 'unmanifestedShipmentLocationList',
    }

    def __init__(self, carrier_id=None, carrier_name=None, unmanifested_shipment_location_list=None, _configuration=None):  # noqa: E501
        """UnmanifestedCarrierInformation - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._carrier_id = None
        self._carrier_name = None
        self._unmanifested_shipment_location_list = None
        self.discriminator = None

        if carrier_id is not None:
            self.carrier_id = carrier_id
        if carrier_name is not None:
            self.carrier_name = carrier_name
        if unmanifested_shipment_location_list is not None:
            self.unmanifested_shipment_location_list = unmanifested_shipment_location_list

    @property
    def carrier_id(self):
        """Gets the carrier_id of this UnmanifestedCarrierInformation.  # noqa: E501

        The carrier identifier for the offering, provided by the carrier.  # noqa: E501

        :return: The carrier_id of this UnmanifestedCarrierInformation.  # noqa: E501
        :rtype: str
        """
        return self._carrier_id

    @carrier_id.setter
    def carrier_id(self, carrier_id):
        """Sets the carrier_id of this UnmanifestedCarrierInformation.

        The carrier identifier for the offering, provided by the carrier.  # noqa: E501

        :param carrier_id: The carrier_id of this UnmanifestedCarrierInformation.  # noqa: E501
        :type: str
        """

        self._carrier_id = carrier_id

    @property
    def carrier_name(self):
        """Gets the carrier_name of this UnmanifestedCarrierInformation.  # noqa: E501

        The carrier name for the offering.  # noqa: E501

        :return: The carrier_name of this UnmanifestedCarrierInformation.  # noqa: E501
        :rtype: str
        """
        return self._carrier_name

    @carrier_name.setter
    def carrier_name(self, carrier_name):
        """Sets the carrier_name of this UnmanifestedCarrierInformation.

        The carrier name for the offering.  # noqa: E501

        :param carrier_name: The carrier_name of this UnmanifestedCarrierInformation.  # noqa: E501
        :type: str
        """

        self._carrier_name = carrier_name

    @property
    def unmanifested_shipment_location_list(self):
        """Gets the unmanifested_shipment_location_list of this UnmanifestedCarrierInformation.  # noqa: E501

        A list of UnmanifestedShipmentLocation  # noqa: E501

        :return: The unmanifested_shipment_location_list of this UnmanifestedCarrierInformation.  # noqa: E501
        :rtype: List[UnmanifestedShipmentLocation]
        """
        return self._unmanifested_shipment_location_list

    @unmanifested_shipment_location_list.setter
    def unmanifested_shipment_location_list(self, unmanifested_shipment_location_list):
        """Sets the unmanifested_shipment_location_list of this UnmanifestedCarrierInformation.

        A list of UnmanifestedShipmentLocation  # noqa: E501

        :param unmanifested_shipment_location_list: The unmanifested_shipment_location_list of this UnmanifestedCarrierInformation.  # noqa: E501
        :type: List[UnmanifestedShipmentLocation]
        """

        self._unmanifested_shipment_location_list = unmanifested_shipment_location_list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UnmanifestedCarrierInformation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UnmanifestedCarrierInformation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UnmanifestedCarrierInformation):
            return True

        return self.to_dict() != other.to_dict()
