# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class UnmanifestedShipmentLocation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'address': 'Address',
        'last_manifest_date': 'str',
    }

    attribute_map = {
        'address': 'address',
        'last_manifest_date': 'lastManifestDate',
    }

    def __init__(self, address=None, last_manifest_date=None, _configuration=None):  # noqa: E501
        """UnmanifestedShipmentLocation - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._address = None
        self._last_manifest_date = None
        self.discriminator = None

        if address is not None:
            self.address = address
        if last_manifest_date is not None:
            self.last_manifest_date = last_manifest_date

    @property
    def address(self):
        """Gets the address of this UnmanifestedShipmentLocation.  # noqa: E501


        :return: The address of this UnmanifestedShipmentLocation.  # noqa: E501
        :rtype: Address
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this UnmanifestedShipmentLocation.


        :param address: The address of this UnmanifestedShipmentLocation.  # noqa: E501
        :type: Address
        """

        self._address = address

    @property
    def last_manifest_date(self):
        """Gets the last_manifest_date of this UnmanifestedShipmentLocation.  # noqa: E501

        Its Last Manifest Date.  # noqa: E501

        :return: The last_manifest_date of this UnmanifestedShipmentLocation.  # noqa: E501
        :rtype: str
        """
        return self._last_manifest_date

    @last_manifest_date.setter
    def last_manifest_date(self, last_manifest_date):
        """Sets the last_manifest_date of this UnmanifestedShipmentLocation.

        Its Last Manifest Date.  # noqa: E501

        :param last_manifest_date: The last_manifest_date of this UnmanifestedShipmentLocation.  # noqa: E501
        :type: str
        """

        self._last_manifest_date = last_manifest_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UnmanifestedShipmentLocation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UnmanifestedShipmentLocation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UnmanifestedShipmentLocation):
            return True

        return self.to_dict() != other.to_dict()
