# coding: utf-8

"""
    Selling Partner API for Supply Sources

    Manage configurations and capabilities of seller supply sources.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class CreateSupplySourceResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'supply_source_id': 'str',
        'supply_source_code': 'str',
    }

    attribute_map = {
        'supply_source_id': 'supplySourceId',
        'supply_source_code': 'supplySourceCode',
    }

    def __init__(self, supply_source_id=None, supply_source_code=None, _configuration=None):  # noqa: E501
        """CreateSupplySourceResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._supply_source_id = None
        self._supply_source_code = None
        self.discriminator = None

        self.supply_source_id = supply_source_id
        self.supply_source_code = supply_source_code

    @property
    def supply_source_id(self):
        """Gets the supply_source_id of this CreateSupplySourceResponse.  # noqa: E501

        An Amazon generated unique supply source ID.  # noqa: E501

        :return: The supply_source_id of this CreateSupplySourceResponse.  # noqa: E501
        :rtype: str
        """
        return self._supply_source_id

    @supply_source_id.setter
    def supply_source_id(self, supply_source_id):
        """Sets the supply_source_id of this CreateSupplySourceResponse.

        An Amazon generated unique supply source ID.  # noqa: E501

        :param supply_source_id: The supply_source_id of this CreateSupplySourceResponse.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and supply_source_id is None:
            raise ValueError("Invalid value for `supply_source_id`, must not be `None`")  # noqa: E501

        self._supply_source_id = supply_source_id

    @property
    def supply_source_code(self):
        """Gets the supply_source_code of this CreateSupplySourceResponse.  # noqa: E501

        The seller-provided unique supply source code.  # noqa: E501

        :return: The supply_source_code of this CreateSupplySourceResponse.  # noqa: E501
        :rtype: str
        """
        return self._supply_source_code

    @supply_source_code.setter
    def supply_source_code(self, supply_source_code):
        """Sets the supply_source_code of this CreateSupplySourceResponse.

        The seller-provided unique supply source code.  # noqa: E501

        :param supply_source_code: The supply_source_code of this CreateSupplySourceResponse.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and supply_source_code is None:
            raise ValueError("Invalid value for `supply_source_code`, must not be `None`")  # noqa: E501

        self._supply_source_code = supply_source_code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateSupplySourceResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateSupplySourceResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateSupplySourceResponse):
            return True

        return self.to_dict() != other.to_dict()
