# coding: utf-8

"""
    Selling Partner API for Supply Sources

    Manage configurations and capabilities of seller supply sources.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class GetSupplySourcesResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'supply_sources': 'List[SupplySourceListInner]',
        'next_page_token': 'str',
    }

    attribute_map = {
        'supply_sources': 'supplySources',
        'next_page_token': 'nextPageToken',
    }

    def __init__(self, supply_sources=None, next_page_token=None, _configuration=None):  # noqa: E501
        """GetSupplySourcesResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._supply_sources = None
        self._next_page_token = None
        self.discriminator = None

        if supply_sources is not None:
            self.supply_sources = supply_sources
        if next_page_token is not None:
            self.next_page_token = next_page_token

    @property
    def supply_sources(self):
        """Gets the supply_sources of this GetSupplySourcesResponse.  # noqa: E501

        The list of `SupplySource`s.  # noqa: E501

        :return: The supply_sources of this GetSupplySourcesResponse.  # noqa: E501
        :rtype: List[SupplySourceListInner]
        """
        return self._supply_sources

    @supply_sources.setter
    def supply_sources(self, supply_sources):
        """Sets the supply_sources of this GetSupplySourcesResponse.

        The list of `SupplySource`s.  # noqa: E501

        :param supply_sources: The supply_sources of this GetSupplySourcesResponse.  # noqa: E501
        :type: List[SupplySourceListInner]
        """

        self._supply_sources = supply_sources

    @property
    def next_page_token(self):
        """Gets the next_page_token of this GetSupplySourcesResponse.  # noqa: E501

        If present, use this pagination token to retrieve the next page of supply sources.  # noqa: E501

        :return: The next_page_token of this GetSupplySourcesResponse.  # noqa: E501
        :rtype: str
        """
        return self._next_page_token

    @next_page_token.setter
    def next_page_token(self, next_page_token):
        """Sets the next_page_token of this GetSupplySourcesResponse.

        If present, use this pagination token to retrieve the next page of supply sources.  # noqa: E501

        :param next_page_token: The next_page_token of this GetSupplySourcesResponse.  # noqa: E501
        :type: str
        """

        self._next_page_token = next_page_token

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetSupplySourcesResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetSupplySourcesResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetSupplySourcesResponse):
            return True

        return self.to_dict() != other.to_dict()
