# coding: utf-8

"""
    The Selling Partner API for Transfers.

    The Selling Partner API for Transfers enables selling partners to retrieve payment methods and initiate payouts for their seller accounts. This API supports the following marketplaces: DE, FR, IT, ES, SE, NL, PL, and BE.

    The version of the OpenAPI document: 2024-06-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class InitiatePayoutResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payout_reference_id': 'str',
    }

    attribute_map = {
        'payout_reference_id': 'payoutReferenceId',
    }

    def __init__(self, payout_reference_id=None, _configuration=None):  # noqa: E501
        """InitiatePayoutResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._payout_reference_id = None
        self.discriminator = None

        self.payout_reference_id = payout_reference_id

    @property
    def payout_reference_id(self):
        """Gets the payout_reference_id of this InitiatePayoutResponse.  # noqa: E501

        The financial event group ID for a successfully initiated payout. You can use this ID to track payout information.  # noqa: E501

        :return: The payout_reference_id of this InitiatePayoutResponse.  # noqa: E501
        :rtype: str
        """
        return self._payout_reference_id

    @payout_reference_id.setter
    def payout_reference_id(self, payout_reference_id):
        """Sets the payout_reference_id of this InitiatePayoutResponse.

        The financial event group ID for a successfully initiated payout. You can use this ID to track payout information.  # noqa: E501

        :param payout_reference_id: The payout_reference_id of this InitiatePayoutResponse.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and payout_reference_id is None:
            raise ValueError("Invalid value for `payout_reference_id`, must not be `None`")  # noqa: E501

        self._payout_reference_id = payout_reference_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InitiatePayoutResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InitiatePayoutResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InitiatePayoutResponse):
            return True

        return self.to_dict() != other.to_dict()
