# coding: utf-8

"""
    The Selling Partner API for Automotive.

    The Selling Partner API for Automotive provides programmatic access to information needed by selling partners to provide compatibility information about their listed products.

    The version of the OpenAPI document: 2024-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class VehicleIdentifiers(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'standard': 'VehicleStandard',
        'value': 'str',
    }

    attribute_map = {
        'standard': 'standard',
        'value': 'value',
    }

    def __init__(self, standard=None, value=None, _configuration=None):  # noqa: E501
        """VehicleIdentifiers - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._standard = None
        self._value = None
        self.discriminator = None

        self.standard = standard
        self.value = value

    @property
    def standard(self):
        """Gets the standard of this VehicleIdentifiers.  # noqa: E501


        :return: The standard of this VehicleIdentifiers.  # noqa: E501
        :rtype: VehicleStandard
        """
        return self._standard

    @standard.setter
    def standard(self, standard):
        """Sets the standard of this VehicleIdentifiers.


        :param standard: The standard of this VehicleIdentifiers.  # noqa: E501
        :type: VehicleStandard
        """
        if self._configuration.client_side_validation and standard is None:
            raise ValueError("Invalid value for `standard`, must not be `None`")  # noqa: E501

        self._standard = standard

    @property
    def value(self):
        """Gets the value of this VehicleIdentifiers.  # noqa: E501

        Id that can uniquely identify a vehicle based the vehicle identification standard.  # noqa: E501

        :return: The value of this VehicleIdentifiers.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this VehicleIdentifiers.

        Id that can uniquely identify a vehicle based the vehicle identification standard.  # noqa: E501

        :param value: The value of this VehicleIdentifiers.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VehicleIdentifiers, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VehicleIdentifiers):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VehicleIdentifiers):
            return True

        return self.to_dict() != other.to_dict()
