# coding: utf-8

"""
    The Selling Partner API for Automotive.

    The Selling Partner API for Automotive provides programmatic access to information needed by selling partners to provide compatibility information about their listed products.

    The version of the OpenAPI document: 2024-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class VehiclesResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'pagination': 'Pagination',
        'vehicles': 'List[Vehicle]',
    }

    attribute_map = {
        'pagination': 'pagination',
        'vehicles': 'vehicles',
    }

    def __init__(self, pagination=None, vehicles=None, _configuration=None):  # noqa: E501
        """VehiclesResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._pagination = None
        self._vehicles = None
        self.discriminator = None

        if pagination is not None:
            self.pagination = pagination
        self.vehicles = vehicles

    @property
    def pagination(self):
        """Gets the pagination of this VehiclesResponse.  # noqa: E501


        :return: The pagination of this VehiclesResponse.  # noqa: E501
        :rtype: Pagination
        """
        return self._pagination

    @pagination.setter
    def pagination(self, pagination):
        """Sets the pagination of this VehiclesResponse.


        :param pagination: The pagination of this VehiclesResponse.  # noqa: E501
        :type: Pagination
        """

        self._pagination = pagination

    @property
    def vehicles(self):
        """Gets the vehicles of this VehiclesResponse.  # noqa: E501

        List of vehicles from Amazon's catalog.  # noqa: E501

        :return: The vehicles of this VehiclesResponse.  # noqa: E501
        :rtype: List[Vehicle]
        """
        return self._vehicles

    @vehicles.setter
    def vehicles(self, vehicles):
        """Sets the vehicles of this VehiclesResponse.

        List of vehicles from Amazon's catalog.  # noqa: E501

        :param vehicles: The vehicles of this VehiclesResponse.  # noqa: E501
        :type: List[Vehicle]
        """
        if self._configuration.client_side_validation and vehicles is None:
            raise ValueError("Invalid value for `vehicles`, must not be `None`")  # noqa: E501

        self._vehicles = vehicles

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VehiclesResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VehiclesResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VehiclesResponse):
            return True

        return self.to_dict() != other.to_dict()
