# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Orders

    The Selling Partner API for Direct Fulfillment Orders provides programmatic access to a direct fulfillment vendor's order data.

    The version of the OpenAPI document: 2021-12-28
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class OrderItemAcknowledgement(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'item_sequence_number': 'str',
        'buyer_product_identifier': 'str',
        'vendor_product_identifier': 'str',
        'acknowledged_quantity': 'ItemQuantity',
    }

    attribute_map = {
        'item_sequence_number': 'itemSequenceNumber',
        'buyer_product_identifier': 'buyerProductIdentifier',
        'vendor_product_identifier': 'vendorProductIdentifier',
        'acknowledged_quantity': 'acknowledgedQuantity',
    }

    def __init__(self, item_sequence_number=None, buyer_product_identifier=None, vendor_product_identifier=None, acknowledged_quantity=None, _configuration=None):  # noqa: E501
        """OrderItemAcknowledgement - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._item_sequence_number = None
        self._buyer_product_identifier = None
        self._vendor_product_identifier = None
        self._acknowledged_quantity = None
        self.discriminator = None

        self.item_sequence_number = item_sequence_number
        if buyer_product_identifier is not None:
            self.buyer_product_identifier = buyer_product_identifier
        if vendor_product_identifier is not None:
            self.vendor_product_identifier = vendor_product_identifier
        self.acknowledged_quantity = acknowledged_quantity

    @property
    def item_sequence_number(self):
        """Gets the item_sequence_number of this OrderItemAcknowledgement.  # noqa: E501

        Line item sequence number for the item.  # noqa: E501

        :return: The item_sequence_number of this OrderItemAcknowledgement.  # noqa: E501
        :rtype: str
        """
        return self._item_sequence_number

    @item_sequence_number.setter
    def item_sequence_number(self, item_sequence_number):
        """Sets the item_sequence_number of this OrderItemAcknowledgement.

        Line item sequence number for the item.  # noqa: E501

        :param item_sequence_number: The item_sequence_number of this OrderItemAcknowledgement.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and item_sequence_number is None:
            raise ValueError("Invalid value for `item_sequence_number`, must not be `None`")  # noqa: E501

        self._item_sequence_number = item_sequence_number

    @property
    def buyer_product_identifier(self):
        """Gets the buyer_product_identifier of this OrderItemAcknowledgement.  # noqa: E501

        Buyer's standard identification number (ASIN) of an item.  # noqa: E501

        :return: The buyer_product_identifier of this OrderItemAcknowledgement.  # noqa: E501
        :rtype: str
        """
        return self._buyer_product_identifier

    @buyer_product_identifier.setter
    def buyer_product_identifier(self, buyer_product_identifier):
        """Sets the buyer_product_identifier of this OrderItemAcknowledgement.

        Buyer's standard identification number (ASIN) of an item.  # noqa: E501

        :param buyer_product_identifier: The buyer_product_identifier of this OrderItemAcknowledgement.  # noqa: E501
        :type: str
        """

        self._buyer_product_identifier = buyer_product_identifier

    @property
    def vendor_product_identifier(self):
        """Gets the vendor_product_identifier of this OrderItemAcknowledgement.  # noqa: E501

        The vendor selected product identification of the item. Should be the same as was provided in the purchase order.  # noqa: E501

        :return: The vendor_product_identifier of this OrderItemAcknowledgement.  # noqa: E501
        :rtype: str
        """
        return self._vendor_product_identifier

    @vendor_product_identifier.setter
    def vendor_product_identifier(self, vendor_product_identifier):
        """Sets the vendor_product_identifier of this OrderItemAcknowledgement.

        The vendor selected product identification of the item. Should be the same as was provided in the purchase order.  # noqa: E501

        :param vendor_product_identifier: The vendor_product_identifier of this OrderItemAcknowledgement.  # noqa: E501
        :type: str
        """

        self._vendor_product_identifier = vendor_product_identifier

    @property
    def acknowledged_quantity(self):
        """Gets the acknowledged_quantity of this OrderItemAcknowledgement.  # noqa: E501


        :return: The acknowledged_quantity of this OrderItemAcknowledgement.  # noqa: E501
        :rtype: ItemQuantity
        """
        return self._acknowledged_quantity

    @acknowledged_quantity.setter
    def acknowledged_quantity(self, acknowledged_quantity):
        """Sets the acknowledged_quantity of this OrderItemAcknowledgement.


        :param acknowledged_quantity: The acknowledged_quantity of this OrderItemAcknowledgement.  # noqa: E501
        :type: ItemQuantity
        """
        if self._configuration.client_side_validation and acknowledged_quantity is None:
            raise ValueError("Invalid value for `acknowledged_quantity`, must not be `None`")  # noqa: E501

        self._acknowledged_quantity = acknowledged_quantity

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderItemAcknowledgement, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderItemAcknowledgement):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OrderItemAcknowledgement):
            return True

        return self.to_dict() != other.to_dict()
