# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Orders

    The Selling Partner API for Direct Fulfillment Orders provides programmatic access to a direct fulfillment vendor's order data.

    The version of the OpenAPI document: 2021-12-28
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ShipmentDates(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'required_ship_date': 'datetime',
        'promised_delivery_date': 'datetime',
    }

    attribute_map = {
        'required_ship_date': 'requiredShipDate',
        'promised_delivery_date': 'promisedDeliveryDate',
    }

    def __init__(self, required_ship_date=None, promised_delivery_date=None, _configuration=None):  # noqa: E501
        """ShipmentDates - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._required_ship_date = None
        self._promised_delivery_date = None
        self.discriminator = None

        self.required_ship_date = required_ship_date
        if promised_delivery_date is not None:
            self.promised_delivery_date = promised_delivery_date

    @property
    def required_ship_date(self):
        """Gets the required_ship_date of this ShipmentDates.  # noqa: E501

        Time by which the vendor is required to ship the order.  # noqa: E501

        :return: The required_ship_date of this ShipmentDates.  # noqa: E501
        :rtype: datetime
        """
        return self._required_ship_date

    @required_ship_date.setter
    def required_ship_date(self, required_ship_date):
        """Sets the required_ship_date of this ShipmentDates.

        Time by which the vendor is required to ship the order.  # noqa: E501

        :param required_ship_date: The required_ship_date of this ShipmentDates.  # noqa: E501
        :type: datetime
        """
        if self._configuration.client_side_validation and required_ship_date is None:
            raise ValueError("Invalid value for `required_ship_date`, must not be `None`")  # noqa: E501

        self._required_ship_date = required_ship_date

    @property
    def promised_delivery_date(self):
        """Gets the promised_delivery_date of this ShipmentDates.  # noqa: E501

        Delivery date promised to the Amazon customer.  # noqa: E501

        :return: The promised_delivery_date of this ShipmentDates.  # noqa: E501
        :rtype: datetime
        """
        return self._promised_delivery_date

    @promised_delivery_date.setter
    def promised_delivery_date(self, promised_delivery_date):
        """Sets the promised_delivery_date of this ShipmentDates.

        Delivery date promised to the Amazon customer.  # noqa: E501

        :param promised_delivery_date: The promised_delivery_date of this ShipmentDates.  # noqa: E501
        :type: datetime
        """

        self._promised_delivery_date = promised_delivery_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ShipmentDates, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ShipmentDates):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ShipmentDates):
            return True

        return self.to_dict() != other.to_dict()
