# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Orders

    The Selling Partner API for Direct Fulfillment Orders provides programmatic access to a direct fulfillment vendor's order data.

    The version of the OpenAPI document: 2021-12-28
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class TaxDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'tax_rate': 'str',
        'tax_amount': 'Money',
        'taxable_amount': 'Money',
        'type': 'str',
    }

    attribute_map = {
        'tax_rate': 'taxRate',
        'tax_amount': 'taxAmount',
        'taxable_amount': 'taxableAmount',
        'type': 'type',
    }

    def __init__(self, tax_rate=None, tax_amount=None, taxable_amount=None, type=None, _configuration=None):  # noqa: E501
        """TaxDetails - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._tax_rate = None
        self._tax_amount = None
        self._taxable_amount = None
        self._type = None
        self.discriminator = None

        if tax_rate is not None:
            self.tax_rate = tax_rate
        self.tax_amount = tax_amount
        if taxable_amount is not None:
            self.taxable_amount = taxable_amount
        if type is not None:
            self.type = type

    @property
    def tax_rate(self):
        """Gets the tax_rate of this TaxDetails.  # noqa: E501

        A decimal number with no loss of precision. Useful when precision loss is unacceptable, as with currencies. Follows RFC7159 for number representation.  # noqa: E501

        :return: The tax_rate of this TaxDetails.  # noqa: E501
        :rtype: str
        """
        return self._tax_rate

    @tax_rate.setter
    def tax_rate(self, tax_rate):
        """Sets the tax_rate of this TaxDetails.

        A decimal number with no loss of precision. Useful when precision loss is unacceptable, as with currencies. Follows RFC7159 for number representation.  # noqa: E501

        :param tax_rate: The tax_rate of this TaxDetails.  # noqa: E501
        :type: str
        """

        self._tax_rate = tax_rate

    @property
    def tax_amount(self):
        """Gets the tax_amount of this TaxDetails.  # noqa: E501


        :return: The tax_amount of this TaxDetails.  # noqa: E501
        :rtype: Money
        """
        return self._tax_amount

    @tax_amount.setter
    def tax_amount(self, tax_amount):
        """Sets the tax_amount of this TaxDetails.


        :param tax_amount: The tax_amount of this TaxDetails.  # noqa: E501
        :type: Money
        """
        if self._configuration.client_side_validation and tax_amount is None:
            raise ValueError("Invalid value for `tax_amount`, must not be `None`")  # noqa: E501

        self._tax_amount = tax_amount

    @property
    def taxable_amount(self):
        """Gets the taxable_amount of this TaxDetails.  # noqa: E501


        :return: The taxable_amount of this TaxDetails.  # noqa: E501
        :rtype: Money
        """
        return self._taxable_amount

    @taxable_amount.setter
    def taxable_amount(self, taxable_amount):
        """Sets the taxable_amount of this TaxDetails.


        :param taxable_amount: The taxable_amount of this TaxDetails.  # noqa: E501
        :type: Money
        """

        self._taxable_amount = taxable_amount

    @property
    def type(self):
        """Gets the type of this TaxDetails.  # noqa: E501

        Tax type.  # noqa: E501

        :return: The type of this TaxDetails.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this TaxDetails.

        Tax type.  # noqa: E501

        :param type: The type of this TaxDetails.  # noqa: E501
        :type: str
        """
        allowed_values = ["CONSUMPTION", "GST", "MwSt.", "PST", "TOTAL", "TVA", "VAT"]  # noqa: E501
        if (self._configuration.client_side_validation and
                type not in allowed_values):
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TaxDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TaxDetails):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TaxDetails):
            return True

        return self.to_dict() != other.to_dict()
