# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Shipping

    Use the Selling Partner API for Direct Fulfillment Shipping to access a direct fulfillment vendor's shipping data.

    The version of the OpenAPI document: 2021-12-28
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ContainerLabel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'container_tracking_number': 'str',
        'content': 'str',
        'format': 'ContainerLabelFormat',
    }

    attribute_map = {
        'container_tracking_number': 'containerTrackingNumber',
        'content': 'content',
        'format': 'format',
    }

    def __init__(self, container_tracking_number=None, content=None, format=None, _configuration=None):  # noqa: E501
        """ContainerLabel - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._container_tracking_number = None
        self._content = None
        self._format = None
        self.discriminator = None

        if container_tracking_number is not None:
            self.container_tracking_number = container_tracking_number
        self.content = content
        self.format = format

    @property
    def container_tracking_number(self):
        """Gets the container_tracking_number of this ContainerLabel.  # noqa: E501

        The container (pallet) tracking identifier from the shipping carrier.  # noqa: E501

        :return: The container_tracking_number of this ContainerLabel.  # noqa: E501
        :rtype: str
        """
        return self._container_tracking_number

    @container_tracking_number.setter
    def container_tracking_number(self, container_tracking_number):
        """Sets the container_tracking_number of this ContainerLabel.

        The container (pallet) tracking identifier from the shipping carrier.  # noqa: E501

        :param container_tracking_number: The container_tracking_number of this ContainerLabel.  # noqa: E501
        :type: str
        """

        self._container_tracking_number = container_tracking_number

    @property
    def content(self):
        """Gets the content of this ContainerLabel.  # noqa: E501

        The container label content encoded into a Base64 string.  # noqa: E501

        :return: The content of this ContainerLabel.  # noqa: E501
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content):
        """Sets the content of this ContainerLabel.

        The container label content encoded into a Base64 string.  # noqa: E501

        :param content: The content of this ContainerLabel.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and content is None:
            raise ValueError("Invalid value for `content`, must not be `None`")  # noqa: E501

        self._content = content

    @property
    def format(self):
        """Gets the format of this ContainerLabel.  # noqa: E501


        :return: The format of this ContainerLabel.  # noqa: E501
        :rtype: ContainerLabelFormat
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this ContainerLabel.


        :param format: The format of this ContainerLabel.  # noqa: E501
        :type: ContainerLabelFormat
        """
        if self._configuration.client_side_validation and format is None:
            raise ValueError("Invalid value for `format`, must not be `None`")  # noqa: E501

        self._format = format

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ContainerLabel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContainerLabel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ContainerLabel):
            return True

        return self.to_dict() != other.to_dict()
