# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Shipping

    Use the Selling Partner API for Direct Fulfillment Shipping to access a direct fulfillment vendor's shipping data.

    The version of the OpenAPI document: 2021-12-28
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class PackedItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'item_sequence_number': 'int',
        'buyer_product_identifier': 'str',
        'piece_number': 'int',
        'vendor_product_identifier': 'str',
        'packed_quantity': 'ItemQuantity',
    }

    attribute_map = {
        'item_sequence_number': 'itemSequenceNumber',
        'buyer_product_identifier': 'buyerProductIdentifier',
        'piece_number': 'pieceNumber',
        'vendor_product_identifier': 'vendorProductIdentifier',
        'packed_quantity': 'packedQuantity',
    }

    def __init__(self, item_sequence_number=None, buyer_product_identifier=None, piece_number=None, vendor_product_identifier=None, packed_quantity=None, _configuration=None):  # noqa: E501
        """PackedItem - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._item_sequence_number = None
        self._buyer_product_identifier = None
        self._piece_number = None
        self._vendor_product_identifier = None
        self._packed_quantity = None
        self.discriminator = None

        self.item_sequence_number = item_sequence_number
        if buyer_product_identifier is not None:
            self.buyer_product_identifier = buyer_product_identifier
        if piece_number is not None:
            self.piece_number = piece_number
        if vendor_product_identifier is not None:
            self.vendor_product_identifier = vendor_product_identifier
        self.packed_quantity = packed_quantity

    @property
    def item_sequence_number(self):
        """Gets the item_sequence_number of this PackedItem.  # noqa: E501

        The sequence number of the item. The number must be the same as the order number of the item.  # noqa: E501

        :return: The item_sequence_number of this PackedItem.  # noqa: E501
        :rtype: int
        """
        return self._item_sequence_number

    @item_sequence_number.setter
    def item_sequence_number(self, item_sequence_number):
        """Sets the item_sequence_number of this PackedItem.

        The sequence number of the item. The number must be the same as the order number of the item.  # noqa: E501

        :param item_sequence_number: The item_sequence_number of this PackedItem.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and item_sequence_number is None:
            raise ValueError("Invalid value for `item_sequence_number`, must not be `None`")  # noqa: E501

        self._item_sequence_number = item_sequence_number

    @property
    def buyer_product_identifier(self):
        """Gets the buyer_product_identifier of this PackedItem.  # noqa: E501

        The buyer's Amazon Standard Identification Number (ASIN) of an item. Either `buyerProductIdentifier` or `vendorProductIdentifier` is required.  # noqa: E501

        :return: The buyer_product_identifier of this PackedItem.  # noqa: E501
        :rtype: str
        """
        return self._buyer_product_identifier

    @buyer_product_identifier.setter
    def buyer_product_identifier(self, buyer_product_identifier):
        """Sets the buyer_product_identifier of this PackedItem.

        The buyer's Amazon Standard Identification Number (ASIN) of an item. Either `buyerProductIdentifier` or `vendorProductIdentifier` is required.  # noqa: E501

        :param buyer_product_identifier: The buyer_product_identifier of this PackedItem.  # noqa: E501
        :type: str
        """

        self._buyer_product_identifier = buyer_product_identifier

    @property
    def piece_number(self):
        """Gets the piece_number of this PackedItem.  # noqa: E501

        The piece number of the item in this container. This is required when the item is split across different containers.  # noqa: E501

        :return: The piece_number of this PackedItem.  # noqa: E501
        :rtype: int
        """
        return self._piece_number

    @piece_number.setter
    def piece_number(self, piece_number):
        """Sets the piece_number of this PackedItem.

        The piece number of the item in this container. This is required when the item is split across different containers.  # noqa: E501

        :param piece_number: The piece_number of this PackedItem.  # noqa: E501
        :type: int
        """

        self._piece_number = piece_number

    @property
    def vendor_product_identifier(self):
        """Gets the vendor_product_identifier of this PackedItem.  # noqa: E501

        An item's product identifier, which the vendor selects. This identifier should be the same as the identifier, such as a SKU, in the purchase order.  # noqa: E501

        :return: The vendor_product_identifier of this PackedItem.  # noqa: E501
        :rtype: str
        """
        return self._vendor_product_identifier

    @vendor_product_identifier.setter
    def vendor_product_identifier(self, vendor_product_identifier):
        """Sets the vendor_product_identifier of this PackedItem.

        An item's product identifier, which the vendor selects. This identifier should be the same as the identifier, such as a SKU, in the purchase order.  # noqa: E501

        :param vendor_product_identifier: The vendor_product_identifier of this PackedItem.  # noqa: E501
        :type: str
        """

        self._vendor_product_identifier = vendor_product_identifier

    @property
    def packed_quantity(self):
        """Gets the packed_quantity of this PackedItem.  # noqa: E501


        :return: The packed_quantity of this PackedItem.  # noqa: E501
        :rtype: ItemQuantity
        """
        return self._packed_quantity

    @packed_quantity.setter
    def packed_quantity(self, packed_quantity):
        """Sets the packed_quantity of this PackedItem.


        :param packed_quantity: The packed_quantity of this PackedItem.  # noqa: E501
        :type: ItemQuantity
        """
        if self._configuration.client_side_validation and packed_quantity is None:
            raise ValueError("Invalid value for `packed_quantity`, must not be `None`")  # noqa: E501

        self._packed_quantity = packed_quantity

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PackedItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PackedItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PackedItem):
            return True

        return self.to_dict() != other.to_dict()
