# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Shipping

    Use the Selling Partner API for Direct Fulfillment Shipping to access a direct fulfillment vendor's shipping data.

    The version of the OpenAPI document: 2021-12-28
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ShippingLabelList(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'pagination': 'Pagination',
        'shipping_labels': 'List[ShippingLabel]',
    }

    attribute_map = {
        'pagination': 'pagination',
        'shipping_labels': 'shippingLabels',
    }

    def __init__(self, pagination=None, shipping_labels=None, _configuration=None):  # noqa: E501
        """ShippingLabelList - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._pagination = None
        self._shipping_labels = None
        self.discriminator = None

        if pagination is not None:
            self.pagination = pagination
        if shipping_labels is not None:
            self.shipping_labels = shipping_labels

    @property
    def pagination(self):
        """Gets the pagination of this ShippingLabelList.  # noqa: E501


        :return: The pagination of this ShippingLabelList.  # noqa: E501
        :rtype: Pagination
        """
        return self._pagination

    @pagination.setter
    def pagination(self, pagination):
        """Sets the pagination of this ShippingLabelList.


        :param pagination: The pagination of this ShippingLabelList.  # noqa: E501
        :type: Pagination
        """

        self._pagination = pagination

    @property
    def shipping_labels(self):
        """Gets the shipping_labels of this ShippingLabelList.  # noqa: E501

        An array containing the details of the generated shipping labels.  # noqa: E501

        :return: The shipping_labels of this ShippingLabelList.  # noqa: E501
        :rtype: List[ShippingLabel]
        """
        return self._shipping_labels

    @shipping_labels.setter
    def shipping_labels(self, shipping_labels):
        """Sets the shipping_labels of this ShippingLabelList.

        An array containing the details of the generated shipping labels.  # noqa: E501

        :param shipping_labels: The shipping_labels of this ShippingLabelList.  # noqa: E501
        :type: List[ShippingLabel]
        """

        self._shipping_labels = shipping_labels

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ShippingLabelList, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ShippingLabelList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ShippingLabelList):
            return True

        return self.to_dict() != other.to_dict()
