# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Shipping

    Use the Selling Partner API for Direct Fulfillment Shipping to access a direct fulfillment vendor's shipping data.

    The version of the OpenAPI document: 2021-12-28
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class SubmitShipmentStatusUpdatesRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'shipment_status_updates': 'List[ShipmentStatusUpdate]',
    }

    attribute_map = {
        'shipment_status_updates': 'shipmentStatusUpdates',
    }

    def __init__(self, shipment_status_updates=None, _configuration=None):  # noqa: E501
        """SubmitShipmentStatusUpdatesRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._shipment_status_updates = None
        self.discriminator = None

        if shipment_status_updates is not None:
            self.shipment_status_updates = shipment_status_updates

    @property
    def shipment_status_updates(self):
        """Gets the shipment_status_updates of this SubmitShipmentStatusUpdatesRequest.  # noqa: E501

        Contains a list of one or more `ShipmentStatusUpdate` objects. Each `ShipmentStatusUpdate` object represents an update to the status of a specific shipment.  # noqa: E501

        :return: The shipment_status_updates of this SubmitShipmentStatusUpdatesRequest.  # noqa: E501
        :rtype: List[ShipmentStatusUpdate]
        """
        return self._shipment_status_updates

    @shipment_status_updates.setter
    def shipment_status_updates(self, shipment_status_updates):
        """Sets the shipment_status_updates of this SubmitShipmentStatusUpdatesRequest.

        Contains a list of one or more `ShipmentStatusUpdate` objects. Each `ShipmentStatusUpdate` object represents an update to the status of a specific shipment.  # noqa: E501

        :param shipment_status_updates: The shipment_status_updates of this SubmitShipmentStatusUpdatesRequest.  # noqa: E501
        :type: List[ShipmentStatusUpdate]
        """
        if (self._configuration.client_side_validation and
                shipment_status_updates is not None and len(shipment_status_updates) < 1):
            raise ValueError("Invalid value for `shipment_status_updates`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._shipment_status_updates = shipment_status_updates

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SubmitShipmentStatusUpdatesRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubmitShipmentStatusUpdatesRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SubmitShipmentStatusUpdatesRequest):
            return True

        return self.to_dict() != other.to_dict()
