# coding: utf-8

"""
    Selling Partner API for Retail Procurement Payments

    The Selling Partner API for Retail Procurement Payments provides programmatic access to vendors payments data.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class AllowanceDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'description': 'str',
        'allowance_amount': 'Money',
        'tax_details': 'List[TaxDetails]',
    }

    attribute_map = {
        'type': 'type',
        'description': 'description',
        'allowance_amount': 'allowanceAmount',
        'tax_details': 'taxDetails',
    }

    def __init__(self, type=None, description=None, allowance_amount=None, tax_details=None, _configuration=None):  # noqa: E501
        """AllowanceDetails - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._type = None
        self._description = None
        self._allowance_amount = None
        self._tax_details = None
        self.discriminator = None

        self.type = type
        if description is not None:
            self.description = description
        self.allowance_amount = allowance_amount
        if tax_details is not None:
            self.tax_details = tax_details

    @property
    def type(self):
        """Gets the type of this AllowanceDetails.  # noqa: E501

        Type of the allowance applied.  # noqa: E501

        :return: The type of this AllowanceDetails.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this AllowanceDetails.

        Type of the allowance applied.  # noqa: E501

        :param type: The type of this AllowanceDetails.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["Discount", "DiscountIncentive", "Defective", "Promotional", "UnsaleableMerchandise", "Special"]  # noqa: E501
        if (self._configuration.client_side_validation and
                type not in allowed_values):
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def description(self):
        """Gets the description of this AllowanceDetails.  # noqa: E501

        Description of the allowance.  # noqa: E501

        :return: The description of this AllowanceDetails.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AllowanceDetails.

        Description of the allowance.  # noqa: E501

        :param description: The description of this AllowanceDetails.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def allowance_amount(self):
        """Gets the allowance_amount of this AllowanceDetails.  # noqa: E501


        :return: The allowance_amount of this AllowanceDetails.  # noqa: E501
        :rtype: Money
        """
        return self._allowance_amount

    @allowance_amount.setter
    def allowance_amount(self, allowance_amount):
        """Sets the allowance_amount of this AllowanceDetails.


        :param allowance_amount: The allowance_amount of this AllowanceDetails.  # noqa: E501
        :type: Money
        """
        if self._configuration.client_side_validation and allowance_amount is None:
            raise ValueError("Invalid value for `allowance_amount`, must not be `None`")  # noqa: E501

        self._allowance_amount = allowance_amount

    @property
    def tax_details(self):
        """Gets the tax_details of this AllowanceDetails.  # noqa: E501

        Tax amount details applied on this allowance.  # noqa: E501

        :return: The tax_details of this AllowanceDetails.  # noqa: E501
        :rtype: List[TaxDetails]
        """
        return self._tax_details

    @tax_details.setter
    def tax_details(self, tax_details):
        """Sets the tax_details of this AllowanceDetails.

        Tax amount details applied on this allowance.  # noqa: E501

        :param tax_details: The tax_details of this AllowanceDetails.  # noqa: E501
        :type: List[TaxDetails]
        """

        self._tax_details = tax_details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AllowanceDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AllowanceDetails):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AllowanceDetails):
            return True

        return self.to_dict() != other.to_dict()
