# coding: utf-8

"""
    Selling Partner API for Retail Procurement Orders

    The Selling Partner API for Retail Procurement Orders provides programmatic access to vendor orders data.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class OrderItemStatus(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'item_sequence_number': 'str',
        'buyer_product_identifier': 'str',
        'vendor_product_identifier': 'str',
        'net_cost': 'Money',
        'list_price': 'Money',
        'ordered_quantity': 'OrderItemStatusOrderedQuantity',
        'acknowledgement_status': 'OrderItemStatusAcknowledgementStatus',
        'receiving_status': 'OrderItemStatusReceivingStatus',
    }

    attribute_map = {
        'item_sequence_number': 'itemSequenceNumber',
        'buyer_product_identifier': 'buyerProductIdentifier',
        'vendor_product_identifier': 'vendorProductIdentifier',
        'net_cost': 'netCost',
        'list_price': 'listPrice',
        'ordered_quantity': 'orderedQuantity',
        'acknowledgement_status': 'acknowledgementStatus',
        'receiving_status': 'receivingStatus',
    }

    def __init__(self, item_sequence_number=None, buyer_product_identifier=None, vendor_product_identifier=None, net_cost=None, list_price=None, ordered_quantity=None, acknowledgement_status=None, receiving_status=None, _configuration=None):  # noqa: E501
        """OrderItemStatus - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._item_sequence_number = None
        self._buyer_product_identifier = None
        self._vendor_product_identifier = None
        self._net_cost = None
        self._list_price = None
        self._ordered_quantity = None
        self._acknowledgement_status = None
        self._receiving_status = None
        self.discriminator = None

        self.item_sequence_number = item_sequence_number
        if buyer_product_identifier is not None:
            self.buyer_product_identifier = buyer_product_identifier
        if vendor_product_identifier is not None:
            self.vendor_product_identifier = vendor_product_identifier
        if net_cost is not None:
            self.net_cost = net_cost
        if list_price is not None:
            self.list_price = list_price
        if ordered_quantity is not None:
            self.ordered_quantity = ordered_quantity
        if acknowledgement_status is not None:
            self.acknowledgement_status = acknowledgement_status
        if receiving_status is not None:
            self.receiving_status = receiving_status

    @property
    def item_sequence_number(self):
        """Gets the item_sequence_number of this OrderItemStatus.  # noqa: E501

        Numbering of the item on the purchase order. The first item will be 1, the second 2, and so on.  # noqa: E501

        :return: The item_sequence_number of this OrderItemStatus.  # noqa: E501
        :rtype: str
        """
        return self._item_sequence_number

    @item_sequence_number.setter
    def item_sequence_number(self, item_sequence_number):
        """Sets the item_sequence_number of this OrderItemStatus.

        Numbering of the item on the purchase order. The first item will be 1, the second 2, and so on.  # noqa: E501

        :param item_sequence_number: The item_sequence_number of this OrderItemStatus.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and item_sequence_number is None:
            raise ValueError("Invalid value for `item_sequence_number`, must not be `None`")  # noqa: E501

        self._item_sequence_number = item_sequence_number

    @property
    def buyer_product_identifier(self):
        """Gets the buyer_product_identifier of this OrderItemStatus.  # noqa: E501

        Buyer's Standard Identification Number (ASIN) of an item.  # noqa: E501

        :return: The buyer_product_identifier of this OrderItemStatus.  # noqa: E501
        :rtype: str
        """
        return self._buyer_product_identifier

    @buyer_product_identifier.setter
    def buyer_product_identifier(self, buyer_product_identifier):
        """Sets the buyer_product_identifier of this OrderItemStatus.

        Buyer's Standard Identification Number (ASIN) of an item.  # noqa: E501

        :param buyer_product_identifier: The buyer_product_identifier of this OrderItemStatus.  # noqa: E501
        :type: str
        """

        self._buyer_product_identifier = buyer_product_identifier

    @property
    def vendor_product_identifier(self):
        """Gets the vendor_product_identifier of this OrderItemStatus.  # noqa: E501

        The vendor selected product identification of the item.  # noqa: E501

        :return: The vendor_product_identifier of this OrderItemStatus.  # noqa: E501
        :rtype: str
        """
        return self._vendor_product_identifier

    @vendor_product_identifier.setter
    def vendor_product_identifier(self, vendor_product_identifier):
        """Sets the vendor_product_identifier of this OrderItemStatus.

        The vendor selected product identification of the item.  # noqa: E501

        :param vendor_product_identifier: The vendor_product_identifier of this OrderItemStatus.  # noqa: E501
        :type: str
        """

        self._vendor_product_identifier = vendor_product_identifier

    @property
    def net_cost(self):
        """Gets the net_cost of this OrderItemStatus.  # noqa: E501


        :return: The net_cost of this OrderItemStatus.  # noqa: E501
        :rtype: Money
        """
        return self._net_cost

    @net_cost.setter
    def net_cost(self, net_cost):
        """Sets the net_cost of this OrderItemStatus.


        :param net_cost: The net_cost of this OrderItemStatus.  # noqa: E501
        :type: Money
        """

        self._net_cost = net_cost

    @property
    def list_price(self):
        """Gets the list_price of this OrderItemStatus.  # noqa: E501


        :return: The list_price of this OrderItemStatus.  # noqa: E501
        :rtype: Money
        """
        return self._list_price

    @list_price.setter
    def list_price(self, list_price):
        """Sets the list_price of this OrderItemStatus.


        :param list_price: The list_price of this OrderItemStatus.  # noqa: E501
        :type: Money
        """

        self._list_price = list_price

    @property
    def ordered_quantity(self):
        """Gets the ordered_quantity of this OrderItemStatus.  # noqa: E501


        :return: The ordered_quantity of this OrderItemStatus.  # noqa: E501
        :rtype: OrderItemStatusOrderedQuantity
        """
        return self._ordered_quantity

    @ordered_quantity.setter
    def ordered_quantity(self, ordered_quantity):
        """Sets the ordered_quantity of this OrderItemStatus.


        :param ordered_quantity: The ordered_quantity of this OrderItemStatus.  # noqa: E501
        :type: OrderItemStatusOrderedQuantity
        """

        self._ordered_quantity = ordered_quantity

    @property
    def acknowledgement_status(self):
        """Gets the acknowledgement_status of this OrderItemStatus.  # noqa: E501


        :return: The acknowledgement_status of this OrderItemStatus.  # noqa: E501
        :rtype: OrderItemStatusAcknowledgementStatus
        """
        return self._acknowledgement_status

    @acknowledgement_status.setter
    def acknowledgement_status(self, acknowledgement_status):
        """Sets the acknowledgement_status of this OrderItemStatus.


        :param acknowledgement_status: The acknowledgement_status of this OrderItemStatus.  # noqa: E501
        :type: OrderItemStatusAcknowledgementStatus
        """

        self._acknowledgement_status = acknowledgement_status

    @property
    def receiving_status(self):
        """Gets the receiving_status of this OrderItemStatus.  # noqa: E501


        :return: The receiving_status of this OrderItemStatus.  # noqa: E501
        :rtype: OrderItemStatusReceivingStatus
        """
        return self._receiving_status

    @receiving_status.setter
    def receiving_status(self, receiving_status):
        """Sets the receiving_status of this OrderItemStatus.


        :param receiving_status: The receiving_status of this OrderItemStatus.  # noqa: E501
        :type: OrderItemStatusReceivingStatus
        """

        self._receiving_status = receiving_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderItemStatus, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderItemStatus):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OrderItemStatus):
            return True

        return self.to_dict() != other.to_dict()
