# coding: utf-8

"""
    Selling Partner API for Retail Procurement Orders

    The Selling Partner API for Retail Procurement Orders provides programmatic access to vendor orders data.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class OrderedQuantityDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'updated_date': 'datetime',
        'ordered_quantity': 'ItemQuantity',
        'cancelled_quantity': 'ItemQuantity',
    }

    attribute_map = {
        'updated_date': 'updatedDate',
        'ordered_quantity': 'orderedQuantity',
        'cancelled_quantity': 'cancelledQuantity',
    }

    def __init__(self, updated_date=None, ordered_quantity=None, cancelled_quantity=None, _configuration=None):  # noqa: E501
        """OrderedQuantityDetails - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._updated_date = None
        self._ordered_quantity = None
        self._cancelled_quantity = None
        self.discriminator = None

        if updated_date is not None:
            self.updated_date = updated_date
        if ordered_quantity is not None:
            self.ordered_quantity = ordered_quantity
        if cancelled_quantity is not None:
            self.cancelled_quantity = cancelled_quantity

    @property
    def updated_date(self):
        """Gets the updated_date of this OrderedQuantityDetails.  # noqa: E501

        The date when the line item quantity was updated by buyer. Must be in ISO-8601 date/time format.  # noqa: E501

        :return: The updated_date of this OrderedQuantityDetails.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_date

    @updated_date.setter
    def updated_date(self, updated_date):
        """Sets the updated_date of this OrderedQuantityDetails.

        The date when the line item quantity was updated by buyer. Must be in ISO-8601 date/time format.  # noqa: E501

        :param updated_date: The updated_date of this OrderedQuantityDetails.  # noqa: E501
        :type: datetime
        """

        self._updated_date = updated_date

    @property
    def ordered_quantity(self):
        """Gets the ordered_quantity of this OrderedQuantityDetails.  # noqa: E501


        :return: The ordered_quantity of this OrderedQuantityDetails.  # noqa: E501
        :rtype: ItemQuantity
        """
        return self._ordered_quantity

    @ordered_quantity.setter
    def ordered_quantity(self, ordered_quantity):
        """Sets the ordered_quantity of this OrderedQuantityDetails.


        :param ordered_quantity: The ordered_quantity of this OrderedQuantityDetails.  # noqa: E501
        :type: ItemQuantity
        """

        self._ordered_quantity = ordered_quantity

    @property
    def cancelled_quantity(self):
        """Gets the cancelled_quantity of this OrderedQuantityDetails.  # noqa: E501


        :return: The cancelled_quantity of this OrderedQuantityDetails.  # noqa: E501
        :rtype: ItemQuantity
        """
        return self._cancelled_quantity

    @cancelled_quantity.setter
    def cancelled_quantity(self, cancelled_quantity):
        """Sets the cancelled_quantity of this OrderedQuantityDetails.


        :param cancelled_quantity: The cancelled_quantity of this OrderedQuantityDetails.  # noqa: E501
        :type: ItemQuantity
        """

        self._cancelled_quantity = cancelled_quantity

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderedQuantityDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderedQuantityDetails):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OrderedQuantityDetails):
            return True

        return self.to_dict() != other.to_dict()
