# coding: utf-8

"""
    Selling Partner API for Retail Procurement Orders

    The Selling Partner API for Retail Procurement Orders provides programmatic access to vendor orders data.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class PartyIdentification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'party_id': 'str',
        'address': 'Address',
        'tax_info': 'TaxRegistrationDetails',
    }

    attribute_map = {
        'party_id': 'partyId',
        'address': 'address',
        'tax_info': 'taxInfo',
    }

    def __init__(self, party_id=None, address=None, tax_info=None, _configuration=None):  # noqa: E501
        """PartyIdentification - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._party_id = None
        self._address = None
        self._tax_info = None
        self.discriminator = None

        self.party_id = party_id
        if address is not None:
            self.address = address
        if tax_info is not None:
            self.tax_info = tax_info

    @property
    def party_id(self):
        """Gets the party_id of this PartyIdentification.  # noqa: E501

        Assigned identification for the party. For example, warehouse code or vendor code. Please refer to specific party for more details.  # noqa: E501

        :return: The party_id of this PartyIdentification.  # noqa: E501
        :rtype: str
        """
        return self._party_id

    @party_id.setter
    def party_id(self, party_id):
        """Sets the party_id of this PartyIdentification.

        Assigned identification for the party. For example, warehouse code or vendor code. Please refer to specific party for more details.  # noqa: E501

        :param party_id: The party_id of this PartyIdentification.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and party_id is None:
            raise ValueError("Invalid value for `party_id`, must not be `None`")  # noqa: E501

        self._party_id = party_id

    @property
    def address(self):
        """Gets the address of this PartyIdentification.  # noqa: E501


        :return: The address of this PartyIdentification.  # noqa: E501
        :rtype: Address
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this PartyIdentification.


        :param address: The address of this PartyIdentification.  # noqa: E501
        :type: Address
        """

        self._address = address

    @property
    def tax_info(self):
        """Gets the tax_info of this PartyIdentification.  # noqa: E501


        :return: The tax_info of this PartyIdentification.  # noqa: E501
        :rtype: TaxRegistrationDetails
        """
        return self._tax_info

    @tax_info.setter
    def tax_info(self, tax_info):
        """Sets the tax_info of this PartyIdentification.


        :param tax_info: The tax_info of this PartyIdentification.  # noqa: E501
        :type: TaxRegistrationDetails
        """

        self._tax_info = tax_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PartyIdentification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PartyIdentification):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PartyIdentification):
            return True

        return self.to_dict() != other.to_dict()
