# coding: utf-8

"""
    Selling Partner API for Retail Procurement Shipments

    The Selling Partner API for Retail Procurement Shipments provides programmatic access to retail shipping data for vendors.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ContainerIdentification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'container_identification_type': 'str',
        'container_identification_number': 'str',
    }

    attribute_map = {
        'container_identification_type': 'containerIdentificationType',
        'container_identification_number': 'containerIdentificationNumber',
    }

    def __init__(self, container_identification_type=None, container_identification_number=None, _configuration=None):  # noqa: E501
        """ContainerIdentification - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._container_identification_type = None
        self._container_identification_number = None
        self.discriminator = None

        self.container_identification_type = container_identification_type
        self.container_identification_number = container_identification_number

    @property
    def container_identification_type(self):
        """Gets the container_identification_type of this ContainerIdentification.  # noqa: E501

        The container identification type.  # noqa: E501

        :return: The container_identification_type of this ContainerIdentification.  # noqa: E501
        :rtype: str
        """
        return self._container_identification_type

    @container_identification_type.setter
    def container_identification_type(self, container_identification_type):
        """Sets the container_identification_type of this ContainerIdentification.

        The container identification type.  # noqa: E501

        :param container_identification_type: The container_identification_type of this ContainerIdentification.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and container_identification_type is None:
            raise ValueError("Invalid value for `container_identification_type`, must not be `None`")  # noqa: E501
        allowed_values = ["SSCC", "AMZNCC", "GTIN", "BPS", "CID"]  # noqa: E501
        if (self._configuration.client_side_validation and
                container_identification_type not in allowed_values):
            raise ValueError(
                "Invalid value for `container_identification_type` ({0}), must be one of {1}"  # noqa: E501
                .format(container_identification_type, allowed_values)
            )

        self._container_identification_type = container_identification_type

    @property
    def container_identification_number(self):
        """Gets the container_identification_number of this ContainerIdentification.  # noqa: E501

        Container identification number that adheres to the definition of the container identification type.  # noqa: E501

        :return: The container_identification_number of this ContainerIdentification.  # noqa: E501
        :rtype: str
        """
        return self._container_identification_number

    @container_identification_number.setter
    def container_identification_number(self, container_identification_number):
        """Sets the container_identification_number of this ContainerIdentification.

        Container identification number that adheres to the definition of the container identification type.  # noqa: E501

        :param container_identification_number: The container_identification_number of this ContainerIdentification.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and container_identification_number is None:
            raise ValueError("Invalid value for `container_identification_number`, must not be `None`")  # noqa: E501

        self._container_identification_number = container_identification_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ContainerIdentification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContainerIdentification):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ContainerIdentification):
            return True

        return self.to_dict() != other.to_dict()
