# coding: utf-8

"""
    Selling Partner API for Retail Procurement Shipments

    The Selling Partner API for Retail Procurement Shipments provides programmatic access to retail shipping data for vendors.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class InnerContainersDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'container_count': 'int',
        'container_sequence_numbers': 'List[ContainerSequenceNumbers]',
    }

    attribute_map = {
        'container_count': 'containerCount',
        'container_sequence_numbers': 'containerSequenceNumbers',
    }

    def __init__(self, container_count=None, container_sequence_numbers=None, _configuration=None):  # noqa: E501
        """InnerContainersDetails - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._container_count = None
        self._container_sequence_numbers = None
        self.discriminator = None

        if container_count is not None:
            self.container_count = container_count
        if container_sequence_numbers is not None:
            self.container_sequence_numbers = container_sequence_numbers

    @property
    def container_count(self):
        """Gets the container_count of this InnerContainersDetails.  # noqa: E501

        Total containers as part of the shipment  # noqa: E501

        :return: The container_count of this InnerContainersDetails.  # noqa: E501
        :rtype: int
        """
        return self._container_count

    @container_count.setter
    def container_count(self, container_count):
        """Sets the container_count of this InnerContainersDetails.

        Total containers as part of the shipment  # noqa: E501

        :param container_count: The container_count of this InnerContainersDetails.  # noqa: E501
        :type: int
        """

        self._container_count = container_count

    @property
    def container_sequence_numbers(self):
        """Gets the container_sequence_numbers of this InnerContainersDetails.  # noqa: E501

        Container sequence numbers that are involved in this shipment.  # noqa: E501

        :return: The container_sequence_numbers of this InnerContainersDetails.  # noqa: E501
        :rtype: List[ContainerSequenceNumbers]
        """
        return self._container_sequence_numbers

    @container_sequence_numbers.setter
    def container_sequence_numbers(self, container_sequence_numbers):
        """Sets the container_sequence_numbers of this InnerContainersDetails.

        Container sequence numbers that are involved in this shipment.  # noqa: E501

        :param container_sequence_numbers: The container_sequence_numbers of this InnerContainersDetails.  # noqa: E501
        :type: List[ContainerSequenceNumbers]
        """

        self._container_sequence_numbers = container_sequence_numbers

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InnerContainersDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InnerContainersDetails):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InnerContainersDetails):
            return True

        return self.to_dict() != other.to_dict()
