# coding: utf-8

"""
    Selling Partner API for Retail Procurement Shipments

    The Selling Partner API for Retail Procurement Shipments provides programmatic access to retail shipping data for vendors.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class Route(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'stops': 'List[Stop]',
    }

    attribute_map = {
        'stops': 'stops',
    }

    def __init__(self, stops=None, _configuration=None):  # noqa: E501
        """Route - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._stops = None
        self.discriminator = None

        self.stops = stops

    @property
    def stops(self):
        """Gets the stops of this Route.  # noqa: E501

        The port or location involved in transporting the cargo, as specified in transportation contracts or operational plans.  # noqa: E501

        :return: The stops of this Route.  # noqa: E501
        :rtype: List[Stop]
        """
        return self._stops

    @stops.setter
    def stops(self, stops):
        """Sets the stops of this Route.

        The port or location involved in transporting the cargo, as specified in transportation contracts or operational plans.  # noqa: E501

        :param stops: The stops of this Route.  # noqa: E501
        :type: List[Stop]
        """
        if self._configuration.client_side_validation and stops is None:
            raise ValueError("Invalid value for `stops`, must not be `None`")  # noqa: E501

        self._stops = stops

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Route, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Route):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Route):
            return True

        return self.to_dict() != other.to_dict()
