# coding: utf-8

"""
    Selling Partner API for Retail Procurement Shipments

    The Selling Partner API for Retail Procurement Shipments provides programmatic access to retail shipping data for vendors.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class ShipmentStatusDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'shipment_status': 'str',
        'shipment_status_date': 'datetime',
    }

    attribute_map = {
        'shipment_status': 'shipmentStatus',
        'shipment_status_date': 'shipmentStatusDate',
    }

    def __init__(self, shipment_status=None, shipment_status_date=None, _configuration=None):  # noqa: E501
        """ShipmentStatusDetails - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._shipment_status = None
        self._shipment_status_date = None
        self.discriminator = None

        if shipment_status is not None:
            self.shipment_status = shipment_status
        if shipment_status_date is not None:
            self.shipment_status_date = shipment_status_date

    @property
    def shipment_status(self):
        """Gets the shipment_status of this ShipmentStatusDetails.  # noqa: E501

        Current status of the shipment on whether it is picked up or scheduled.  # noqa: E501

        :return: The shipment_status of this ShipmentStatusDetails.  # noqa: E501
        :rtype: str
        """
        return self._shipment_status

    @shipment_status.setter
    def shipment_status(self, shipment_status):
        """Sets the shipment_status of this ShipmentStatusDetails.

        Current status of the shipment on whether it is picked up or scheduled.  # noqa: E501

        :param shipment_status: The shipment_status of this ShipmentStatusDetails.  # noqa: E501
        :type: str
        """
        allowed_values = ["Created", "TransportationRequested", "CarrierAssigned", "Shipped"]  # noqa: E501
        if (self._configuration.client_side_validation and
                shipment_status not in allowed_values):
            raise ValueError(
                "Invalid value for `shipment_status` ({0}), must be one of {1}"  # noqa: E501
                .format(shipment_status, allowed_values)
            )

        self._shipment_status = shipment_status

    @property
    def shipment_status_date(self):
        """Gets the shipment_status_date of this ShipmentStatusDetails.  # noqa: E501

        Date and time on last status update received for the shipment  # noqa: E501

        :return: The shipment_status_date of this ShipmentStatusDetails.  # noqa: E501
        :rtype: datetime
        """
        return self._shipment_status_date

    @shipment_status_date.setter
    def shipment_status_date(self, shipment_status_date):
        """Sets the shipment_status_date of this ShipmentStatusDetails.

        Date and time on last status update received for the shipment  # noqa: E501

        :param shipment_status_date: The shipment_status_date of this ShipmentStatusDetails.  # noqa: E501
        :type: datetime
        """

        self._shipment_status_date = shipment_status_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ShipmentStatusDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ShipmentStatusDetails):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ShipmentStatusDetails):
            return True

        return self.to_dict() != other.to_dict()
