# coding: utf-8

"""
    Selling Partner API for Retail Procurement Shipments

    The Selling Partner API for Retail Procurement Shipments provides programmatic access to retail shipping data for vendors.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class TaxRegistrationDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'tax_registration_type': 'str',
        'tax_registration_number': 'str',
    }

    attribute_map = {
        'tax_registration_type': 'taxRegistrationType',
        'tax_registration_number': 'taxRegistrationNumber',
    }

    def __init__(self, tax_registration_type=None, tax_registration_number=None, _configuration=None):  # noqa: E501
        """TaxRegistrationDetails - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._tax_registration_type = None
        self._tax_registration_number = None
        self.discriminator = None

        self.tax_registration_type = tax_registration_type
        self.tax_registration_number = tax_registration_number

    @property
    def tax_registration_type(self):
        """Gets the tax_registration_type of this TaxRegistrationDetails.  # noqa: E501

        Tax registration type for the entity.  # noqa: E501

        :return: The tax_registration_type of this TaxRegistrationDetails.  # noqa: E501
        :rtype: str
        """
        return self._tax_registration_type

    @tax_registration_type.setter
    def tax_registration_type(self, tax_registration_type):
        """Sets the tax_registration_type of this TaxRegistrationDetails.

        Tax registration type for the entity.  # noqa: E501

        :param tax_registration_type: The tax_registration_type of this TaxRegistrationDetails.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and tax_registration_type is None:
            raise ValueError("Invalid value for `tax_registration_type`, must not be `None`")  # noqa: E501
        allowed_values = ["VAT", "GST"]  # noqa: E501
        if (self._configuration.client_side_validation and
                tax_registration_type not in allowed_values):
            raise ValueError(
                "Invalid value for `tax_registration_type` ({0}), must be one of {1}"  # noqa: E501
                .format(tax_registration_type, allowed_values)
            )

        self._tax_registration_type = tax_registration_type

    @property
    def tax_registration_number(self):
        """Gets the tax_registration_number of this TaxRegistrationDetails.  # noqa: E501

        Tax registration number for the entity. For example, VAT ID.  # noqa: E501

        :return: The tax_registration_number of this TaxRegistrationDetails.  # noqa: E501
        :rtype: str
        """
        return self._tax_registration_number

    @tax_registration_number.setter
    def tax_registration_number(self, tax_registration_number):
        """Sets the tax_registration_number of this TaxRegistrationDetails.

        Tax registration number for the entity. For example, VAT ID.  # noqa: E501

        :param tax_registration_number: The tax_registration_number of this TaxRegistrationDetails.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and tax_registration_number is None:
            raise ValueError("Invalid value for `tax_registration_number`, must not be `None`")  # noqa: E501

        self._tax_registration_number = tax_registration_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TaxRegistrationDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TaxRegistrationDetails):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TaxRegistrationDetails):
            return True

        return self.to_dict() != other.to_dict()
