# coding: utf-8

"""
    Selling Partner API for Retail Procurement Shipments

    The Selling Partner API for Retail Procurement Shipments provides programmatic access to retail shipping data for vendors.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import pprint
import re  # noqa: F401

import six

from spapi.configuration import Configuration


class VendorDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'selling_party': 'PartyIdentification',
        'vendor_shipment_identifier': 'str',
    }

    attribute_map = {
        'selling_party': 'sellingParty',
        'vendor_shipment_identifier': 'vendorShipmentIdentifier',
    }

    def __init__(self, selling_party=None, vendor_shipment_identifier=None, _configuration=None):  # noqa: E501
        """VendorDetails - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._selling_party = None
        self._vendor_shipment_identifier = None
        self.discriminator = None

        if selling_party is not None:
            self.selling_party = selling_party
        if vendor_shipment_identifier is not None:
            self.vendor_shipment_identifier = vendor_shipment_identifier

    @property
    def selling_party(self):
        """Gets the selling_party of this VendorDetails.  # noqa: E501


        :return: The selling_party of this VendorDetails.  # noqa: E501
        :rtype: PartyIdentification
        """
        return self._selling_party

    @selling_party.setter
    def selling_party(self, selling_party):
        """Sets the selling_party of this VendorDetails.


        :param selling_party: The selling_party of this VendorDetails.  # noqa: E501
        :type: PartyIdentification
        """

        self._selling_party = selling_party

    @property
    def vendor_shipment_identifier(self):
        """Gets the vendor_shipment_identifier of this VendorDetails.  # noqa: E501

        Unique vendor shipment id which is not used in last 365 days  # noqa: E501

        :return: The vendor_shipment_identifier of this VendorDetails.  # noqa: E501
        :rtype: str
        """
        return self._vendor_shipment_identifier

    @vendor_shipment_identifier.setter
    def vendor_shipment_identifier(self, vendor_shipment_identifier):
        """Sets the vendor_shipment_identifier of this VendorDetails.

        Unique vendor shipment id which is not used in last 365 days  # noqa: E501

        :param vendor_shipment_identifier: The vendor_shipment_identifier of this VendorDetails.  # noqa: E501
        :type: str
        """

        self._vendor_shipment_identifier = vendor_shipment_identifier

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VendorDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VendorDetails):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VendorDetails):
            return True

        return self.to_dict() != other.to_dict()
